 program Game;

uses graphics,crt,vars,bitmaps,fonts,SPX_TIM,mensys;
{$M $1000,400000,625320}
type
 bubarray=array[0..9,0..9] of byte;
const
bubbuf: bubarray = ((0,1,2,3,4,5,6,7,8,9),
                     (0,1,2,3,4,5,6,7,9,9),
                     (0,1,2,3,4,6,7,9,9,9),
                     (0,1,2,4,5,7,8,9,9,9),
                     (0,1,3,4,6,7,9,9,9,9),
                     (0,1,3,4,6,7,9,9,9,9),
                     (0,1,3,4,6,7,9,9,9,9),
                     (0,1,3,4,6,8,9,9,9,9),
                     (0,1,3,4,6,8,9,9,9,9),
                     (0,1,3,4,6,8,9,9,9,9));
var c1:byte;

Procedure LoadIndex;
 var
  filez:file of ItemIdArray;
 begin
  New(ItemIndex);

  Assign(filez,'Weapons.id');
  Reset(filez);
  read(filez,ItemIndex^.Weapons);
  close(filez);

  Assign(filez,'Spells.id');
  Reset(filez);
  read(filez,ItemIndex^.Spells);
  close(filez);

  Assign(filez,'Armor.id');
  Reset(filez);
  read(filez,ItemIndex^.Armor);
  close(filez);

  Assign(filez,'Items.id');
  Reset(filez);
  read(filez,ItemIndex^.Items);
  close(filez);

  Assign(filez,'Crystals.id');
  Reset(filez);
  read(filez,ItemIndex^.Crystals);
  close(filez);
 end;
Procedure KillIndex;
 begin
  Dispose(ItemIndex);
 end;

(******Key entry functions********)
Function PowerKey(d:char;zeroed:boolean):boolean;
 begin
   PowerKey:=false;
   If (d=#13) or (d=(' ')) then
   PowerKey:=true;
 end;
Function Up(d:char;zeroed:boolean):boolean;
 begin
   up:=false;
   If (d=('8')) or (Zeroed and (d=#72)) then
   up:=true;
 end;
Function Down(d:char;zeroed:boolean):boolean;
 begin
   Down:=false;
   If (d=('2')) or (Zeroed and (d=#80)) then
   Down:=true;
 end;
Function Left(d:char;zeroed:boolean):boolean;
 begin
   Left:=false;
   If (d=('4')) or (Zeroed and (d=#75)) then
   Left:=true;
 end;
Function Right(d:char;zeroed:boolean):boolean;
 begin
   Right:=false;
   If (d=('6')) or (Zeroed and (d=#77)) then
   Right:=true;
 end;
(******Key entry functions********)



Procedure SetUpPal;
 var
  c1,c2,c3:byte;
 begin
  for c1:=0 to 9 do
   asetrgbpalette(c1+64,c1*4+17,c1*4+17,c1*4+17);
  for c1:=0 to 9 do
   asetrgbpalette(c1+74,c1,c1*4+25,c1);
  for c1:=0 to 9 do
   asetrgbpalette(c1+84,c1,c1,c1*4+25);
  for c1:=0 to 9 do
   asetrgbpalette(c1+94,c1*3+30,c1*2+15,c1+7);
  for c1:=0 to 4 do
   asetrgbpalette(c1+104,c1*3+30,c1,c1);
  for c1:=0 to 1 do
   asetrgbpalette(c1+109,c1*3+7,c1*3+7,c1*3+10);
  for c1:=2 to 3 do
   asetrgbpalette(c1+109,c1*6+40,c1*6+40,63);
   asetrgbpalette(113,63,63,63);
  for c1:=0 to 2 do
   asetrgbpalette(c1+114,c1*6+15,c1*3+7,c1*2+2);
  for c1:=0 to 1 do
   asetrgbpalette(c1+117,23+c1*5,23+c1*5,35+c1*6);
  for c1:=0 to 4 do
   asetrgbpalette(c1+119,c1*5+35,c1*6+35,c1*2);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*5+35,c1*2,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*2,c1*5+35,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+129,c1*6+10,c1*3+4,c1*7+10);
  for c1:=0 to 4 do
   asetrgbpalette(c1+134,8+c1*3,4,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+139,4,8+c1*3,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+144,4,4,8+c1*3);
  for c1:=0 to 4 do
   asetrgbpalette(c1+149,c1*5+11,c1*5+15,c1*5+30);
  for c1:=0 to 4 do
   asetrgbpalette(c1+154,5+c1*2,5+c1*2,5+c1*2);{
  For c1:=0 to 9 do
   asetrgbpalette(c1+154,0,c1*2+10,c1*4+20);
  for c1:=0 to 4 do
   asetrgbpalette(c1+154,c1*10+20,c1*5+10,c1*2+5); }
  for c1:=0 to 4 do
   asetrgbpalette(c1+159,c1*3+15,c1*2+7,c1+2); {
   asetrgbpalette(188,63,63,63); }
  for c1:=0 to 4 do
   begin
    asetrgbpalette(c1+164,50-(c1*2),46-(c1*5),36-(c1*6));
   end;
 end;
Procedure Credits;
 var
  c1,c2,c3:byte;
  Temp:VirtScrPtr;
 begin
  FadeOut(20);
  ClearSCreen;
  PushScreen;
  DispFullBtmBuf('laura.Btm');
  New(Temp);
  Temp^:=TheSCreen^;
  For c1:=1 to 5 do
   asetRgbPalette(c1,63-c1*7,63-c1*7,63-c1*2);
  For c1:=1 to 5 do
   asetRgbPalette(c1+5,63-(c1*7),63-(c1*2),63-(c1*7));
  For c1:=1 to 5 do
   asetRgbPalette(c1+10,63-(c1*2),63-(c1*7),63-(c1*7));
  PushFadeIn(20);

  LoadFont1;
  c1:=0;
  While Not(Keypressed) do
   begin
    if c1<10 then
     begin
      c1:=c1+1;
      AsmPush(temp,TheScreen);{
      TheScreen^:=Temp^;       }
      OutTextXyRange1(50 ,5*c1,11,'Production-');
      OutTextXyRange1(60 ,6*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,7*c1,1,'Scott Farrell');
      OutTextXyRange1(60 ,8*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,6*c1,6,'Zaskoda');{
      OutTextXyRange1(200,7*c1,6,'Neuro-XTC');
      OutTextXyRange1(200,8*c1,6,'ICEMAN');  }

      OutTextXyRange1(50 ,10*c1,11,'Art-');
      OutTextXyRange1(60 ,11*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,12*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,11*c1,6,'Zaskoda');{
      OutTextXyRange1(200,12*c1,6,'IceMan');  }

      OutTextXyRange1(50 ,14*c1,11,'Code-');
      OutTextXyRange1(60 ,15*c1,1,'Scott Dudley');
      OutTextXyRange1(200,15*c1,6,'Zaskoda');
      PushScreen;
     end;
   end;

  While c1>0 do
   begin
     begin
      c1:=c1-1;
      AsmPush(temp,TheScreen);{
      TheScreen^:=Temp^;       }
      OutTextXyRange1(50 ,6*c1-10,11,'Production-');
      OutTextXyRange1(60 ,7*c1-10,1,'Scott Dudley');
      OutTextXyRange1(60 ,8*c1-10,1,'Scott Farrell');
      OutTextXyRange1(60 ,9*c1-10,1,'Klint Bower');
      OutTextXyRange1(200,7*c1-10,6,'Zaskoda');
      OutTextXyRange1(200,8*c1-10,6,'Neuro-XTC');
      OutTextXyRange1(200,9*c1-10,6,'ICEMAN');

      OutTextXyRange1(50 ,11*c1-10,11,'Art-');
      OutTextXyRange1(60 ,12*c1-10,1,'Scott Dudley');
      OutTextXyRange1(60 ,13*c1-10,1,'Klint Bower');
      OutTextXyRange1(200,12*c1-10,6,'Zaskoda');
      OutTextXyRange1(200,13*c1-10,6,'IceMan');

      OutTextXyRange1(50 ,15*c1-10,11,'Code-');
      OutTextXyRange1(60 ,16*c1-10,1,'Scott Dudley');
      OutTextXyRange1(200,16*c1-10,6,'Zaskoda');
      PushScreen;
     end;
   end;

  FadeOut(20);
  KillFont1;
  Dispose(Temp);
  While Keypressed do readkey;
 end;
Procedure PutBub(x,y:integer;bubtemp:VirtScrPtr);
 var
  c1,c2:integer;
 begin
  If (x>-1) and (x+19<320) and (y>-1) and (y+19<200) then
  for c1:=0 to 9 do
  for c2:=0 to 9 do
   begin
    putpixel(x+c1,y+c2,BubTemp^[(x+bubbuf[c2,c1])+(y+bubbuf[c1,c2])*320]);
    putpixel(x+(19-c1),y+c2,BubTemp^[(x+(19-bubbuf[c2,c1]))+(y+bubbuf[c1,c2])*320]);
    putpixel(x+c1,y+(19-c2),BubTemp^[(x+bubbuf[c2,c1])+(y+(19-bubbuf[c1,c2]))*320]);
    putpixel(x+(19-c1),y+(19-c2),BubTemp^[(x+(19-bubbuf[(c2),(c1)]))
    +(y+(19-bubbuf[(c1),(c2)]))*320]);
   end;
 end;
Procedure PutDrop(x,y:integer);
 begin
    {correction}
  If (x-1>-1) and (x-1<320) and (y-3>-1) and (y-3<200) then
    Mem[$a000:(x-1)+(y-3)*320]:=TheScreen^[(x-1)+(y-3)*320];
  If (x+1>-1) and (x+1<320) and (y-3>-1) and (y-3<200) then
    Mem[$a000:(x+1)+(y-3)*320]:=TheScreen^[(x+1)+(y-3)*320];
  If (x>-1) and (x<320) and (y-4>-1) and (y-4<200) then
    Mem[$a000:(x)+(y-4)*320]:=TheScreen^[(x)+(y-4)*320];
  If (x-2>-1) and (x-2<320) and (y-1>-1) and (y-1<200) then
     Mem[$a000:(x-2)+(y-1)*320]:=TheScreen^[(x-2)+(y-1)*320];
  If (x+2>-1) and (x+2<320) and (y-1>-1) and (y-1<200) then
     Mem[$a000:(x+2)+(y-1)*320]:=TheScreen^[(x+2)+(y-1)*320];
    {correction}
    {smear}
  If (x>-1) and (x<320) and (y-2>-1) and (y-2<200) then
     Mem[$a000:(x)+(y-2)*320]:=TheScreen^[(x)+(y-3)*320];
  If (x>-1) and (x<320) and (y-1>-1) and (y-1<200) then
     Mem[$a000:(x)+(y-1)*320]:=TheScreen^[(x)+(y)*320];
  If (x>-1) and (x<320) and (y>-1) and (y<200) then
     Mem[$a000:(x)+(y)*320]:=TheScreen^[(x)+(y+2)*320];
  If (x>-1) and (x<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x)+(y+1)*320]:=TheScreen^[(x)+(y+3)*320];
  If (x>-1) and (x<320) and (y+2>-1) and (y+2<200) then
     Mem[$a000:(x)+(y+2)*320]:=TheScreen^[(x)+(y+3)*320];
  If (x>-1) and (x<320) and (y+3>-1) and (y+3<200) then
     Mem[$a000:(x)+(y+3)*320]:=TheScreen^[(x)+(y+4)*320];
  If (x>-1) and (x<320) and (y+4>-1) and (y+4<200) then
     Mem[$a000:(x)+(y+4)*320]:=TheScreen^[(x)+(y+5)*320];
  If (x-1>-1) and (x-1<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x-1)+(y-1)*320]:=TheScreen^[(x-2)+(y-2)*320];
  If (x-1>-1) and (x-1<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x-1)+(y)*320]:=TheScreen^[(x-2)+(y)*320];
  If (x-1>-1) and (x-1<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x-1)+(y+1)*320]:=TheScreen^[(x-2)+(y+1)*320];
  If (x-1>-1) and (x-1<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x-1)+(y+2)*320]:=TheScreen^[(x-2)+(y+3)*320];
  If (x-2>-1) and (x-2<320) and (y+1>-1) and (y+1<200) then
     Mem[$a000:(x-2)+(y+1)*320]:=TheScreen^[(x-3)+(y+1)*320];
  If (x+1>-1) and (x+1<320) and (y-1>+1) and (y-1<200) then
     Mem[$a000:(x+1)+(y-1)*320]:=TheScreen^[(x+2)+(y-2)*320];
  If (x+1>-1) and (x+1<320) and (y>+1) and (y<200) then
     Mem[$a000:(x+1)+(y)*320]:=TheScreen^[(x+2)+(y)*320];
  If (x+1>-1) and (x+1<320) and (y+1>+1) and (y+1<200) then
     Mem[$a000:(x+1)+(y+1)*320]:=TheScreen^[(x+2)+(y+1)*320];
  If (x+1>-1) and (x+1<320) and (y+2>+1) and (y+2<200) then
     Mem[$a000:(x+1)+(y+2)*320]:=TheScreen^[(x+2)+(y+3)*320];
  If (x+2>-1) and (x+2<320) and (y+1>+1) and (y+1<200) then
     Mem[$a000:(x+2)+(y+1)*320]:=TheScreen^[(x+3)+(y+1)*320];
    {smear}

 end;
Procedure TitleScreen;
 var
  c1,c2:byte;
  temp:VirtScrPtr;
  pal:palettetype;
  Smearx:array[0..200] of integer;
  Smeary:array[0..200] of integer;
  sinsub:array[0..199] of byte;
 begin
  for c1:=0 to 200 do
   begin
    sinsub[c1]:=trunc(sin(c1/40)*32)+128;
   end;
  LoadFont4;
  ClearScreen;
  PushScreen;
  new(temp);
  DispFullBtmBuf('tal4.Btm');
  For c1:=1 to 7 do
     asetrgbpalette(c1,c1*1,c1*3,c1*4);
  For c1:=1 to 7 do
     asetrgbpalette(c1+7,c1*1+30,c1*3+40,c1*5+20);
  For c1:=1 to 7 do
     asetrgbpalette(c1+14,c1*3+40,c1*5+20,c1*1+30);
     FetchPal(pal);
  For c1:=1 to 255 do
     asetrgbpalette(c1,c1 div 4,c1 div 8,c1 div 16);
  PushFadeIn(20);
  Outtextxy3D4(50,13,1,1,8,1,1, '   Zaskoda Soft presents-');
  Outtextxy3D4(50,180,1,1,8,1,1,'Chapter 1: A Past Forgotten');
  Outtextxy3D4(50,190,1,1,15,1,1,'                            1995');
  temp^:=TheScreen^;
  Pushscreen;
  Fadeto(55,pal);
  While Keypressed do readkey;
  for c1:=0 to 100 do
   begin
    smearx[c1]:=random(320-64)+32;
    smeary[c1]:=random(2000)+2000;
   end;
  SetRate(1024);
  F_Clk[0]:=255;
  c2:=1;
  repeat
   if F_Clk[0]=0 then
   begin
   F_Clk[0]:=10;
   for c1:=0 to c2 do
    begin
     {if random<0.5 then }smeary[c1]:=smeary[c1]-random(c2 div 10+5);{
     Putdrop(smearx[c1],smeary[c1]);              }
     if smeary[c1]<0 then
      begin
       if c2<20 then c2:=c2+1;
       smearx[c1]:=random(320-64)+32;
       smeary[c1]:=2050;
      end;
     PutBub((smearx[c1]+sinsub[((smeary[c1] div 10)+c1+c2) mod 201])-128,
     smeary[c1] div 10,temp);
    end;
    pushscreen;
    asmpush(temp,thescreen);
    end;
  until keypressed;
  readkey;
  FadeOut(20);
  dispose(temp);

  ClearScreen;
  Pushscreen;
  KillFont4;
 end;
Procedure Startup;
 var
  c1,c2,c3:byte;
  Filez:File of SmallBtm;
  bklfile:file of smallbtm;
  mapfile:file of MapRec;
  dump:SmallBtm;
 begin
  FadeOut(20);
  assign(Filez,'temp.Spr');
  Reset(Filez);
  for c1:=0 to 3 do
  for c2:=0 to 3 do
  begin
  if c2<>3 then
   begin
    new(hero.bitmaps[c2+c1*4]);
    Read(Filez,Hero.BitMaps[c2+c1*4]^);
    Read(Filez,Hero.BitMaps[c2+c1*4]^);
   end
  else
   begin
    hero.bitmaps[c2+c1*4]:=(hero.bitmaps[(c2+c1*4)-2]);
    Read(Filez,Dump);
    Read(Filez,Dump);
   end;
  end;
  Close(Filez);     {
  for c1:=0 to 15 do
  for c2:=0 to 9 do
  for c3:=0 to 39 do
   begin
    hero.bitmaps[c1].Bitmap^[c3][c2]:=c2-c1;
    hero.bitmaps[c1].Bitmap^[c3][19-c2]:=c2-c1;
   end;              }
  new(OWM);
  assign(mapfile,'over.map');
  reset(mapfile);
  read(mapfile,owm^);
  close(mapfile);{
  for c1:=0 to 179 do
  for c2:=0 to 179 do
   owm^.back[c1,c2]:=1;

  for c1:=5 to 20 do
  for c2:=5 to 20 do
   owm^.back[c1,c2]:=0;
  for c1:=6 to 19 do
   begin
    owm^.back[c1,5]:=24;
    owm^.back[c1,20]:=26;
    owm^.back[5,c1]:=23;
    owm^.back[20,c1]:=25;
   end;
  for c1:=0 to 179 do
   begin
    owm^.back[c1,0]:=35;
    owm^.back[c1,179]:=35;
    owm^.back[0,c1]:=35;
    owm^.back[179,c1]:=35;
   end;
   owm^.back[5,5]:=32;
   owm^.back[5,20]:=31;
   owm^.back[20,5]:=33;
   owm^.back[20,20]:=34;
   owm^.back[7,10]:=100;
   owm^.back[70,10]:=101;}

  for c1:=0 to (Num_of_SmallBits-1) do
  begin
  new(Const_Game_Vars.SmallBitMaps[c1]);
  end;                  {
  for c1:=0 to 15 do
  begin
  new(MediumBitMaps[c1].BitMap);
  end;
  for c1:=0 to 15 do
  for c2:=0 to 15 do
  begin
  new(Sprites[c1][c2].BitMap);
  end;   } {
  for c3:=1 to 35 do
  for c1:=0 to 19 do
  for c2:=0 to 19 do
  begin
  SmallBitMaps[c3]^[c1][c2]:=c3;
  end;     }               {
  for c3:=1 to 35 do
  for c1:=1 to 18 do
  for c2:=1 to 18 do
  begin
  SmallBitMaps[c3]^[c1][0]:=c3+1;
  SmallBitMaps[c3]^[0][c1]:=c3+1;
  SmallBitMaps[c3]^[c1][19]:=c3-1;
  SmallBitMaps[c3]^[19][c1]:=c3-1;
  end;                     }

  assign(bklfile,'over160.set');
  reset(bklfile);                {
  read(bklfile,SmallBitMaps[1]^); }
  for c1:=0 to (Num_of_SmallBits-1) do
  read(bklfile,Const_Game_Vars.SmallBitMaps[c1]^);
  close(bklfile);



  LoadFont1;
  new(menuinfo);
 end;
Procedure Shutup;
 var
  c1,c2,c3:byte;
 begin
 {
  for c1:=0 to 15 do
  begin
  Dispose(hero.bitmaps[c1].Bitmap);
  end;      }
  for c1:=0 to 3 do
  for c2:=0 to 2 do
  begin
    dispose(hero.bitmaps[c2+c1*4]);
  end;
  Dispose(OWM);
  for c1:=0 to (Num_of_SmallBits-1) do
  begin
  Dispose(Const_Game_Vars.SmallBitMaps[c1]);
  end;    {
  for c1:=0 to 15 do
  begin
   Dispose(MediumBitMaps[c1].BitMap);
  end;
  for c1:=0 to 15 do
  for c2:=0 to 15 do
  begin
   Dispose(Sprites[c1][c2].BitMap);
  end;     }
  KillFont1;
  dispose(menuinfo);
 end;
Procedure Test;                 {sample overworld}
 vAR
  pal:palettetype;
  c1,c2,c3:integer;
  d:char;
  zeroed:boolean;
 begin
 ClearScreen;
 PushSCreen;
 for c1:=0 to 255 do
 asetrgbpalette(c1,0,0,0);
 for c1:=1 to 20 do
 asetrgbpalette(c1,c1*3+10,c1*2+5,c1);
 for c1:=0 to 3 do
 asetrgbpalette(c1+20,40-(c1*8),50-c1*7,60-(c1*8));
 SetUpPal;
 hero.x:=8;
 hero.y:=8;
 hero.offset:=0;
 hero.dir:=1;
 hero.frame:=1;

 DrawGrid;

 PushFadeIn(50);
 drawpanel(0);
 panelup;
 repeat
 {
 if d=('5') then hero.frame:=hero.frame+1;
 if hero.frame>15 then hero.frame:=0;       }

  if left(d,zeroed) then
   begin
    Hero.dir:=4;
  if owm^.back[Hero.X-1,Hero.Y]<72 then
   begin
    hero.x:=hero.x-1;
    hero.offset:=20;
   end;
   end;
  if right(d,zeroed) then
   begin
    Hero.dir:=2;
  if owm^.back[Hero.X+1,Hero.Y]<72 then
   begin
    hero.x:=hero.x+1;
    hero.offset:=20;
   end;
   end;
  if up(d,zeroed) then
   begin
    Hero.dir:=3;
  if owm^.back[Hero.X,Hero.Y-1]<72 then
   begin
    hero.offset:=20;
    hero.y:=hero.y-1;
   end;
   end;
  if down(d,zeroed) then
   begin
    Hero.dir:=1;
  if owm^.back[Hero.X,Hero.Y+1]<72 then
   begin
    hero.y:=hero.y+1;
    hero.offset:=20;
   end;
   end;
 If (hero.offset=0) then
  Hero.Frame:=((Hero.Dir-1)*4)+1
 else
  Hero.Frame:=(Hero.Dir-1)*4+(4-((Hero.OffSet+4) div 5));
 if hero.offset<>0 then hero.offset:=hero.offset-GlobOb.WalkRate;{
 if hero.offset=0 then hero.dir:=0 else hero.offset:=hero.offset-2; }
 DrawGrid;
 while f_clk[2]<>0 do sound(random(100)+1500);nosound;
 f_clk[2]:=10;
 waitscreen;
 pushscreen;
 d:=(' ');
 if hero.offset=0 then if keypressed then
  begin
   zeroed:=false;
   d:=readkey;
   if d=#0 then
    begin
     d:=readkey;
     zeroed:=true;
    end;
  end;
 if d=('=') then
  begin
    DrawPopTxtBk;
    PushScreen;
    readkey;
  end;
 if d=('*') then
  begin
   menuinfo^.title:='Main Menu';
   menuinfo^.choices[0]:='Move';
   menuinfo^.choices[1]:='Stock';
   menuinfo^.choices[2]:='Magic';
   menuinfo^.choices[3]:='Equipment';
   menuinfo^.choices[4]:='Status';
   menuinfo^.choices[5]:='Rod';
   menuinfo^.choices[6]:='Options';
   menuinfo^.choices[7]:='Files';
   menuinfo^.choices[8]:='Quit';
   menuinfo^.choices[9]:='end';
   c1:=Getchoice(0,0);
   if c1=8 then d:=#27;
   if c1=4 then
    begin
     Fadeout(20);
     DispFullBtmFull('statsamp.btm',50);
     SetUpPal;
     drawpanel(0);
     for c1:=1 to 20 do
     asetrgbpalette(c1,c1*3+10,c1*2+5,c1);
     pushfadein(20);
    end;

   panelclose;
   drawpanel(0);{
   dultext(0);
   dultext(1);
   dultext(2);
   dultext(3);
   dultext(4);
   dultext(5);
   dultext(6);
   hitext(2);
   OutTextXYChoise(234,10,0, 'Main Menu');
   OutTextXYChoise(237,40,0, '  Move');
   OutTextXyChoise(234,55,1, '  Stock');
   OutTextXyChoise(234,70,2, '  Magic');
   OutTextXyChoise(234,85,3, '  Equip');
   OutTextXyChoise(237,100,4,'  Stat');
   OutTextXyChoise(237,115,5,'  Rods');
   OutTextXyChoise(237,130,6,'  Opts');
   OutTextXyChoise(234,145,6,'  Files');
   OutTextXyChoise(234,160,6,'  Close');
   OutTextXyChoise(237,175,6,'  Quit');}
   panelup;
  end;                 {
 if hero.offset<>0 then }
 while keypressed do readkey;
 until d=#27;
 end;
Procedure MainMenu(var ConVar:byte);
 var
  c1:integer;
  cycle:byte;
  Pal:PaletteType;
  d:char;
  Chosen,Zeroed:boolean;
 begin
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('icebk.Btm');            {BackGround}


  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,10+c1,10+c1,10+c1*2);
  for c1:=0 to 4 do
   asetrgbpalette(c1+105,(c1*2+5),(c1*2+5),(c1*3+10));
  for c1:=0 to 10 do
   asetrgbpalette(c1+110,(c1*1+20),(c1*1+20),(c1*2+30));
     DulText(0);
     DulText(1);
     DulText(2);
     HiText(ConVar);


   LoadFont2;                              {Actual Texts}
   OutTextXyBW2(79,9,108,'Main  Menu');
   OutTextXyBW2(81,9,106,'Main  Menu');
   OutTextXyBW2(79,11,107,'Main  Menu');
   OutTextXyBW2(81,11,105,'Main  Menu');
   OutTextXydep2(80,10,110,'Main  Menu');
   KillFont2;
   LoadFont1;
   OutTextXYChoise(120,70,0,'Enter Game');
   OutTextXYChoise(124,90,1,' Credits');
   OutTextXYChoise(120,110,2,'   Quit');  {
   OutTextXy3d1(120,70,6,5,10,2,1,  'Enter Game');
   OutTextXy3d1(124,90,6,5,13,2,1,  ' Credits');
   OutTextXy3d1(120,110,6,5,16,2,1, '   Quit');}
   KillFont1;
  FetchPal(Pal);           {Get PAllette for loop}
  PushFadeIn(10);          {Quickly Bring up menu}
  While Keypressed do readkey;

  cycle:=0;      {For color cycle}
  setrate(1024);
  f_clk[0] := 40;
  Chosen:=false;
  repeat
  Chosen:=False;
   if f_Clk[0]=0 then
    begin
     f_clk[0] := 40;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;
   d:=('-');
   If Keypressed then d:=ReadKey;
   If d=#0 then
    begin
     Zeroed:=True;
     D:=Readkey;
    end;                                    {
   If (d=('8')) or (Zeroed and (d=#72)) then }
   if up(d,zeroed) then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=2 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     HiText(ConVar);
    end;                                    {
   If (d=('2')) or (Zeroed and (d=#80)) then }   {If more than 5 options}
   If Down(d,zeroed) then
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=2 then ConVar:=0 else
     ConVar:=ConVar+1;
     HiText(ConVar);
    end;
   If Powerkey(d,zeroed) then Chosen:=True;
   If d=#27 then
    begin
     ConVar:=2;
     Chosen:=True;
    end;
  until Chosen;
  FadeOut(10);
 end;

Procedure Story(Wich:Byte);
 var
  c2:byte;
  Words:STBPtr;
  filez:file of Pop_Text_background;
  temp:^Pop_Text_line;
 begin
  new(Const_Game_Vars.popback);
  assign(filez,'POPTXTBK.GRD');
  reset(filez);
  read(filez,Const_Game_Vars.popback^);
  close(filez);

  New(Words);
  Words^[0]:=('  I have never seen her but her face  ');
  Words^[1]:=('is clear in my dreams every night.    ');
  Words^[2]:=('Something cries out inside of me to   ');
  Words^[3]:=('find her. I know she needs me. But I  ');
  Words^[4]:=('know not even who she is.             ');
  FadeOut(10);
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('laura.btm');{
  HalfPal;
  BrownPal;                   }{
   for c2:=59 downto 0 do
    begin
     temp:=addr(thescreen^[(5)+(c2+140)*320]);
     temp^:=popback^[c2];
    end;                        }
  For c1:=1 to 9 do
   asetrgbpalette(c1,c1*4+20,c1*2+10,c1);
  For c1:=1 to 4 do
   asetrgbpalette(c1+9,0,c1*4+30,c1*5+40);
  PushFadeIn(50);


  (*If thens for wich screens to push*)

  (*If thens for wich text to push*)

  LoadFont1;
  PopText(Words,10);
  readkey;  {


  Words^[0]:=('     The dragons seemed to be driven  ');
  Words^[1]:=('by some force not of their own. There ');
  Words^[2]:=('attacks were well planned and always  ');
  Words^[3]:=('effective. Striking the humans were it');
  Words^[4]:=('did the most damage.                  ');
  FadeOut(50);
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('reddrag.btm');
  BWPal;
  For c1:=1 to 4 do
   asetrgbpalette(c1,0,c1*4+30,c1*5+40);
  PushFadeIn(50);


  (*If thens for wich screens to push*)

  (*If thens for wich text to push*)

  PopText(Words,1);
  DispGrdBuf('reddrag.btm');
  Words^[0]:=('     As war raged on, the dragons were');
  Words^[1]:=('slowly disposed of.                   ');
  Words^[2]:=('                                      ');
  Words^[3]:=('                                      ');
  Words^[4]:=('         Years passed on..            ');
  ReadKey;
  PopText(Words,1);
  ReadKey;         }

  FadeOut(50);
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('LS2.Btm');{
  BrownPal;                  }
  For c1:=1 to 4 do
   asetrgbpalette(c1,0,c1*4+30,c1*5+40);
  PushFadeIn(50);

  Words^[0]:=('                                      ');
  Words^[1]:=('     Now the dragons are gone. The    ');
  Words^[2]:=('only mention of them in is legends and');
  Words^[3]:=('fairy tales.                          ');
  Words^[4]:=('                                      ');
  PopText(Words,1);
  KillFont1;
  readkey;
  dispose(Const_Game_Vars.popback);
 end;
Procedure GameSelect(var Wich:byte;New:boolean);
 var
  convar:byte;
  cycle:byte;
  Pal:PaletteType;
  d:char;
  Chosen,Zeroed:boolean;
 begin
  convar:=4;
  if not(new) then convar:=5;
  ClearScreen;
  PushScreen;                {
  DispFullBtmBuf('grid.Btm'); }
  DispFullBtmBuf('WrpBk2.Btm');            {BackGround}
  PopLoadBacks;


  For c1:=0 to 19 do                     {LGB colors}
   AsetRgbPalette(c1+34,c1*3,c1*2,c1*1);
  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,10+c1,10+c1,10+c1*2);
  for c1:=0 to 10 do
   asetrgbpalette(c1+110,c1*2+30,0,0);
     DulText(0);
     DulText(1);
     dulText(2);
     dulText(3);
     DulText(4);
     DulText(5);
     HiText(convar);

                            {
   LoadFont2;                }             {Actual Texts}{
   OutTextXyBW2(119,164,22,'N E W');
   OutTextXyBW2(121,164,22,'N E W');
   OutTextXyBW2(119,166,23,'N E W');
   OutTextXyBW2(121,166,24,'N E W');
   outtextxynorm2(120,165,110,'N E W');
   KillFont2;                                             }
   LoadFont1;
   OutTextXyChoise(80,9,0, 'Zaskoda    time 20:21');
   OutTextXyChoise(80,22,0, 'Level 12      Talibah');
   OutTextXyChoise(140,55,1, 'Game 2');
   OutTextXyChoise(140,95,2, 'Game 3');
   OutTextXyChoise(140,135,3,'Game 4');
  if new then
  begin
   OutTextXyChoise(107,165,4,'Start NEW Game');
   OutTextXyChoise(127,185,5,'Exit Menu');
  end
   else
   OutTextXyChoise(127,175,5,'Exit Menu');
   KillFont1;



  FetchPal(Pal);           {Get PAllette for loop}
  PushFadeIn(10);          {Quickly Bring up menu}
  While Keypressed do readkey;

  cycle:=0;      {For color cycle}
  setrate(1024);
  f_clk[0] := 40;
  Chosen:=false;
  repeat
  Chosen:=False;

   if f_Clk[0]=0 then
    begin
     f_clk[0] := 40;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;

   d:=('-');
   If Keypressed then d:=ReadKey;
   If d=#0 then
    begin
     Zeroed:=True;
     D:=Readkey;
    end;

   If Up(d,zeroed) then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=5 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     if (not(new)) and (ConVar=4) then ConVar:=3;
     HiText(ConVar);
    end;
   If Down(d,zeroed) then                       {If more than 5 options}
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=5 then ConVar:=0 else
     ConVar:=ConVar+1;
     if (not(new)) and (ConVar=4) then ConVar:=5;
     HiText(ConVar);
    end;
   If Powerkey(d,zeroed) then Chosen:=True;
   If d=#27 then
    begin
     ConVar:=5;
     Chosen:=True;
    end;
  until Chosen;
  FadeOut(10);
  Wich:=Convar;                                 {
  if convar=5 then play :=false else play:=true; }
 end;


(******Loading/Unloading********)
Procedure LoadGameConst;
 begin
  LoadOverlay;
  LoadPopTxtBk;
  LoadIndex;
  {fonts}
  {overlays}
  {pop text stuff}
 end;
Procedure KillGameConst;
 begin
  KillOverlay;
  KillPopTxtBk;
  KillIndex;
 end;
Procedure LoadGame(Play:byte);
 begin
  {init pointers}
  {loadgame}
 end;
Procedure KillGame(Play:byte);
 begin
  {check for save}
  {kill game pointers}
 end;
(******Loading/Unloading********)


(******Gaming Loops********)
Procedure FightLoop;
 begin
  {fadeout}
  {evaluate monsters}
  {load fight graphics}
  {begin loop}
    {get party choices}
    {setup enemy choices}
    {enter battle}
      {beginloop}
      {endloop}
    {evaluate winner}
  {end loop}
  {kill fight graphics}
 end;
Procedure MoveLoop;
 begin
  {put up those menus}
  {begin loop}
   {check for key entry}
   {if movenment then set offset and direction}
   {if enter then exit}
   {if space then talk/open}
   {if one away from offset=0 then random}
     {killmapstuff/fightloop/loadmapstuff/dec(offset)/repaintscreen}
   {decrement offset}
   {update graphics}
   {clearkey}
  {end loop}
 end;
Procedure GameLoop;
 begin
  {load map}{load sprite}{always save in map mode}
  {draw the screen}
  {open main menu}
  {fadein}
  {start loop}
   {check key entry}
   {if move then moveloop}
   {if stock then stockmenu}
   {if magic then magicmenu}
   {if equip then equipmenu}
   {if status then status menu}
   {if rods then rodmenu}
   {if options then opsmenu}
   {if files then}
    {if load then load(which game)}
    {if save then save(which game)}
   {if quit then quit:=true}
  {end loop}
 end;
Procedure RunGame;
 var
  play:Byte;
 begin
  GameSelect(play,true);
  if play<>5 then
   begin
    {If new then open story/load defaults}
    LoadGame(play); {nul}
    LoadGameConst;  {nul}
    {del}STARTUP;
    {del}test;
    {del}Shutup;
    GameLoop;       {nul}
    KillGameConst;{nul}
    KillGame(play); {nul}
   end;
 end;
(******Gaming Loops********)
Procedure OverAll;
 var
  ConVar:byte;
 begin
  ConVar:=0;
  TitleScreen;
  repeat
   MainMenu(ConVar);
   If ConVar=0 then RunGame;
   If ConVar=1 then credits;
  until ConVar=2;
 end;
begin

 GlobOb.WalkRAte:=1;
 GlobOb.TalkRAte:=40;
     setvideomode($13);

     OverAll;
     setvideomode($3);
  setrate(18);
  clrscr;
  Writeln('That was fun!');

end.