Unit Vars;

Interface


Type
 CommonString=String[8];
 ItemID=Record
   Name:CommonString;
   Strength:byte;
   Special:byte;
  end;
 ItemIdArray=Array[0..255] of ItemId;
 Index_of_Items=Record
   Weapons:ItemIdArray;
   Spells:ItemIdArray;
   Armor:ItemIdArray;
   Items:ItemIdArray;
   Crystals:ItemIdArray;
  end;
 Record_Of_Save_Stuff=Record
   Base_Char:byte;
   Exp:byte;
   Armor:Byte;
   Helmet:Byte;
   Weapon:Byte;
  end;
 GlobalOptionStuff=Record   {four of these in the end}
   TalkRate:Byte;
   WalkRate:byte;
  end;

 BackGroundLine=array[0..179] of byte;
 BackGroundBitMap=Array[0..159] of backgroundLine;
 OLT1=array[0..219] of byte;   {overlay stuff on main part of game}
 OLT2=array[0..19] of byte;
 OLT3=array[0..99] of byte;

 OverLayType=record
  top:array[0..19] of OLT1;
  bot:array[0..19] of OLT1;
  left:array[20..179] of OLT2;
  right:array[20..179] of OLT2;
  panel:array[0..199] of OLT3;
  end;

 LoadGridBackLine=array[0..219] of byte;  {Backs in load game part}
 LoadGridBack=array[0..29] of LoadGridBackLine;
 LGBPtr=^LoadGridBack;

 Pop_Text_Line=Array[0..309] of byte;              {back for Pop Texts}
 Pop_Text_background=array[0..59] of Pop_Text_Line;


 FullScreenBtm=Array[0..64000] of byte;
 palettetype=array[0..255] of record
   r,g,b:byte;
  end;

 BtmRec=Record
    Pal:PAlettetype;
    Screen:FullScreenBtm;
   end;

 HorizBtmArray=array[0..19] of byte;  {For Sprites}
 FastHorizBtmArray=array[0..9] of word;  {For Sprites}

 FastHBASmallPoint=^FastHorizBtmArray;
 HBASmallPoint=^HorizBtmArray;
 SmallBtm=array[0..19] of HorizBtmArray;
 FastSmallBtm=array[0..19] of FastHorizBtmArray;{
 SmallBtmRec=record
   BitMap:SmallBtm;
   BitTest:Array[0..19] of byte;
  end;                                           }
 SmallBlock=^SmallBtm;
 FastSmallBlock=^FastSmallBtm;
 MediumBtm=array[0..39] of HorizBtmArray;
 MediumBtmRec=record
   BitMap:^MediumBtm;
   BitTest:Array[0..19] of byte;
  end;                                   {
 MediumBlock=^SmallBtmRec;                }


 HeroSpriteRec=record      {needs work}
  dir:byte;
  x,y:byte;
  OffSet:byte;
  Frame:byte;
  BitMaps:Array[0..15] of SmallBlock;
 end;
 SpriteRec=array[0..15{16 frames}] of SmallBlock;
                                               {
 MapTypeOverWorld=Array[0..249,0..249] of byte;
 MapTypeTown=Array [0..31,0..31] of byte;       }
 booboo=array[0..179,0..179] of byte;
 MapRec=record
  back:booboo;
  forth:booboo;
  NPCMAPData:array[0..127] of byte;
  TreasureData:array[0..31] of byte;
 end;
 {to be added to maprec}

Const
 Num_of_SmallBits=255;

Var
 ItemIndex:^Index_of_Items;
 Const_Game_Vars:record
   OverLay:^OverLAyType;
   PopBack:^Pop_Text_background;
   SmallBitMaps:array[0..(Num_of_SmallBits-1)] of SmallBlock;   {map stuff}
  end;
 Individual_Vars:record
  end;
 CurrentBG:^BackGroundBitMap;
 OWM:^MapRec;
 GlobOb:GlobalOptionStuff;

 MediumBitMaps:array[0..15] of MediumBtmRec; {Like trees}
 Sprites:Array[0..15{# of sprites}] of SpriteRec;       {Characters}
 Hero:HeroSpriteRec;                   {Hero}

Implementation

begin

end.