{This unit basically has functions and overlays
 dealing specifically with blitting bitmaps from
 one place to another}
{$B-}
{$G+}
unit bitmaps;
interface
uses Graphics,Vars,spx_tim,multkeys;  {this unit uses fast clock number 3!}

Procedure LoadOverLay;
Procedure KillOverLay;
Procedure DrawOverLay;
Procedure PanelUp_instant;
Procedure DrawPanelDirect(y:byte); {panel is right side of overlay}
Procedure DrawPanel(y:byte);
Procedure PanelClose;
Procedure PanelUp;

Procedure LoadPopTxtBk;
Procedure KillPopTxtBk;
Procedure DrawPopTxtBk;

Procedure DrawGridfs;
Procedure DrawSmallMap;

Procedure PopLoadBacks;{ this loads, draws, then unloads }
procedure PutSmallTranBitFastHalffs(x, y: word; trans,cutter : byte; where : SmallBlock);
Procedure PutSmallBitfasterfs(x,y:word; Where: SmallBtm);
procedure PutSmallTranBitFastfs(x, y : word; trans : byte; where : SmallBlock);
procedure PutSmallTranBitFastHalf(x, y: word; trans,cutter : byte; where : SmallBlock);
Procedure PutSmallBitfaster(x,y:word; Where: SmallBtm);
procedure PutSmallTranBitFast(x, y : word; trans : byte; where : SmallBlock);
procedure PutSmallBitOutLine (x,y:word;col:byte;where:SmallBlock);
procedure PutSmallBit3Dedge (x,y:word;mid:byte;where:SmallBlock);
{ Procedure PutMediumBit(X,Y:byte); }
Procedure DispGrdBuf(What:String);
Procedure DispFullBtmBuf(What:String);
Procedure DispFullBtmFull(What:String;Speed:byte);
Procedure KillEffectSprite;
Procedure LoadEffectSprite;
Procedure InitRain;
Procedure CloseRain;{
Procedure InitFog;
Procedure CloseFog;}
Procedure StatLine(x,y:word;val,max,col1,col2:byte);
Procedure DrawGridFS_nosprites;
Procedure DrawPartyGuys(c1,c2,c3:byte);

var
 RainOn,FogOn:Boolean;
implementation
const
 Num_Of_Drops=35;
type
 Rain_Drop=Record
      x,y:byte;
      frame:byte;
     end;
 Rain_Drops=Array[0..Num_Of_Drops] of Rain_Drop;
var
 Rain:^Rain_Drops;
 Drops:spriteframes;
 EffectSprite:spriteframes;

 {$I-}

Procedure LoadEffectSprite;
 begin
  LoadSprite(EffectSprite,EffectSpr_Loc);
 end;
Procedure KillEffectSprite;
 begin
  KillSprite(EffectSprite);
 end;
Procedure StatLine(x,y:word;val,max,col1,col2:byte);
 var
  c1:byte;
 begin
  if val>0 then
  For c1:=0 to val do
   begin
    TheScreen^[x+y*320+c1]:=col1;
   end;
  If Val<max then
  For c1:=val to max do
   begin
    TheScreen^[x+y*320+c1]:=col2;
   end;
 end;


Procedure DrawSmallMap;
 var c2,c3:byte;
 begin
  for c2:=0 to 79 do
  for c3:=0 to 79 do
   putpixel(230+(c2),10+(c3),TileLUT^[OWM^.back[GlobalStats^.c1x-39+c2,GlobalStats^.c1y-39+c3]]);
  putpixel(230+39,10+39,random(256));
 end;

Procedure LoadRainBits;
 var
  Filez:File of SmallBtm;
  c1:byte;
 begin
  LoadSprite(Drops,Drops_Loc);
  RainOn:=true;
 end;
Procedure InitRain;
 var c1:byte;
 begin
  LoadRainBits;
  if rain=nil then
  New(rain);
  for c1:=0 to Num_of_Drops do
   begin
    Rain^[c1].x:=random(200)+20;
    Rain^[c1].y:=random(200)+10+11;
    Rain^[c1].frame:=random(23);
   end;
 end;
Procedure UpDateRain;
 var c1:byte;
 begin
  For c1:=0 to Num_Of_Drops do
   begin
    If Rain^[c1].frame>0 then
      begin
       dec(rain^[c1].frame);
       inc(rain^[c1].x);
      end
     else
       begin
         Rain^[c1].x:=random(210)+10;
         Rain^[c1].y:=random(190)+23;
         Rain^[c1].frame:=random(5)+18;
       end;
      PutSmallTranBitFastfs(Rain^[c1].x,rain^[c1].y-(Rain^[c1].frame),0,Drops[Rain^[c1].frame shr 2]);
   end;
 end;
Procedure CloseRain;
 var
 c1:byte;
 begin
  rainon:=false;
  dispose(Rain);
  rain:=nil;
  killsprite(drops);
 end;
Procedure PopLoadBacks;
 var
  LGB:LGBPtr;
  Temp:^LoadGridBackLine;
  c1,c2:Integer;
  Filez:File of LoadGridBack;
 begin
  new(LGB);
  assign(Filez,'LGB.GRD');
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Lgb^);
    for c2:=0 to 3 do
    for c1:=0 to 29 do
     begin
      Temp:=Addr(TheScreen^[50+(c1+5+(c2*40))*320]);
      Temp^:=LGB^[c1];
     end;
   end;
  Dispose(LGB);
  LGB:=Nil;
 end;
Procedure DispGrdBuf(What:String);
 var
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    TheScreen^:=Temp^.Screen;
   end;
  Dispose(Temp);
  temp:=nil;
 end;
Procedure DispFullBtmBuf(What:String);
 var
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    TheScreen^:=Temp^.Screen;
    for c1:=0 to 255 do
    ASetRgbPAlette(c1,Temp^.Pal[c1].R,Temp^.Pal[c1].g,Temp^.Pal[c1].b);
   end
  else
   begin
    writeln(DebugFile,'Error opening '+What);
   end;
  Dispose(Temp);
  temp:=nil;
 end;
Procedure DispFullBtmFull(What:String;Speed:byte);
 var
  p:pointer;
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    for c1:=0 to 255 do
      asetrgbpalette(c1,0,0,0);
    TheRealScreen^:=Temp^.Screen;
    FadeIn(Speed,Temp^.Pal);
     while (somethingdown) do;
     while not(somethingdown) do;
     while (somethingdown) do;
     FadeOut(Speed);
   end;
  Dispose(Temp);
  temp:=nil;
 end;
Procedure LoadPopTxtBk;
 var
  filez:file of Pop_Text_background;
 begin
  New(PopBack);
  Assign(Filez,'PopTxtBk.Grd');
  reset(Filez);
  if IOResult=0 then
   begin
    read(Filez,PopBack^);
    close(Filez);
   end;
 end;
Procedure KillPopTxtBk;
 begin
  Dispose(PopBack);
  PopBack:=Nil;
 end;
Procedure LoadOverLay;
 var
  filez:file of OverLayType;
 begin
  if overlay=nil then New(OverLay);
  Assign(Filez,GlobalStats^.OLTName+'.OLT');
  reset(Filez);
   if IOResult=0 then
    begin
    read(Filez,OverLay^);
    close(Filez);
   if IOResult<>0 then
    begin
     Write(debugfile,'Error reading '+GlobalStats^.OLTName+'.OLT');
    end;
    end
   else
    begin
     Write(debugfile,'Error opening '+GlobalStats^.OLTName+'.OLT');
    end;

 end;
Procedure KillOverLay;
 begin
  Dispose(OverLay);
  Overlay:=Nil;
 end;

Procedure DrawPartyGuys(c1,c2,c3:byte);
 var
  temp1,temp2:byte;
 begin
  if GlobalStats^.c1alive then
     begin
        temp1:=trunc((GlobalStats^.c1hp/GlobalStats^.c1mhp)*18);
        StatLine(81,120,temp1,18,78,108);
        StatLine(81,121,temp1,18,74,104);
        if GlobalStats^.c1mmp<>0 then
         begin
          temp1:=trunc((GlobalStats^.c1mp/GlobalStats^.c1mmp)*18);
          StatLine(81,122,temp1,18,88 ,108);
          StatLine(81,123,temp1,18,84,104);
         end;
        PutSmallBitOutLine(80,100,c1,c1bitmaps[1]);
        PutSmallTranBitFast(80,100,0,c1bitmaps[1]);
     end;
  if GlobalStats^.c2alive then
     begin
        temp1:=trunc((GlobalStats^.c2hp/GlobalStats^.c2mhp)*18);
        StatLine(101,120,temp1,18,78,108);
        StatLine(101,121,temp1,18,74,104);
        if GlobalStats^.c2mmp<>0 then
         begin
          temp1:=trunc((GlobalStats^.c2mp/GlobalStats^.c2mmp)*18);
          StatLine(101,122,temp1,18,88,108);
          StatLine(101,123,temp1,18,84,104);
         end;
        PutSmallBitOutLine(100,100,c2,c2bitmaps[1]);
        PutSmallTranBitFast(100,100,0,c2bitmaps[1]);
     end;
  if GlobalStats^.c3alive then
     begin
        temp1:=trunc((GlobalStats^.c3hp/GlobalStats^.c3mhp)*18);
        StatLine(121,120,temp1,18,78,108);
        StatLine(121,121,temp1,18,74,104);
        if GlobalStats^.c3mmp<>0 then
         begin
          temp1:=trunc((GlobalStats^.c3mp/GlobalStats^.c3mmp)*18);
          StatLine(121,122,temp1,18,88,108);
          StatLine(121,123,temp1,18,84,104);
         end;
        PutSmallBitOutLine(120,100,c3,c3bitmaps[1]);
        PutSmallTranBitFast(120,100,0,c3bitmaps[1]);
     end;
 end;


Procedure DrawGridFS;
 var
  c1,c2,c3:integer;

  p1:^OLT1;
  p2:^OLT2;
  firstX,firstY:integer{byte};
  startX,StartY:integer{byte};
  lastx,lasty:byte;

 Function FinalX(x{,y},offset,dir:byte):integer;
 begin
   if dir=1 then finalX:=StartX+(X-FirstX)*20
    else if dir=2 then finalX:=StartX+(X-FirstX)*20-(offset{ div 10})
    else if dir=3 then finalX:=StartX+(X-FirstX)*20
    else if dir=4 then finalX:=StartX+(X-FirstX)*20+(offset{ div 10});
  end;
 Function FinalY({x,}y,offset,height,dir:byte):integer;
 begin
   if dir=1 then  finalY:=StartY+(Y-FirstY)*20-(offset{ div 1})-height
    else if dir=2 then  finalY:=StartY+(Y-FirstY)*20-height
    else if dir=3 then  finalY:=StartY+(Y-FirstY)*20+(offset{ div 10})-height
    else if dir=4 then  finalY:=StartY+(Y-FirstY)*20-height;
  end;
 Procedure PutSprite(x,y,offset,height,dir:byte;where:smallblock);
 var
  Fx,Fy:integer;
 begin
  if (abs(x-GlobalStats^.c1x)<8) and (abs(y-GlobalStats^.c1y)<8) then
  begin
   Fx:=FinalX(x,offset,dir);
   Fy:=FinalY(y,offset,height,dir);
   if (Fx>0) and (Fy>0) and (Fx<240) and (Fy<220) then
   PutSmallTranBitFastFS(FX,FY,0,where);
  end;
 end;
Procedure PutPartySprites;
 var {c1x,}c2x,c3x,c1y,c2y,c3y:integer; {need to be int for full screen}
 const c1x=120;
 begin{
   C1X:=120;}
   C1Y:=120-GlobalStats^.c1height;
 if GlobalStats^.c2alive then
   begin
     C2X:=FinalX(GlobalStats^.c2X,GlobalStats^.c2offset,GlobalStats^.c2dir);
     C2Y:=FinalY(GlobalStats^.c2Y,GlobalStats^.c2offset,GlobalStats^.c2height,GlobalStats^.c2dir);
     if not((c2x>0) and (c2x<200) and (c2y>0) and (c2y<180)) then begin c2x:=0; c2y:=0; end;
   end;
 if GlobalStats^.c3alive then
   begin
     C3X:=FinalX(GlobalStats^.c3X,GlobalStats^.c3offset,GlobalStats^.c3dir);
     C3Y:=FinalY(GlobalStats^.c3Y,GlobalStats^.c3offset,GlobalStats^.c3height,GlobalStats^.c3dir);
     if not((c3x>0) and (c3x<200) and (c3y>0) and (c3y<180)) then begin c3x:=0; c3y:=0; end;
   end;

   If c2y>c1y then
    begin
       if c3y>c2y then
         begin
           if GlobalStats^.c1alive then
            PutSmallTranBitFastHalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
           if GlobalStats^.c2alive then
            PutSmallTranBitFasthalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
           if GlobalStats^.c3alive then
            PutSmallTranBitFasthalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
         end
       else if c3y>c1y then
         begin
           if GlobalStats^.c1alive then
            PutSmallTranBitFasthalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
           if GlobalStats^.c3alive then
            PutSmallTranBitFasthalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
           if GlobalStats^.c2alive then
            PutSmallTranBitFasthalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
         end
       else
         begin
           if GlobalStats^.c3alive then
            PutSmallTranBitFasthalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
           if GlobalStats^.c1alive then
            PutSmallTranBitFasthalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
           if GlobalStats^.c2alive then
            PutSmallTranBitFasthalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
         end;
     end
    else {c1y>=c2y}
     begin
       if c3y>c1y then
         begin
           if GlobalStats^.c2alive then
            PutSmallTranBitFasthalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
           if GlobalStats^.c1alive then
            PutSmallTranBitFasthalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
           if GlobalStats^.c3alive then
            PutSmallTranBitFasthalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
         end
       else if c3y>c2y then
         begin
           if GlobalStats^.c2alive then
            PutSmallTranBitFasthalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
           if GlobalStats^.c3alive then
            PutSmallTranBitFasthalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
           if GlobalStats^.c1alive then
            PutSmallTranBitFasthalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
         end
       else
         begin
           if GlobalStats^.c3alive then
            PutSmallTranBitFastHalffs(c3x,c3y,0,GlobalStats^.c3cut,c3bitmaps[GlobalStats^.c3frame]);
           if GlobalStats^.c2alive then
            PutSmallTranBitFastHalffs(c2x,c2y,0,GlobalStats^.c2cut,c2bitmaps[GlobalStats^.c2frame]);
           if GlobalStats^.c1alive then
            PutSmallTranBitFastHalffs(c1x,c1y,0,GlobalStats^.c1cut,c1bitmaps[GlobalStats^.c1frame]);
         end
     end;
   {special effect thingy}
   if GlobalStats^.c1alive then
   if GlobalStats^.c1effect>0 then
        PutSmallTranBitFastfs(c1x,c1y,0,EffectSprite[GlobalStats^.c1effect shr 2]);

   if GlobalStats^.c2alive then
   if GlobalStats^.c2effect>0 then
        PutSmallTranBitFastfs(c2x,c2y,0,EffectSprite[GlobalStats^.c2effect shr 2]);

   if GlobalStats^.c3alive then
   if GlobalStats^.c3effect>0 then
        PutSmallTranBitFastfs(c3x,c3y,0,EffectSprite[GlobalStats^.c3effect shr 2]);
   {end special effect thingy}
 end;

 begin

  if GlobalStats^.c1offset=0 then
    begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20;
      LastX:=10;
      LastY:=9;
    end
  else
   begin
    if GlobalStats^.c1dir=1 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-6;
      StartX:=20;
      StartY:=GlobalStats^.c1offset{ div 10};
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=2 then
     begin
      FirstX:=GlobalStats^.c1X-6;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=GlobalStats^.c1offset{ div 10};
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
    if GlobalStats^.c1dir=3 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20-GlobalStats^.c1offset{ div 10};
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=4 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20-GlobalStats^.c1offset{ div 10};
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
     end;


    for c1:=0 to LastX do
    for c2:=0 to LastY do
     begin
      PutSmallBitFasterfs(c1*20+StartX,c2*20+startY,MapTiles[OWM^.back[c1+firstX,c2+firstY]]^);
      if (OWM^.forth[c1+firstX,c2+firstY]>227) and (OWM^.forth[c1+firstX,c2+firstY]<244) then
      {hidden or not}
      if OWM^.treasuredata[OWM^.forth[c1+firstX,c2+firstY]-228]=0 then
       begin
        {open or closed}
        if (GlobalStats^.Treasure_Taken[GlobalStats^.map-127][OWM^.forth[c1+firstX,c2+firstY]-228]) then
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Open])
        else
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Closed])
       end;
         {
      PutSprite(c1+firstx,c2+firsty,Boxes[c3]^.offset,0,Boxes[c3]^.dir,ObjBitMaps[Obj_Box]);}
     end;



  {sprites}
  for c1:=-1 to 13 do
  for c2:=-1 to 5 do
   begin
     {boxes}
     if (OWM^.forth[c1+firstX,c2+firstY]=227) then
      begin
       c3:=0;
       While (((Boxes[c3]^.x<>c1+firstx) or (Boxes[c3]^.y<>c2+firsty)) and (c3<Num_of_Boxes)) do inc(c3);
       If c3<Num_Of_Boxes then
        PutSprite(c1+firstx,c2+firsty,Boxes[c3]^.offset,0,Boxes[c3]^.dir,ObjBitMaps[Obj_Box]);
      end;
     {NPC}
     if (OWM^.forth[c1+firstX,c2+firstY]>193) and
        (OWM^.forth[c1+firstX,c2+firstY]<194+NUM_OF_NPCs) then
       begin
        if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]<>nil) then
         if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.x=c1+firstx) then
          if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.y=c2+firsty) then
        PutSprite(c1+firstx,
                  c2+firsty,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.offset,5,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.dir,
                  NPCbitmaps[NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.sprt]
                  [NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.frame]);
       end;
   end;   {}

   PutPartySprites; {catch it in the middle}

  for c1:=-1 to 13 do
  for c2:=6 to 11 do
   begin
    {boxes}
     if (OWM^.forth[c1+firstX,c2+firstY]=227) then
      begin
       c3:=0;
       While (((Boxes[c3]^.x<>c1+firstx) or (Boxes[c3]^.y<>c2+firsty)) and (c3<Num_of_Boxes)) do inc(c3);
       If c3<Num_Of_Boxes then
        PutSprite(c1+firstx,c2+firsty,Boxes[c3]^.offset,0,Boxes[c3]^.dir,ObjBitMaps[Obj_Box]);
      end;
     {NPC}
     if (OWM^.forth[c1+firstX,c2+firstY]>193) and
        (OWM^.forth[c1+firstX,c2+firstY]<194+NUM_OF_NPCs) then
       begin
        if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]<>nil) then
         if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.x=c1+firstx) then
          if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.y=c2+firsty) then
        PutSprite(c1+firstx,
                  c2+firsty,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.offset,5,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.dir,
                  NPCbitmaps[NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.sprt]
                  [NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.frame]);
       end;
   end;                      {}

    if rainon then UpDateRain;{
    if fogon then UpDateFog;   }


 end;

Procedure DrawGridFS_nosprites;
{
 var
  c1,c2,c3:integer;

  p1:^OLT1;
  p2:^OLT2;
  firstX,firstY:integer;
  startX,StartY:integer;
  lastx,lasty:byte;

 Function FinalX(x,offset,dir:byte):integer;
 begin
   if dir=1 then finalX:=StartX+(X-FirstX)*20
    else if dir=2 then finalX:=StartX+(X-FirstX)*20-(offset)
    else if dir=3 then finalX:=StartX+(X-FirstX)*20
    else if dir=4 then finalX:=StartX+(X-FirstX)*20+(offset);
  end;
 Function FinalY(y,offset,height,dir:byte):integer;
 begin
   if dir=1 then  finalY:=StartY+(Y-FirstY)*20-(offset)-height
    else if dir=2 then  finalY:=StartY+(Y-FirstY)*20-height
    else if dir=3 then  finalY:=StartY+(Y-FirstY)*20+(offset)-height
    else if dir=4 then  finalY:=StartY+(Y-FirstY)*20-height;
  end;

 begin

  if GlobalStats^.c1offset=0 then
    begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20;
      LastX:=10;
      LastY:=9;
    end
  else
   begin
    if GlobalStats^.c1dir=1 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-6;
      StartX:=20;
      StartY:=GlobalStats^.c1offset;
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=2 then
     begin
      FirstX:=GlobalStats^.c1X-6;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=GlobalStats^.c1offset;
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
    if GlobalStats^.c1dir=3 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20-GlobalStats^.c1offset;
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=4 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20-GlobalStats^.c1offset;
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
     end;


    for c1:=0 to LastX do
    for c2:=0 to LastY do
     begin
      PutSmallBitFasterfs(c1*20+StartX,c2*20+startY,MapTiles[OWM^.back[c1+firstX,c2+firstY]]^);
      if (OWM^.forth[c1+firstX,c2+firstY]>227) and (OWM^.forth[c1+firstX,c2+firstY]<244) then

      if OWM^.treasuredata[OWM^.forth[c1+firstX,c2+firstY]-228]=0 then
       begin

        if (GlobalStats^.Treasure_Taken[GlobalStats^.map-127][OWM^.forth[c1+firstX,c2+firstY]-228]) then
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Open])
        else
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Closed])
       end;
     end;
}
 var
  c1,c2,c3:integer;

  p1:^OLT1;
  p2:^OLT2;
  firstX,firstY:integer{byte};
  startX,StartY:integer{byte};
  lastx,lasty:byte;

 Function FinalX(x,offset,dir:byte):integer;
 begin
   if dir=1 then finalX:=StartX+(X-FirstX)*20
    else if dir=2 then finalX:=StartX+(X-FirstX)*20-(offset)
    else if dir=3 then finalX:=StartX+(X-FirstX)*20
    else if dir=4 then finalX:=StartX+(X-FirstX)*20+(offset);
  end;
 Function FinalY(y,offset,height,dir:byte):integer;
 begin
   if dir=1 then  finalY:=StartY+(Y-FirstY)*20-(offset)-height
    else if dir=2 then  finalY:=StartY+(Y-FirstY)*20-height
    else if dir=3 then  finalY:=StartY+(Y-FirstY)*20+(offset)-height
    else if dir=4 then  finalY:=StartY+(Y-FirstY)*20-height;
  end;
 Procedure PutSprite(x,y,offset,height,dir:byte;where:smallblock);
 var
  Fx,Fy:integer;
 begin
  if (abs(x-GlobalStats^.c1x)<8) and (abs(y-GlobalStats^.c1y)<8) then
  begin
   Fx:=FinalX(x,offset,dir);
   Fy:=FinalY(y,offset,height,dir);
   if (Fx>0) and (Fy>0) and (Fx<240) and (Fy<220) then
   PutSmallTranBitFastFS(FX,FY,0,where);
  end;
 end;

 begin

  if GlobalStats^.c1offset=0 then
    begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20;
      LastX:=10;
      LastY:=9;
    end
  else
   begin
    if GlobalStats^.c1dir=1 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-6;
      StartX:=20;
      StartY:=GlobalStats^.c1offset{ div 10};
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=2 then
     begin
      FirstX:=GlobalStats^.c1X-6;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=GlobalStats^.c1offset{ div 10};
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
    if GlobalStats^.c1dir=3 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20;
      StartY:=20-GlobalStats^.c1offset{ div 10};
      LastX:=10;
      LastY:=10;
     end;
    if GlobalStats^.c1dir=4 then
     begin
      FirstX:=GlobalStats^.c1X-5;
      FirstY:=GlobalStats^.c1y-5;
      StartX:=20-GlobalStats^.c1offset{ div 10};
      StartY:=20;
      LastX:=11;
      LastY:=9;
     end;
     end;


    for c1:=0 to LastX do
    for c2:=0 to LastY do
     begin
      PutSmallBitFasterfs(c1*20+StartX,c2*20+startY,MapTiles[OWM^.back[c1+firstX,c2+firstY]]^);
      if (OWM^.forth[c1+firstX,c2+firstY]>227) and (OWM^.forth[c1+firstX,c2+firstY]<244) then
      {hidden or not}
      if OWM^.treasuredata[OWM^.forth[c1+firstX,c2+firstY]-228]=0 then
       begin
        {open or closed}
        if (GlobalStats^.Treasure_Taken[GlobalStats^.map-127][OWM^.forth[c1+firstX,c2+firstY]-228]) then
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Open])
        else
         PutSmallTranBitFastfs(c1*20+StartX,c2*20+startY,0,ObjBitMaps[Obj_Treasure_Closed])
       end;
         {
      PutSprite(c1+firstx,c2+firsty,Boxes[c3]^.offset,0,Boxes[c3]^.dir,ObjBitMaps[Obj_Box]);}
     end;



  {sprites}
  for c1:=-1 to 13 do
  for c2:=-1 to 11 do
   begin
     {boxes}
     if (OWM^.forth[c1+firstX,c2+firstY]=227) then
      begin
       c3:=0;
       While (((Boxes[c3]^.x<>c1+firstx) or (Boxes[c3]^.y<>c2+firsty)) and (c3<Num_of_Boxes)) do inc(c3);
       If c3<Num_Of_Boxes then
        PutSprite(c1+firstx,c2+firsty,Boxes[c3]^.offset,0,Boxes[c3]^.dir,ObjBitMaps[Obj_Box]);
      end;
     {NPC}
     if (OWM^.forth[c1+firstX,c2+firstY]>193) and
        (OWM^.forth[c1+firstX,c2+firstY]<194+NUM_OF_NPCs) then
       begin
        if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]<>nil) then
         if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.x=c1+firstx) then
          if (NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.y=c2+firsty) then
        PutSprite(c1+firstx,
                  c2+firsty,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.offset,5,
                  NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.dir,
                  NPCbitmaps[NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.sprt]
                  [NPCs[OWM^.forth[c1+firstX,c2+firstY]-194]^.frame]);
       end;
   end;

    if rainon then UpDateRain;

 end;



Procedure DrawPopTxtBk;
 var
  c2:byte;
  temp:^Pop_Text_line;
 begin
   for c2:=59 downto 0 do
    begin
     temp:=addr(TheScreen^[(5)+(c2+138)*320]);
     temp^:=popback^[c2];
    end;
 end;
Procedure DrawOverLay;
 var
  c1:byte;
  p1:^OLT1;
  p2:^OLT2;
 begin
  for c1:=0 to 19 do
   begin
    p1:=addr(TheScreen^[c1*320]);
    p1^:=OverLay^.Top[c1];
    p1:=addr(TheScreen^[(c1+180)*320]);
    p1^:=OverLay^.Bot[c1];
   end;
  for c1:=20 to 179 do
   begin
    P2:=addr(TheScreen^[c1*320]);
    p2^:=OverLay^.Left[c1];
    P2:=addr(TheScreen^[c1*320+200]);
    p2^:=OverLay^.Right[c1];
   end;
 end;
Procedure DrawPanel(y:byte);
 var
  c1:byte;
  p3:^OLT3;
 begin
  For c1:=0 to 199-y do
   begin
    p3:=addr(TheScreen^[(c1+y)*320+220]);
    p3^:=OverLay^.Panel[c1];
   end;
 end;
Procedure PanelClose;
 var
  c1,c2:byte;
  p3:^OLT3;
  p4:^OLT3;
 begin
  new(p4);
  for c1:=0 to 99 do
  p4^[c1]:=0;                         {timer used here}

   F_Clk[3]:=1;
  for c2:=5 to 99 do
  begin
   repeat
   until F_clk[3]=0;
   F_Clk[3]:=1;
  for c1:=1 to 4 do
   begin
    p3:=addr(TheRealScreen^[(c2-c1)*320+220]);
    p3^:=OverLay^.Panel[5-c1];

    p3:=addr(TheRealScreen^[(199-(c2-c1))*320+220]);
    p3^:=OverLay^.Panel[199-(5-c1)];
   end;

    p3:=addr(TheRealScreen^[(199-(c2-5))*320+220]);
    p3^:=p4^;

    p3:=addr(TheRealScreen^[(c2-5)*320+220]);
    p3^:=p4^;
   end;
   dispose(p4);
   p4:=nil;
 end;
Procedure PanelUp;
 var
  c1,c2:byte;
  p3:^OLT3;
  p4:^OLT3;
 begin
   F_Clk[3]:=1;                       {timer used here}
  for c2:=99 downto 5 do
  begin
   repeat
   until F_clk[3]=0;
   F_Clk[3]:=1;
  for c1:=1 to 5 do
   begin
    p3:=addr(TheRealScreen^[(c2-c1)*320+220]);
    p3^:=OverLay^.Panel[5-c1];

    p3:=addr(TheRealScreen^[(199-(c2-c1))*320+220]);
    p3^:=OverLay^.Panel[199-(5-c1)];
   end;
    p4:=addr(TheScreen^[(199-c2)*320+220]);
    p3:=addr(TheRealScreen^[(199-c2)*320+220]);
    p3^:=p4^;

    p4:=addr(TheScreen^[(c2)*320+220]);
    p3:=addr(TheRealScreen^[(c2)*320+220]);
    p3^:=p4^;
   end;
 end;

Procedure PanelUp_instant;
 var
  c2:byte;
  p3:^OLT3;
  p4:^OLT3;
 begin
  for c2:=199 downto 0 do
  begin
    p4:=addr(TheScreen^[(c2)*320+220]);
    p3:=addr(TheRealScreen^[(c2)*320+220]);
    p3^:=p4^;
   end;
 end;



Procedure DrawPanelDirect(y:byte);
 var
  c1:byte;
  p3:^OLT3;
 begin
  For c1:=0 to 199-y do
   begin
    p3:=addr(TheRealScreen^[(c1+y)*320+220]);
    p3^:=OverLay^.Panel[c1];
   end;
 end;

procedure PutSmallBitOutline (x,y:word;col:byte;where:SmallBlock);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    If Where^[c2][c1]=0 then
     begin
      if ((c1<>0) and (Where^[c2][c1-1]<>0)) or
       ((c1<>19) and (Where^[c2][c1+1]<>0)) or
       ((c2<>0) and (Where^[c2-1][c1]<>0)) or
       ((c2<>19) and (Where^[c2+1][c1]<>0)) then
       begin
        putpixel(x+c1,y+c2,col);
       end;
     end;
   end;
 end;
procedure PutSmallBit3Dedge (x,y:word;mid:byte;where:SmallBlock);
 var
  c1,c2:byte;
  pixelcol:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    If Where^[c2][c1]=0 then
     begin
      pixelcol:=mid;
      if ((c1<>0) and (Where^[c2][c1-1]<>0)) or
       ((c1<>19) and (Where^[c2][c1+1]<>0)) or
       ((c2<>0) and (Where^[c2-1][c1]<>0)) or
       ((c2<>19) and (Where^[c2+1][c1]<>0)) then
       begin
        pixelcol:=mid;
        if ((c1<>0) and (Where^[c2][c1-1]<>0)) then PixelCol:=PixelCol-2;
        if ((c1<>19) and (Where^[c2][c1+1]<>0)) then PixelCol:=PixelCol+2;
        if ((c2<>0) and (Where^[c2-1][c1]<>0)) then PixelCol:=PixelCol-2;
        if ((c2<>19) and (Where^[c2+1][c1]<>0)) then PixelCol:=PixelCol+2;
        putpixel(x+c1,y+c2,pixelcol);
       end;
     end;
   end;
 end;

procedure PutSmallBitFaster (x, y : word; where : SmallBtm); assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   cx,0014h
@copyloop:
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  add   di,300
  loop  @copyloop
  pop   ds
end;

procedure PutSmallBitFasterfs (x, y : word; where : SmallBtm); assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,2
  mov   si,ax
  shl   ax,6
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   cx,0014h
@copyloop:
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  add   di,240
  loop  @copyloop
  pop   ds
end;

procedure PutSmallTranBitFastHalffs(x, y: word; trans,cutter : byte; where : SmallBlock);
assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,2
  mov   si,ax
  shl   ax,6
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0000h
  mov   cl,[cutter]
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,al
@1:
  cmp   ah,bl
  je    @2
  mov   dh,ah
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,240
  loop  @lineloop

  pop   ds
end;

procedure PutSmallTranBitFastShadow(x, y : word; trans : byte; where : SmallBlock);
assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,2
  mov   si,ax
  shl   ax,6
  add   si,ax
  add   si,[x]
  sub   si,20
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0014h
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,154
@1:
  cmp   ah,bl
  je    @2
  mov   dh,154
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,241
  loop  @lineloop

  pop   ds
end;

procedure PutSmallTranBitFastfs(x, y : word; trans : byte; where : SmallBlock);
assembler;
asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,2
  mov   si,ax
  shl   ax,6
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0014h
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,al
@1:
  cmp   ah,bl
  je    @2
  mov   dh,ah
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,240
  loop  @lineloop

  pop   ds
end;



procedure PutSmallTranBitFastHalf(x, y: word; trans,cutter : byte; where : SmallBlock);
assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0000h
  mov   cl,[cutter]
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,al
@1:
  cmp   ah,bl
  je    @2
  mov   dh,ah
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,300
  loop  @lineloop

  pop   ds
end;

procedure PutSmallTranBitFastHalffsz(x, y: word; trans,cutter : byte; where : SmallBlock);
begin
 PutSmallTranBitFastShadow(x, y, trans , where );
 PutSmallTranBitFastHalffsz(x, y, trans,cutter , where);
end;


procedure PutSmallTranBitFast(x, y : word; trans : byte; where : SmallBlock);
assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0014h
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,al
@1:
  cmp   ah,bl
  je    @2
  mov   dh,ah
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,300
  loop  @lineloop

  pop   ds
end;

begin
 rainon:=false;
end.