Program CDTEST;
  uses CD_ROM,CRT;
Procedure Startup;
  begin
   Audio_Channel_Control(1,255,1,255,1,255,1,255);
   Stop_Audio;
   TextColor(lightblue);
   If MSCDEXOk then writeln('MSCDEXOk= OK') else writeln('MSCDEXOk= failed- Ca not find CD Rom');
  end;
Procedure Check(message:string);
 begin
   TextColor(lightcyan);
  If not(MSCDEXOk) then writeln('MSCDEXOk= failed- Can not find CD Rom')
      else
       begin
        writeln('MSCDEXOk= OK');
        If not(AudioCD) then  writeln('AdioCD= failed- Is there a CD in the drive?')
        else
         begin
          writeln('AdioCD= OK');
          TextColor(lightgray);
          writeln(message);
         end;
       end;
     TextColor(lightgray);
     Writeln('Press any key to move on.');
     readkey;
     writeln;

 end;
Procedure Main;
 var
  c1:byte;
  begin
     Writeln;
     TextColor(green);
     Writeln('Simple CD Audio test for The Legend of Talibah');
     writeln('                  Zaskoda of Shobk');
     Writeln;
     TextColor(lightblue);
     writeln('If you have not already, please put an');
     writeln('audio CD in your CD Rom drive and give');
     writeln('it a moment to spin up. Something loud');
     writeln('would work the best.');
     TextColor(lightgray);
     Writeln;
     writeln;
     writeln('Attempting to play track 1 of the Audio CD:');
     Stop_Audio;
     Play_Track(1);
     Check('You should be hearing the first song on your CD.');
     writeln('Attempting to play track 3 of the Audio CD:');
     Stop_Audio;
     Play_Track(3);
     Check('You should be hearing the third song on your CD.');
     writeln('Attempting to cut volume by half:');
     Audio_Channel_Control(1,64,1,64,1,64,1,64);
     Check('Your music should be half as loud.');

     writeln('Attempting to fade volume from min to max:');
     for c1:=0 to 50 do
      begin
       Audio_Channel_Control(1,c1*5,1,c1*5,1,c1*5,1,c1*5);
       if (c1 div 5) = (c1/5) then write('\');
      end;
      writeln;
     Check('Your music should have faded from full volume to quiet.');

     writeln('Attempting to fade volume from max to min:');
     for c1:=50 downto 0 do
      begin
       Audio_Channel_Control(1,c1*5,1,c1*5,1,c1*5,1,c1*5);
       if (c1 div 5) = (c1/5) then write('\');
      end;
      writeln;
     Check('Your music should have faded from full volume to quiet.');


  end;
Procedure Shutdown;
  begin
   Stop_Audio;
   Writeln('Thanx');writeln;
  end;
begin
  Startup;
  main;
  Shutdown;
end.