{This unit has very basic graphic routines.}
{$B-}

{$G+}

Unit Graphics;

Interface
uses vars;
type VirtScrPtr=^FullScreenBtm;

var TheScreen,
    TheRealScreen:VirtScrPtr;
    OldExitProc:pointer;

Procedure SetCycle(Base:byte;Pal:PaletteType);
Function TopCap(What:byte):byte;   {maybe move this one??}
Procedure DisText(Wich:byte);
Procedure DulText(Wich:byte);
Procedure HiText(Wich:byte);
Procedure BrownPal;
Procedure ClearPal;  {turns the entire pallete black}
Procedure BWPal;
Procedure HalfPal;
Procedure WaitScreen;
PROCEDURE GetRgbPalette(Color : BYTE; VAR Red, Green, Blue : BYTE);
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
procedure putpixel(x,y:word;color:byte);
procedure SetVideoMode(mode:word);
procedure PushScreen;
Procedure PushSmallScreenfs;
Procedure PushSmallScreen;
Procedure PushMenu;
Procedure ClearFunk1;
procedure PushFunk1;
procedure PushFunk2;
procedure ClearScreen;
procedure AsmPush(Source,Dest:VirtScrPtr);
procedure AsmClear(Scr:VirtScrPtr);
Procedure FetchPal(var Pal:PaletteType);
Procedure PushFadeIn(Speed:Byte);
Procedure FadeIn(Speed:Byte;PAl:PaletteType);
Procedure FadeOut(Speed:Byte);
Procedure PushPalDeg(Deg:byte;Pal:palettetype);
Procedure Fadeto(Speed:Byte;PAl:PaletteType);
Procedure DownGamePal;
Procedure FadeOutPartial(speed:byte;var pal:PaletteType);{
Procedure PushSmallScreenSlow;                            }


Implementation
{$F+}
procedure AsmPush(Source,Dest:VirtScrPtr);external;
procedure AsmClear(Scr:VirtScrPtr);external;{$L AsmStuff.Obj}
{$F-}


                            {
Procedure PushSmallScreenSlow;
 var
  c1:byte;
  templine1,templine2:^BackGroundLine;
 begin
  for c1:=0 to 79 do
   begin
    templine1:=addr(TheScreen^[6420+(79-c1)*320]);
    templine2:=addr(TheRealScreen^[6420+(79-c1)*320]);
    templine2^:=templine1^;
    templine1:=addr(TheScreen^[6420+(80+c1)*320]);
    templine2:=addr(TheRealScreen^[6420+(80+c1)*320]);
    templine2^:=templine1^;
    waitscreen;
    if (c1 mod 5)=0 then waitscreen;
   end;
 end;                      }

Procedure PushSmallScreenfs; assembler;
asm
  push  ds
  les   di,[TheRealScreen]
  lds   si,[TheScreen]
  add   si,5220
  cld
  mov   cx,200
@copyloop:
  push  cx
  mov   cx,110
@rowloop:
  movsw
  loop  @rowloop
  pop   cx
  add   di,100
  add   si,40
  loop  @copyloop
  pop   ds
end;
Procedure PushSmallScreen; assembler;
asm
  push  ds
  les   di,[TheRealScreen]
  add   di,6420
  lds   si,[TheScreen]
  add   si,6420
  cld
  mov   cx,160
@copyloop:
  push  cx
  mov   cx,90
@rowloop:
  movsw
  loop  @rowloop
  pop   cx
  add   di,140
  add   si,140
  loop  @copyloop
  pop   ds
end;

Procedure PushMenu; assembler;
asm
  push  ds
  les   di,[TheRealScreen]
  add   di,220
  lds   si,[TheScreen]
  add   si,220
  cld
  mov   cx,200
@copyloop:
  push  cx
  mov   cx,50
@rowloop:
  movsw
  loop  @rowloop
  pop   cx
  add   di,220
  add   si,220
  loop  @copyloop
  pop   ds
end;

Procedure SetCycle(Base:byte;Pal:PaletteType);
 var
  c1:byte;
 begin
  For c1:=128 to 255 do
   asetrgbpalette(topcap(c1+base),Pal[c1].R,Pal[c1].G,Pal[c1].B);
 end;
Function TopCap(What:byte):byte;
 begin
  if what<128 then What:=What+128;
  TopCap:=What;
 end;
Procedure HiText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,63,55,33);
  AsetRgbPalette(Wich*3+11,50,45,25);
  AsetRgbPalette(Wich*3+12,41,36,21);{
  AsetRgbPalette(Wich*4+13,41,36,21); }
 end;
Procedure DisText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,12,11,10);
  AsetRgbPalette(Wich*3+11,9,8,7);
  AsetRgbPalette(Wich*3+12,6,5,4); {
  AsetRgbPalette(Wich*4+13,0,0,0);  }
 end;
Procedure DulText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,41,36,21);
  AsetRgbPalette(Wich*3+11,35,30,18);
  AsetRgbPalette(Wich*3+12,30,25,15);{
  AsetRgbPalette(Wich*4+13,20,17,10); }
 end;
Procedure DownGamePal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=64 to 128+63 do
   asetrgbpalette(c1,(Pal[c1].r*9) div 10,(Pal[c1].g*9) div 10,
   (Pal[c1].b*9) div 10);
 end;
Procedure HalfPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r div 2,Pal[c1].g div 2,Pal[c1].b div 2);
 end;

Procedure BWPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   begin
    Pal[c1].r:=(Pal[c1].r+Pal[c1].g+Pal[c1].b) div 3;
    Pal[c1].g:=Pal[c1].r;
    Pal[c1].b:=Pal[c1].g;
   end;
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r,Pal[c1].g,Pal[c1].b);
 end;
Procedure ClearPal;
 var
  c1:byte;
 begin
  for c1:=0 to 255 do
   asetrgbpalette(c1,0,0,0);
 end;
Procedure BrownPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   begin
    Pal[c1].r:=(Pal[c1].r+Pal[c1].g+Pal[c1].b) div 3;
    Pal[c1].g:=Pal[c1].r;
    Pal[c1].b:=Pal[c1].g;
   end;
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r,Pal[c1].g div 2,Pal[c1].b div 4);
 end;
Procedure PushPalDeg(Deg:byte;Pal:palettetype);
 var
  c1,c2:byte;
 begin
  For c1:=255 downto 0 do
    Asetrgbpalette(c1,Trunc(Pal[c1].R*deg/255),Trunc(Pal[c1].G*deg/255),
    Trunc(Pal[c1].B*deg/255));
 end;
Procedure FetchPal(var Pal:PaletteType);
 var
  c1:byte;
 begin
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
 end;

Procedure PushFadeIn(Speed:Byte);
 var
  c1,c2:byte;
  pal:PaletteType;
 begin
  if speed=0 then speed:=1;
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
  For c1:=0 to 255 do
   ASetRgbPalette(c1,0,0,0);
  PushScreen;
  For c2:=0 to Speed do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
  end;
 end;
Procedure Fadeto(Speed:Byte;PAl:PaletteType);
 var
  c1,c2:byte;
  oldpal:^PaletteType;
 begin
  new(oldpal);
  fetchpal(oldpal^);
  if speed=0 then speed:=1;
  For c2:=0 to Speed do
   begin
  For c1:=0 to 255 do
   AsetRgbPalette(c1,(OldPal^[c1].R*(speed-c2)+Pal[c1].R*c2) div speed
   ,(OldPal^[c1].g*(speed-c2)+Pal[c1].g*c2) div speed
   ,(OldPal^[c1].b*(speed-c2)+Pal[c1].b*c2) div speed);
   waitscreen;
   end;
   dispose(oldpal);
 end;
Procedure FadeIn(Speed:Byte;PAl:PaletteType);
 var
  c1,c2:byte;
 begin
  if speed=0 then speed:=1;
  For c2:=0 to Speed do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
   end;
 end;
Procedure FadeOutPartial(speed:byte;var pal:PaletteType);
 var
  c1,c2:byte;
 begin
  if speed=0 then speed:=1;
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
  For c2:=Speed downto 0 do
  begin
  For c1:=64 to 188 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
   end;
 end;
Procedure FadeOut(Speed:Byte);
 var
  c1,c2:byte;
  pal:PaletteType;
 begin
  if speed=0 then speed:=1;
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
  For c2:=Speed downto 0 do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
   end;
 end;
PROCEDURE GetRgbPalette(Color : BYTE; VAR Red, Green, Blue : BYTE);
 Begin
  Port[$3C7]:=Color;
  Red:=Port[$3C9];
  Green:=Port[$3C9];
  Blue:=Port[$3C9];
 end;
     Procedure WaitScreen;
          Begin
               Repeat Until (Port[$3DA] and $08) <> 0;
               Repeat Until (Port[$3DA] and $08) = 0;
          end; {
Procedure WaitScreen;
 Begin
  while not ((Port[$3DA] and $08) = 0) do begin end;
  Repeat Until (Port[$3DA] and $08) <> 0;
 end;           }
Procedure ASetRGBPalette ( Color, Red, Green, Blue : Byte ); assembler;
asm
  mov dx,3c8h
  mov al, color
  out dx, al
  mov dx,3c9h
  mov al, red
  out dx,al
  mov al, green
  out dx,al
  mov al, blue
  out dx,al
End;             {
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
 Begin
  Port[$3C8]:=Color;
  Port[$3C9]:=Red;
  Port[$3C9]:=Green;
  Port[$3C9]:=Blue;
 end;             }

procedure SetVideoMode(mode:word);assembler;
asm
   mov ax,mode
   xor ah,ah
   int 10h
end;

procedure PutPixel(x,y:word;color:byte);assembler;
asm
   push es
   mov ax,y
   mov bx,y
   shl ax,6
   shl bx,8
   add ax,bx
   add ax,x
   les di, TheScreen
   add di,ax
   mov al,color
   stosb
   pop es
end;

Procedure ClearFunk1;
 type
  Oline=array[0..319] of byte;
  Olineptr=^Oline;
 var
  t1,t2:Olineptr;
  c1,c2:byte;
 begin
  for c2:=20 downto 5 do
  begin
  clearscreen;
  for c1:=0 to 199 do
   begin
    t1:=addr(TheScreen^[(199-((c1*(c2*10 div 20)) div 10))*320]);
    t2:=addr(TheRealScreen^[(199-c1)*320]);
    t1^:=t2^;
   end;
    pushscreen;
  end;
 end;
procedure PushFunk2;
 var
  c1,c2:byte;
 begin
  for c2:=99 downto 0 do
   for c1:=100 downto c2 do
     begin
      move(TheScreen^[((c1-c2) shl 8)+((c1-c2) shl 6)],TheRealScreen^[(c1 shl 8)+(c1 shl 6)],320);
      move(TheScreen^[((200-c1+c2) shl 8)+((200-c1+c2) shl 6)],TheRealScreen^[((200-c1) shl 8)+((200-c1) shl 6)],320);
     end;
 end;
procedure PushFunk1;
 var
  c1,c2:byte;
 begin
  for c2:=198 downto 0 do
   for c1:=c2 to 199 do
     begin
      move(TheScreen^[((c1-c2) shl 8)+((c1-c2) shl 6)],
           TheRealScreen^[(c1 shl 8)+(c1 shl 6)],320);
     end;
 end;
procedure PushScreen;
begin
   AsmPush(TheScreen,TheRealScreen);
end;


procedure ClearScreen;
begin
   AsmClear(TheScreen);
end;

procedure ExitProcedure;far;
begin
   ExitProc:=OldExitProc;
   dispose(TheScreen);
end;

procedure PutSmallBitFaster (x, y : word; where : SmallBtm); assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   cx,0014h
@copyloop:
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  add   di,300
  loop  @copyloop
  pop   ds
end;


begin
   new(TheScreen);
   ClearScreen;
   TheRealScreen:=ptr($A000,0000);
   OldExitProc:=ExitProc;
   ExitProc:=@ExitProcedure;
end.