 {This unit conains most of the global variables,
 functions and procedures dealing with file IO
 and many other common little functions and procs}
{$B-}
{$G+}
{$I-}
Unit Vars;
Interface
uses multkeys,SPX_TIM,joystick,crt;

(********keyboard stuff**********)
var
last_key:byte;
down_bound,up_bound,right_bound,left_bound:word;
debugfile:text;
const
VersionNumber='v0.68';
SpriteTextFileName='DATA/SPRITES.WRD';
Master_Sprite_File='DATA/ALL_SPR.69';
Objects_FileName='DATA/stuff.spr';

Num_Of_Items=32;
EffectSpr_Loc=33;
Drops_Loc=34;
NUM_OF_MAP_WARPS=50;
NUM_OF_NPCS=32;
NUM_OF_BOXES=32;
NUM_OF_TREASURE=16;
NUM_OF_MAPS=64;
OBJ_Box=0;
OBJ_Treasure_Closed=2;
OBJ_Treasure_Open=3;
OBJ_Treasure_Full=4;
OBJ_BackDrop=5;
key_repeat_speed=4;
(********keyboard stuff**********)
Num_of_SmallBits=255;

{Party Member's sprites}
DRUDWYN=0;
SARIS=1;
SFARM=2;
SKNIGHT=3;
SMONK=4;
SSHAD=5;
GERWIN=6;
STAULKER=7;
VENETIA=8;
PHONOVAN=9;


type
 ScreenWidthText=String[38];
 StoryTextBlock=Array[0..4]  of ScreenWidthText;
 STBPtr=^StoryTextBlock;
 TextFile=file of StoryTextBlock;


commonstring=string[8];
CommonStringFile=file of CommonString;

Treasure_Array=array[0..num_of_maps-1,0..num_of_treasure-1] of boolean;
{
Item_Def_Record=record
 name:commonstring;
 definition:byte;
 power:byte;
 end;
 }

mapluttype=record {map look up table info}
 mapname:array[127..192] of commonstring;
 mapfrom:array[127..192] of byte;
 tileset:array[127..192] of commonstring;
 end;                                        {
 SpritesLUTtype=array[0..255] of commonstring; }
 tileluttype=array[0..Num_of_SmallBits-1] of byte;

 GlobalOptionStuff=Record   {four of these in the end}
  end;
                                                  {
 BackGroundLine=array[0..179] of byte;
 BackGroundBitMap=Array[0..159] of backgroundLine; }
 OLT1=array[0..219] of byte;   {overlay stuff on main part of game}
 OLT2=array[0..19] of byte;
 OLT3=array[0..99] of byte;

 OverLayType=record
  top:array[0..19] of OLT1;
  bot:array[0..19] of OLT1;
  left:array[20..179] of OLT2;
  right:array[20..179] of OLT2;
  panel:array[0..199] of OLT3;
  end;

 LoadGridBackLine=array[0..219] of byte;  {Backs in load game part}
 LoadGridBack=array[0..29] of LoadGridBackLine;
 LGBPtr=^LoadGridBack;

 Pop_Text_Line=Array[0..309] of byte;              {back for Pop Texts}
 Pop_Text_background=array[0..59] of Pop_Text_Line;


 FullScreenBtm=Array[0..64000] of byte;
 palettetype=array[0..255] of record
   r,g,b:byte;
  end;

 BtmRec=Record
    Pal:PAlettetype;
    Screen:FullScreenBtm;
   end;

 HorizBtmArray=array[0..19] of byte;  {For Sprites}

 HBASmallPoint=^HorizBtmArray;
 SmallBtm=array[0..19] of HorizBtmArray;


 SmallBlock=^SmallBtm;
 MediumBtm=array[0..39] of HorizBtmArray;
 MediumBtmRec=record
   BitMap:^MediumBtm;{
   BitTest:Array[0..19] of byte;}
  end;

 SpriteFrames=array[0..11] of SmallBlock;

            {
 NPC_Sprites=array[0..Num_of_NPCs] of byte;}
 SpriteRec=record      {needs work}
  dir:byte;            {only used on NPCs}
  x,y:byte;
  OffSet:byte;
  Frame:byte;
  Sprt:byte;
 end;
 BoxRec=record
  dir:byte;
  x,y:byte;
  Offset:byte
 end;


 MapRec=record
  back:array[0..179,0..179] of byte;
  forth:array[0..179,0..179] of byte;
  NPCMAPData:array[0..127] of byte;
  TreasureData:array[0..31] of byte;
 end;

 MapWarp=record
  x,y:byte;
  end;
 MapWarps=array[6..NUM_OF_MAP_WARPS] of MapWarp;

 CurrentGlobalStats=Record {What is Saved}{
   FullScreen:boolean;                     }
   TalkRate:Byte;
   WalkRate:byte;
   menu_r,menu_g,menu_b:byte;
   map:byte;
   Gold:longint;
   OLTName:commonstring;
   Item_Quant:array[0..Num_of_Items-1] of byte;
   BatCount:byte;
   {x,y,offset,dir,frame:byte; {Location of Main Character}
   {Character 1 *Main*}
   C1Name:commonstring;
   C1Alive:boolean;
   C1x,C1y,C1OffSet,c1Dir,C1Frame,C1Sprt,c1cut,c1height,c1lastmove,c1effect:byte;
   c1hp,c1mp,c1mhp,c1mmp,c1exp:word;
   c1weap,c1arm:byte;

   C2Name:commonstring;
   C2Alive:boolean;
   C2x,C2y,C2OffSet,c2Dir,C2Frame,C2Sprt,c2cut,c2height,c2lastmove,c2effect:byte;
   c2hp,c2mp,c2mhp,c2mmp,c2exp:word;
   c2weap,c2arm:byte;

   C3Name:commonstring;
   C3Alive:boolean;
   C3x,C3y,C3OffSet,c3Dir,C3Frame,C3Sprt,c3cut,c3height,c3effect:byte;
   c3hp,c3mp,c3mhp,c3mmp,c3exp:word;
   c3weap,c3arm:byte;
   {Character 2 *Left*}
   {Character 3 *Right*}
   Treasure_Taken:Treasure_Array;
   filler:array[0..255] of byte;
  end;




Var
Words:STBPtr;
maplut:^mapluttype;
SpriteTextFile:TextFile;
GlobalStats:^CurrentGlobalStats;
C1BitMaps:SpriteFrames;  {keep sprites outside of records}
C2BitMaps:SpriteFrames;  {keep sprites outside of records}
C3BitMaps:SpriteFrames;  {keep sprites outside of records}
NPCBitMaps:array[0..{Num_of_NPCs-1}255] of SpriteFrames;
ObjBitMaps:SpriteFrames;


{\/These variable load at start of game loop, unload upon exit of loop\/}
 OverLay:^OverLAyType;         {over entire screen}
 PopBack:^Pop_Text_background; {Background behind text}
 OWM:^MapRec;                  {Overworld Map}
 TileLUT:^tileLUTType;
 MapWarpLUT:^MapWarps;{warp look up table}
 MapTiles:array[0..(Num_of_SmallBits-1)] of SmallBlock;   {map tiles}
 NPCs:array[0..NUM_OF_NPCS-1] of ^SpriteRec;
 Boxes:array[0..NUM_Of_Boxes-1] of ^ BoxRec;


 Key_Left,Key_Right,Key_Up,Key_Down,Key_But1,Key_But2,Key_But3,Key_But4:word;
{/\These variable load at start of game loop, unload upon exit of loop/\}

 GlobOb:GlobalOptionStuff;





Function Frame(x,y,offset,dir:byte):byte;
Procedure LoadOWM(filename:commonstring);
Procedure LoadMapTiles(filename:commonstring);
Procedure LoadSprite(var who:spriteframes;number:byte);
Procedure KillOWM;
Procedure KillMapTiles;
Procedure KillSprite(var who:spriteframes);
Procedure init_maplut;
Procedure kill_maplut;
Procedure ChangeMap(wich:byte);
Procedure ExitMap;

Function EscapeKey:boolean;
Function PowerKey1:boolean;
Function PowerKey2:boolean;
Function Right:boolean;
Function Left:boolean;
Function Down:boolean;
Function Up:boolean;
Procedure AllPause;
Procedure AllPausePressed;
Function ButtonDown:boolean;
Function SomethingDown:boolean;
Procedure SetUpSticks;
Procedure CloseDebugFile;
Procedure OpenDebugFile;
Procedure LoadObjects;
Procedure KillObjects;
Procedure LoadTextBlock(wich:byte;filename:string);
Function Item_Power(which:byte):byte;
Function Item_Name(which:byte):commonstring;{
Function Item_Definition(which:byte):byte;
Procedure Stock_Sort;                     }


{battle stuff--------------------------}
Const
num_of_bat_frames=5;
Type
 {
 HorizBtmArray=array[0..19] of byte;  {For Battle Background}{
 HBASmallPoint=^HorizBtmArray;
 SmallBtm=array[0..19] of HorizBtmArray;
 SmallBlock=^SmallBtm;
 MediumBtm=array[0..39] of HorizBtmArray;
 MediumBtmRec=record
   BitMap:^MediumBtm;
   BitTest:Array[0..19] of byte;
  end;

 SpriteFrames=array[0..11] of SmallBlock;                     }

 {battle engine types}
 battle_bitmap=array[0..num_of_bat_frames,0..59,0..59] of byte;
 enemy_info = object
     hp,mp:integer;
     defense,offense:byte;
     special:byte;
     monster_type:byte;
   end;
 Battletype = object
   background:byte;
   c1frames:^battle_bitmap;
   c2frames:^battle_bitmap;
   c3frames:^battle_bitmap;
   enemy_type1frames:^battle_bitmap;
   enemy_type2frames:^battle_bitmap;
   enemy_type3frames:^battle_bitmap;
   function player_attack(target:byte):integer; {returns amount of damage}
   function enemy_attack(target:byte):integer; {returns amount of damage}
   procedure init;
   procedure kill;
  end;
 var
  battle:battletype;

Implementation


 function Battletype.player_attack(target:byte):integer; {returns amount of damage}
    begin
    end;
 function Battletype.enemy_attack(target:byte):integer; {returns amount of damage}
    begin
    end;
 procedure Battletype.init;
    begin
     new(c1frames);
     new(c2frames);
     new(c3frames);
     new(enemy_type1frames);
     new(enemy_type2frames);
     new(enemy_type3frames);
    end;
 procedure Battletype.kill;
    begin
     dispose(c1frames);
     dispose(c2frames);
     dispose(c3frames);
     dispose(enemy_type1frames);
     dispose(enemy_type2frames);
     dispose(enemy_type3frames);
    end;

{/battle stuff--------------------------}
Function ButtonDown:boolean;
 begin
  pollsticks;
  if ((globalkeydown)
         or (gsticks[1].button1)
         or (gsticks[1].button2)
         or (gsticks[1].button3)
         or (gsticks[1].button4))
      then ButtonDown:=true else ButtonDown:=false;
 end;
Function SomethingDown:boolean;
 begin
  pollsticks;
  if ((globalkeydown)
         or (gsticks[1].y<up_bound)
         or (gsticks[1].y>(down_bound))
         or (gsticks[1].x<left_bound)
         or (gsticks[1].x>(right_bound))
         or (gsticks[1].button1)
         or (gsticks[1].button2)
         or (gsticks[1].button3)
         or (gsticks[1].button4))
      then SomethingDown:=true else SomethingDown:=false;
 end;
Procedure AllPause;
 begin
  pollsticks;
  while not(somethingdown) do pollsticks;
 end;
Procedure AllPausePressed;
 begin
  pollsticks;
  while not(SomethingDown) do pollsticks;
  while (SomethingDown) do pollsticks;
 end;
(******Key entry functions********)
Function EscapeKey:boolean;
 begin
  pollsticks;
   EscapeKey:=false;
   if not((last_key=key_esc) and (s_clk[3]<>0)) then
     if ((keydown[key_esc])) or ((gsticks[1].button4))  then
      begin
       Last_Key:=Key_Esc;
       EscapeKey:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;
Function PowerKey1:boolean;
 begin
  pollsticks;
   PowerKey1:=false;
   if not((last_key=Key_Enter) and (s_clk[3]<>0)) then
     if ((keydown[key_enter])) or ((gsticks[1].button1))  then
      begin
       Last_Key:=Key_Enter;
       PowerKey1:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;
Function PowerKey2:boolean;
 begin
  pollsticks;
   PowerKey2:=false;
   if not((last_key=Key_NP0) and (s_clk[3]<>0)) then
     if ((keydown[key_NP0])) or ((gsticks[1].button2))  then
      begin
       Last_Key:=Key_NP0;
       PowerKey2:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;
Function Up:boolean;
 begin
  pollsticks;
   Up:=false;
   if not((last_key=Key_UpArrow) and (s_clk[3]<>0)) then
     if (keydown[key_UpArrow]) or ((gsticks[1].y<up_bound))  then
      begin
       Last_Key:=Key_UpArrow;
       Up:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;
Function Down:boolean;
 begin
  pollsticks;
  Down:=false;
   if not((last_key=Key_DownArrow) and (s_clk[3]<>0)) then
     if (keydown[key_DownArrow]) or ((gsticks[1].y>down_bound))  then
      begin
       Last_Key:=Key_DownArrow;
       Down:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;
Function Left:boolean;
 begin
  pollsticks;
   Left:=false;
   if not((last_key=Key_LeftArrow) and (s_clk[3]<>0)) then
     if (keydown[key_LeftArrow]) or ((gsticks[1].x<left_bound))  then
      begin
       Last_Key:=Key_LeftArrow;
       Left:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;

Function Right:boolean;
 begin
  pollsticks;
  Right:=false;
   if not((last_key=Key_RightArrow) and (s_clk[3]<>0)) then
     if (keydown[key_RightArrow]) or ((gsticks[1].x>right_bound))  then
      begin
       Last_Key:=Key_RightArrow;
       Right:=true;
       s_clk[3]:=key_repeat_speed;
      end;
 end;


{This function returns the correct frame for
a walking sprite given its position on the
map and direction}
Function Frame(x,y,offset,dir:byte):byte;
 begin
  if dir=1 then
   begin
    frame:=1;
    if (offset>5)  and (offset<15) then
     begin
      if odd(y) then frame:=0 else frame:=2;
     end;
   end
  else if dir=2 then
   begin
    frame:=4;
    if (offset>5)  and (offset<15) then
     begin
      if odd(x) then frame:=3 else frame:=5;
     end;
   end
  else if dir=3 then
   begin
    frame:=7;
    if (offset>5)  and (offset<15) then
     begin
      if odd(y) then frame:=6 else frame:=8;
     end;
   end
  else
   begin
    frame:=10;
    if (offset>5)  and (offset<15) then
     begin
      if odd(x) then frame:=9 else frame:=11;
     end;
   end;
 end;

(******Key entry functions********)
Procedure SetUpSticks;
 var
  x,y:byte;
  doohicky:char;

 begin
  right_bound:=4000;
  down_bound:=4000;
  left_bound:=0;
  up_bound:=0;

  joystick.nojoy:=false;
  for x:=1 to paramcount do if paramstr(x)='-nojoy' then joystick.nojoy:=true;

  if not(joystick.nojoy) then
  begin
  initsticks;
  if not(gsticks[1].present) then
   writeln('No joystick/pad detected...')
  else
   begin
    writeln;
    writeln('  ۲');
    writeln(' ۲                                             ۲');
    writeln('۲             Joystick/Pad Detected             ۲');
    writeln('۲ Press [ESC] Key to skip joystick calibration. ۲');
    writeln(' ۲                                             ۲');
    writeln('  ۲');
    writeln;
    write(' Leave joystick centered and press any button.');
    while not((gsticks[1].button1)
         or (gsticks[1].button2)
         or (gsticks[1].button3)
         or (gsticks[1].button4) or (keydown[key_esc])) do pollsticks;
    if not((keydown[key_esc])) then
     begin
       if gsticks[1].x>40 then left_bound:=gsticks[1].x-40 else left_bound:=1;
       right_bound:=gsticks[1].x+40;
       if gsticks[1].y>40 then up_bound:=gsticks[1].y-40 else up_bound:=1;
       down_bound:=gsticks[1].y+40;
       while ((gsticks[1].button1)
          or (gsticks[1].button2)
          or (gsticks[1].button3)
          or (gsticks[1].button4)) do pollsticks;
     end;

    writeln;
    writeln(' -=');
    writeln(' Make several complete circles with the joystick.');
    write(' Then hit any button.   [   ]');

    x:=WhereX-3;y:=Wherey;
    while not((gsticks[1].button1)
         or (gsticks[1].button2)
         or (gsticks[1].button3)
         or (gsticks[1].button4) or (keydown[key_esc])) do
     begin
      pollsticks;
      {tighter}
      if (gsticks[1].x<right_bound) and (gsticks[1].x+(gsticks[1].x div 4)<left_bound)
       then left_bound:=gsticks[1].x+(gsticks[1].x div 4);
      if (gsticks[1].x>left_bound) and (gsticks[1].x-(gsticks[1].x div 4)>right_bound)
       then right_bound:=gsticks[1].x-(gsticks[1].x div 4);

      if (gsticks[1].y<down_bound) and (gsticks[1].y+(gsticks[1].y div 4)<up_bound)
       then up_bound:=gsticks[1].y+(gsticks[1].y div 4);
      if (gsticks[1].y>up_bound) and (gsticks[1].y-(gsticks[1].y div 4)>down_bound)
       then down_bound:=gsticks[1].y-(gsticks[1].y div 4);


     If gsticks[1].x<left_bound then
       begin
        If gsticks[1].y<up_bound then doohicky:=''
        else If gsticks[1].y>down_bound then doohicky:=''
        else doohicky:='';
       end
     else If gsticks[1].x>right_bound then
      begin
       If gsticks[1].y<up_bound then doohicky:=''
       else If gsticks[1].y>down_bound then doohicky:=''
       else doohicky:='';
      end
     else
      begin
      If gsticks[1].y<up_bound then doohicky:=''
      else If gsticks[1].y>down_bound then doohicky:=''
      else doohicky:='';
      end;
     GotoXY(x+5,y);
     Write(right_bound,'  ',gsticks[1].x,'  ');
     Write(down_bound,'  ',gsticks[1].y,'   ',gsticks[1].y-(gsticks[1].y div 4),'     ');
     GotoXY(x,y);
     Write(doohicky);
   end;
   GotoXY(x+3,y);
   writeln;
   while (gsticks[1].button2) do pollsticks;
   if (keydown[key_esc]) then
    begin
     right_bound:=4000;
     down_bound:=4000;
     left_bound:=0;
     up_bound:=0;
     while (keydown[key_esc]) do;
    end;
  end;
  end;
 end;

Procedure LoadSprite(var who:spriteframes;number:byte);
 var
  c1:byte;
  bklfile:file of smallbtm;
 begin
  for c1:=0 to 11 do
   if (who[c1]=nil) then new(who[c1]);
  assign(bklfile,Master_Sprite_File);
  reset(bklfile);
  if IOResult=0 then
   begin
    seek(bklfile,number*12);
    if IOResult=0 then
      begin
        for c1:=0 to 11 do
         begin
         if not(eof(bklfile)) then Read(bklFile,who[c1]^);
         if IOResult<>0 then writeln(debugfile,'Error reading from '+Master_Sprite_File);
         end;
         close(bklfile);
      end
     else
       begin
        writeln(debugfile,'Error reading from '+Master_Sprite_File);
      end;
   end
      else
       begin
        writeln(debugfile,'Error opening '+Master_Sprite_File);
       {The file wasn't found!}
      end;
 end;

Procedure KillAllNPCSprites;
 var
  c1:byte;
 begin
  for c1:=0 to NUM_OF_NPCS-1 do
   begin
    KillSprite(NPCBitMaps[c1]);
   end;
 end;
Procedure KillAllBoxes;
 var
  c1:byte;
 begin
    For c1:=0 to Num_of_Boxes-1 do
     If Boxes[c1]<>Nil then
      begin
       dispose(boxes[c1]);
       boxes[c1]:=nil;
      end;
 end;

Procedure LoadOWM(filename:commonstring);
 var
  mapfile:file of MapRec;
  c1,c2,c3:byte;
 begin

  if (MapWarpLUT=nil) then new(MapWarpLUT);
  if (OWM=nil) then new(OWM);
  assign(mapfile,filename+'.map');
  reset(mapfile);
  if IOResult=0 then
   begin
    read(mapfile,owm^);
    if IOResult<>0 then writeln(DebugFile,'Error reading '+filename);
    close(mapfile);
   end
  else writeln(DebugFile,'File not found '+filename);
 for c1:=0 to 179 do
  for c2:=0 to 179 do
   begin
    if (owm^.forth[c1,c2]<(Num_of_Map_Warps+1)) and (owm^.forth[c1,c2]>5) then
     begin
      MapWarpLUT^[owm^.forth[c1,c2]].x:=c1;
      MapWarpLUT^[owm^.forth[c1,c2]].y:=c2
     end;
   end;

   {set up NPCs starts here}
      For c1:=0 to 179 do
      for c2:=0 to 179 do                             {qwerty}
       begin
        if (OWM^.forth[c1,c2]>193) and (OWM^.forth[c1,c2]<194+NUM_Of_NPCs) then
         begin
          if NPCs[OWM^.forth[c1,c2]-194]=NIL then
          new(NPCs[OWM^.forth[c1,c2]-194]);
          NPCs[OWM^.forth[c1,c2]-194]^.x:=c1;
          NPCs[OWM^.forth[c1,c2]-194]^.y:=c2;
          NPCs[OWM^.forth[c1,c2]-194]^.dir:=1;
          NPCs[OWM^.forth[c1,c2]-194]^.offset:=0;
          NPCs[OWM^.forth[c1,c2]-194]^.frame:=1;
          NPCs[OWM^.forth[c1,c2]-194]^.sprt:=OWM^.NPCMAPData[OWM^.forth[c1,c2]-194];
          if (NPCBitMaps[NPCs[OWM^.forth[c1,c2]-194]^.sprt][1]=nil) then
          LoadSprite(NPCBitMaps[NPCs[OWM^.forth[c1,c2]-194]^.sprt],
                     NPCs[OWM^.forth[c1,c2]-194]^.sprt);
         end;
    end;
   {set up NPCs ends here}

   {set up boxes starts}
      c3:=0;
      For c1:=0 to 179 do
      for c2:=0 to 179 do
       begin
        if c3<Num_Of_Boxes then
        if (OWM^.forth[c1,c2]=227) then
         begin
          If Boxes[c3]=Nil then new(boxes[c3]);
          Boxes[c3]^.x:=c1;
          Boxes[c3]^.y:=c2;
          Boxes[c3]^.dir:=1;
          Boxes[c3]^.offset:=0;
          inc(c3);
         end;
    end;
   {set up boxes ends}

 end;
Procedure LoadMapTiles(filename:commonstring);
 var
  c1,c2,c3:byte;
  bklfile:file of smallbtm;
  temp:integer;
  totals:array[0..255] of byte;
 begin

  for c1:=0 to (Num_of_SmallBits-1) do
  begin
   if MapTiles[c1]=nil then new(MapTiles[c1]);
  end;
  assign(bklfile,filename+'.set');
  reset(bklfile);
  if IOResult=0 then
   begin
    for c1:=0 to (Num_of_SmallBits-1) do
     begin
     if IOResult=0 then
     read(bklfile,MapTiles[c1]^)
     else writeln(DebugFile,'Error reading from '+filename+'.set');
     end;
    close(bklfile);
   end
  else writeln(debugfile,'Error opening file '+filename+'.set');


  if TileLUT=nil then new(TileLUT);
  for c1:=0 to Num_of_SmallBits-1 do {This loop sets TilLUT[X] to the}
   begin                             {most common pixel in Maptile[x]}
     for c2:=0 to 255 do totals[c2]:=0;
     for c2:=0 to 19 do
       for c3:=0 to 19 do
        begin
         inc(totals[MapTiles[c1]^[c2][c3]]);
        end;
    c3:=0;
    for c2:=0 to 255 do if totals[c2]>totals[c3] then c3:=c2;
    TileLUT^[c1]:=c3;
   end;


 end;

Procedure KillSprite(var who:spriteframes);
 var
  c1:byte;
 begin
  for c1:=0 to 11 do
  begin
    if (who[c1]<>nil) then
     begin
      dispose(who[c1]);
      who[c1]:=nil;
     end;
  end;

 end;

Procedure KillOWM;
 var
  c3:byte;
 begin
  if (MapWarpLUT<>nil) then Dispose(MapWarpLUT);
  MapWarpLUT:=nil;
  if OWM<>nil then Dispose(OWM);
  OWM:=Nil;
  KillAllBoxes;
  KillAllNPCSprites;
                               {
  for c3:=0 to NUM_Of_NPCs-1 do
   killsprite(NPCBitMaps[c3]);  }
  for c3:=0 to NUM_Of_NPCs-1 do
   if NPCs[c3]<>NIL then
    begin
     dispose(NPCs[c3]);
     NPCs[c3]:=NIL;
    end;

 end;

Procedure KillMapTiles;
 var
  c1:byte;
 begin
  for c1:=0 to (Num_of_SmallBits-1) do
  begin
  if MapTiles[c1]<>nil then Dispose(MapTiles[c1]);
  MapTiles[c1]:=nil;
  end;
  if TileLUT<>nil then
   begin
    dispose(TileLUT);
    tileLUT:=NIL;
   end;

 end;

Procedure ChangeMap(wich:byte);
 var
 c1,c2:byte;
 begin
  {turn any tree clipping off}
  GlobalStats^.c1cut:=20;
  GlobalStats^.c2cut:=20;
  GlobalStats^.c3cut:=20;
  GlobalStats^.c1height:=5;
  GlobalStats^.c2height:=5;
  GlobalStats^.c3height:=5;
  GlobalStats^.Map:=wich;
  killowm;
  LoadOWM(maplut^.mapname[GlobalStats^.Map]);
  KillMapTiles;
  LoadMaptiles(maplut^.tileset[GlobalStats^.Map]);
  GlobalStats^.c2dir:=GlobalStats^.c1dir;
  GlobalStats^.c3dir:=GlobalStats^.c1dir;
  GlobalStats^.c1offset:=20;
  if GlobalStats^.c1dir=1 then
   for c1:=0 to 179 do
   for c2:=0 to 179 do
    begin
     if owm^.forth[c1,c2]=3 then
      begin
       GlobalStats^.c1x:=c1;
       GlobalStats^.c1y:=c2;
       GlobalStats^.c2x:=c1;
       GlobalStats^.c2y:=c2-1;
       GlobalStats^.c3x:=c1;
       GlobalStats^.c3y:=c2-1;
       c1:=179;
       c2:=179;
      end;
    end
  else if GlobalStats^.c1dir=2 then
   for c1:=0 to 179 do
   for c2:=0 to 179 do
    begin
     if owm^.forth[c1,c2]=2 then
      begin
       GlobalStats^.c1x:=c1;
       GlobalStats^.c1y:=c2;
       GlobalStats^.c2x:=c1-1;
       GlobalStats^.c2y:=c2;
       GlobalStats^.c3x:=c1-1;
       GlobalStats^.c3y:=c2;
       c1:=179;
       c2:=179;
      end;
    end
  else if GlobalStats^.c1dir=3 then
   for c1:=0 to 179 do
   for c2:=0 to 179 do
    begin
     if owm^.forth[c1,c2]=5 then
      begin
       GlobalStats^.c1x:=c1;
       GlobalStats^.c1y:=c2;
       GlobalStats^.c2x:=c1;
       GlobalStats^.c2y:=c2+1;
       GlobalStats^.c3x:=c1;
       GlobalStats^.c3y:=c2+1;
       c1:=179;
       c2:=179;
      end;
    end
  else if GlobalStats^.c1dir=4 then
   for c1:=0 to 179 do
   for c2:=0 to 179 do
    begin
     if owm^.forth[c1,c2]=4 then
      begin
       GlobalStats^.c1x:=c1;
       GlobalStats^.c1y:=c2;
       GlobalStats^.c2x:=c1+1;
       GlobalStats^.c2y:=c2;
       GlobalStats^.c3x:=c1+1;
       GlobalStats^.c3y:=c2;
       c1:=179;
       c2:=179;
      end;
    end;
  end;

Procedure ExitMap;
 var
  c1,c2,fromap:byte;
 begin
  {turn any tree clipping off}
  GlobalStats^.c1cut:=20;
  GlobalStats^.c2cut:=20;
  GlobalStats^.c3cut:=20;
  fromap:=GlobalStats^.Map;
  GlobalStats^.Map:=maplut^.mapfrom[GlobalStats^.Map];
  killowm;
  LoadOWM(maplut^.mapname[GlobalStats^.Map]);
  KillMapTiles;
  LoadMaptiles(maplut^.tileset[GlobalStats^.Map]);
  GlobalStats^.c1offset:=20;
   for c1:=0 to 179 do
   for c2:=0 to 179 do
    begin
     if owm^.forth[c1,c2]=fromap then
      begin
       GlobalStats^.c1x:=c1;
       GlobalStats^.c1y:=c2;
       GlobalStats^.c2x:=c1;
       GlobalStats^.c2y:=c2;
       GlobalStats^.c3x:=c1;
       GlobalStats^.c3y:=c2;
       c1:=179;
       c2:=179;
      end;
    end;
  if GlobalStats^.c1dir=1 then inc(GlobalStats^.c1y)
  else if GlobalStats^.c1dir=2 then inc(GlobalStats^.c1x)
  else if GlobalStats^.c1dir=3 then dec(GlobalStats^.c1y)
  else if GlobalStats^.c1dir=4 then dec(GlobalStats^.c1x)
 end;


procedure init_maplut;
 begin
  {mapname:array[128..192] of commonstring;}
  {mapfrom:array[128..192] of commonstring;}
  {tileset:array[128..192] of commonstring;}
  new(maplut);
  {-=}
   maplut^.mapname[127]:='over'{'demo01'};  {starting map}
   maplut^.mapfrom[127]:=127;
   maplut^.tileset[127]:='over';
  {-=}
   maplut^.mapname[128]:='talibah';
   maplut^.mapfrom[128]:=127;
   maplut^.tileset[128]:='viltown';
  {-=}
   maplut^.mapname[129]:='ind1';
   maplut^.mapfrom[129]:=127;
   maplut^.tileset[129]:='indtown';
  {-=}
   maplut^.mapname[130]:='cas6-25';
   maplut^.mapfrom[130]:=127;
   maplut^.tileset[130]:='cas6-25';
     {-=}
   maplut^.mapname[131]:='monk';
   maplut^.mapfrom[131]:=127;
   maplut^.tileset[131]:='monk';
     {-=}
   maplut^.mapname[132]:='fortown';
   maplut^.mapfrom[132]:=127;
   maplut^.tileset[132]:='fortown';
     {-=}
   maplut^.mapname[133]:='viltown';{6}
   maplut^.mapfrom[133]:=127;
   maplut^.tileset[133]:='viltown';{6}
     {-=}
   maplut^.mapname[134]:='destown';
   maplut^.mapfrom[134]:=127;
   maplut^.tileset[134]:='destown';
     {-=}
   maplut^.mapname[135]:='caventer';
   maplut^.mapfrom[135]:=127;
   maplut^.tileset[135]:='caventer';
     {-=}
   maplut^.mapname[136]:='talcas';{9}
   maplut^.mapfrom[136]:=127;
   maplut^.tileset[136]:='cas4-2';

   maplut^.mapname[137]:='ice';{10}
   maplut^.mapfrom[137]:=127;
   maplut^.tileset[137]:='ice';
    {-=}
   maplut^.mapname[138]:='monk';{11}
   maplut^.mapfrom[138]:=127;
   maplut^.tileset[138]:='monk';


 end;
Procedure kill_maplut;
 begin
  dispose(maplut);
 end;
Procedure LoadObjects;
 var
  c1:byte;
  bklfile:file of smallbtm;

 begin
  for c1:=0 to 11 do
  if (ObjBitMaps[c1]=Nil) then new(ObjBitMaps[c1]);

  assign(bklfile,Objects_FileName);
  reset(bklfile);
  if IOResult=0 then
    begin
      for c1:=0 to 11 do
       if not(eof(bklfile)) then Read(bklFile,ObjBitMaps[c1]^);
       close(bklfile);
    end
   else
    begin
     writeln(debugfile,'Error opening '+Objects_Filename);
     {The file wasn't found!}
    end;

 end;
Procedure KillObjects;
 var
  c1:byte;
 begin
  for c1:=0 to 11 do
  If (ObjBitMaps[c1]<>Nil) then
   begin
    dispose(ObjBitMaps[c1]);
    ObjBitMaps[c1]:=Nil;
   end;
 end;

                       {
Procedure init_spriteslut;
 begin
  assign(SpriteLutFile,SpriteLUT_FileName);
  reset(SpriteLUTFile);
  if IOResult<>0 then
   Writeln('ERROR! ',SpriteLUT_FileName,' Not Found!!!')
  else
   writeln(SpriteLUT_FileName,' open...');
 end;
Procedure Kill_SpritesLut;
 begin
  close(SpriteLutFile);
  writeln(SpriteLUT_FileName,' closed...');
 end;                   }
Procedure OpenDebugFile;
 begin
  Write('Creating Debug File "debug.txt"');
  Assign(DebugFile,'Debug.Txt');
  Rewrite(DebugFile);
  if IoResult=0 then writeln(' ok ') else writeln(' Failed');
 end;
Procedure CloseDebugFile;
 begin
  Close(DebugFile);
    if IOResult=0 then
     begin
      Writeln('Closed Debug File "debug.txt"');
     end;
 end;

Procedure LoadTextBlock(wich:byte;filename:string);
 begin
 words^[0]:='                                      ';
 words^[1]:='                                      ';
 words^[2]:=' nothing at all                       ';
 words^[3]:='                                      ';
 words^[4]:='                                      ';
 assign(SpriteTextFile,filename);
 reset(SpriteTextFile);
 if IOResult=0 then
  begin
     seek(SpriteTextFile,wich);
     if IOResult=0 then
       begin
       read(SpriteTextFile,words^);
       IF IOResult<>0 then
          begin
          Writeln(debugfile,'Error reading record ',wich,' in file '+filename);
          words^[0]:='                                      ';
          words^[1]:='                                      ';
          words^[2]:=' error seeking!                       ';
          words^[3]:='                                      ';
          words^[4]:='                                      ';
          end;
       end
    else Writeln(debugfile,'Error seeking record ',wich,' in file '+filename);
    close(SpriteTextFile);
  end
 else Writeln(debugfile,'Error opening file '+filename);
 end;

Function Item_Name(which:byte):commonstring;
 begin
  if which=0 then Item_Name:='Herbs'
  else if which=1 then Item_Name:='Potion'
  else if which=2 then Item_Name:='Elixer'
  else if which=3 then Item_Name:='Grn Vile'
  else if which=4 then Item_Name:='Blu Vile'
  else if which=5 then Item_Name:='Cape'
  else if which=6 then Item_Name:='Thread'
  else if which=7 then Item_Name:='Water'
  else if which=8 then Item_Name:='Strength'
  else if which=9 then Item_Name:='9'
  else if which=10 then Item_Name:='10'
  else if which=11 then Item_Name:='11'
  else if which=12 then Item_Name:='12'
  else if which=13 then Item_Name:='13'
  else if which=14 then Item_Name:='14'
  else if which=15 then Item_Name:='15'
  else if which=16 then Item_Name:='16'
  else if which=17 then Item_Name:='17'
  else if which=18 then Item_Name:='18'
  else if which=19 then Item_Name:='19'
  else Item_Name:='Undef';
 end;

Function Item_Power(which:byte):byte;
 begin
  if which=0 then Item_Power:=1
  else Item_Power:=0;
 end;


begin
end.