Unit Fonts;
Interface
uses graphics,crt;
type
 ScreenWidthText=String[38];
 StoryTextBlock=Array[0..5]  of ScreenWidthText;
 STBPtr=^StoryTextBlock;

 Color_7x9_Let=array[0..6,0..8] of byte;
 Color_7x9_Set=Array[32..126] of Color_7x9_Let;
 Color_7x8_Let=array[0..6,0..7] of byte;
 Color_7x8_Set=Array[32..126] of Color_7x8_Let;
 BW_26x22_Let=Array[0..25,0..21] of byte;
 BW_26x22_Set=Array[32..126] of BW_26x22_Let;
 BW_9x9_Let=Array[0..8,0..8] of boolean;
 BW_9x9_Set=Array[32..126] of BW_9x9_Let;
var
 Font1:^Color_7x9_Set;
 Font2:^BW_26x22_Set;
 Font3:^BW_9x9_Set;
 Font4:^Color_7x8_Set;

Procedure OutTextXyNorm1(x,y,base:integer;What:string);
Procedure OutTextXyRange1(x,y,base:integer;What:string);
Procedure OutTextXy3d1(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
Procedure OutTextXyNORM2(x,y,col:integer;What:string);
Procedure OutTextXyBW2(x,y,col:integer;What:string);
Procedure OutTextXyWide2(x,y,col:integer;What:string);
Procedure OutTextXyDep2(x,y,base:integer;What:string);
Procedure OutTextXy3d2(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
Procedure OutTextXyNorm3(x,y,col:integer;What:string);
Procedure OutTextXyWide3(x,y,col:integer;What:string);
Procedure OutTextXy3d3(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
Procedure OutTextXyDep3(x,y,base:integer;What:string);
Procedure OutTextXyNorm4(x,y,base:integer;What:string);
Procedure OutTextXy3d4(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
Procedure OutTextXyChoise(x,y,col:integer;What:String);

Procedure KillFont1;
Procedure LoadFont1;
Procedure LoadFont2;
Procedure KillFont2;
Procedure LoadFont3;
Procedure KillFont3;
Procedure LoadFont4;
Procedure KillFont4;
Implementation
Procedure PutLetRange1(X,Y,base:integer;Let:char);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 6 do
  for c2:=0 to 8 do
   if Font1^[ord(let)][c1][c2]<>0 then
   if ((x+c1)>-1) and ((x+c1)<320) and ((y+c2)>-1) and ((y+c2)<200) then
   putpixel(x+c1,y+c2,Font1^[ord(let)][c1][c2]+base-1);
 end;
Procedure PutLetNorm4(X,Y,base:integer;Let:char);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 6 do
  for c2:=0 to 7 do
   if Font4^[ord(let)][c1][c2]<>0 then
   putpixel(x+c1,y+c2,Font4^[ord(let)][c1][c2]+base-1);
 end;
Procedure PutLetNorm1(X,Y,base:integer;Let:char);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 6 do
  for c2:=0 to 8 do
   if Font1^[ord(let)][c1][c2]<>0 then
   putpixel(x+c1,y+c2,Font1^[ord(let)][c1][c2]+base-1);
 end;
Procedure OutTextXyRange1(x,y,base:integer;What:string);
 var
  c1,c2:byte; begin
  for c1:=1 to length(What) do
   begin
   PutLetRange1(x+(c1-1)*8,y,base,what[c1]);
   end;
 end;
Procedure OutTextXyNorm1(x,y,base:integer;What:string);
 var
  c1,c2:byte; begin
  for c1:=1 to length(What) do
   begin
   PutLetNorm1(x+(c1-1)*8,y,base,what[c1]);
   end;
 end;
Procedure OutTextXyNorm4(x,y,base:integer;What:string);
 var
  c1,c2:byte; begin
  for c1:=1 to length(What) do
   begin
   PutLetNorm4(x+(c1-1)*8,y,base,what[c1]);
   end;
 end;
Procedure OutTextXy3d4(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
 begin
  OutTextXyNorm4(x+1,y-1,hi,What);
  OutTextXyNorm4(x-1,y+1,lo,What);
  OutTextXyNorm4(x-1,y-1,VHi,What);
  OutTextXyNorm4(x+1,y+1,VLo,What);
  OutTextXyNorm4(x,y+1,Lo,What);
  OutTextXyNorm4(x+1,y,Lo,What);
  OutTextXyNorm4(x,y-1,Hi,What);
  OutTextXyNorm4(x-1,y,Hi,What);
  OutTextXyNorm4(x,y,Mid,What);
 end;
Procedure OutTextXyChoise(x,y,col:integer;What:String);
 begin
  OutTextXy3d1(x,y,6,5,col*3+10,2,1,What);
 end;
Procedure OutTextXy3d1(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
 begin
  OutTextXyNorm1(x+1,y-1,hi,What);
  OutTextXyNorm1(x-1,y+1,lo,What);
  OutTextXyNorm1(x-1,y-1,VHi,What);
  OutTextXyNorm1(x+1,y+1,VLo,What);
  OutTextXyNorm1(x,y+1,Lo,What);
  OutTextXyNorm1(x+1,y,Lo,What);
  OutTextXyNorm1(x,y-1,Hi,What);
  OutTextXyNorm1(x-1,y,Hi,What);
  OutTextXyNorm1(x,y,Mid,What);
 end;
Procedure OutTextXyNORM2(x,y,col:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-2;
  for c4:=1 to length(What) do
   begin
    ink:=true;
    c3:=c3+1;
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 25 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 21 do
       begin
        if Font2^[ord(what[c4])][c1][c2]<>0 then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,Font2^[ord(what[c4])][c1][c2]+col);
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXyBW2(x,y,col:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-2;
  for c4:=1 to length(What) do
   begin
    ink:=true;
    c3:=c3+1;
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 25 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 21 do
       begin
        if Font2^[ord(what[c4])][c1][c2]<>0 then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,col);
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXyWide2(x,y,col:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-2;
  for c4:=1 to length(What) do
   begin
    ink:=true;
    c3:=c3+2;
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 25 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 21 do
       begin
        if Font2^[ord(what[c4])][c1][c2]<>0 then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,col);
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXy3d2(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
 begin
  OutTextXyWide2(x+1,y-1,hi,What);
  OutTextXyWide2(x-1,y+1,lo,What);
  OutTextXyWide2(x-1,y-1,VHi,What);
  OutTextXyWide2(x+1,y+1,VLo,What);
  OutTextXyWide2(x,y+1,Lo,What);
  OutTextXyWide2(x+1,y,Lo,What);
  OutTextXyWide2(x,y-1,Hi,What);
  OutTextXyWide2(x-1,y,Hi,What);
  OutTextXyWide2(x,y,Mid,What);
 end;
Procedure OutTextXyDep2(x,y,base:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-2;
  for c4:=1 to length(What) do
   begin
    ink:=true;
    c3:=c3+1;
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 25 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 10 do
       begin
        if Font2^[ord(what[c4])][c1][c2]<>0 then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,base+c2);
         end;
        if Font2^[ord(what[c4])][c1][c2+11]<>0 then
         begin
          ink:=true;
          putpixel(x+c3,y+c2+11,base+(10-c2));
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXyNorm3(x,y,col:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-1;
  for c4:=1 to length(What) do
   begin
    ink:=true;{
    c3:=c3+1;  }
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 8 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 8 do
       begin
        if Font3^[ord(what[c4])][c1][c2] then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,col);
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXyWide3(x,y,col:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-1;
  for c4:=1 to length(What) do
   begin
    ink:=true;
    c3:=c3+2;
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 8 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 8 do
       begin
        if Font3^[ord(what[c4])][c1][c2] then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,col);
         end;
       end;
      end;
   end;
 end;
Procedure OutTextXy3d3(x,y,Vhi,hi,mid,lo,vlo:integer;What:String);
 begin
  OutTextXyWide3(x+1,y-1,hi,What);
  OutTextXyWide3(x-1,y+1,lo,What);
  OutTextXyWide3(x-1,y-1,VHi,What);
  OutTextXyWide3(x+1,y+1,VLo,What);
  OutTextXyWide3(x,y+1,Lo,What);
  OutTextXyWide3(x+1,y,Lo,What);
  OutTextXyWide3(x,y-1,Hi,What);
  OutTextXyWide3(x-1,y,Hi,What);
  OutTextXyWide3(x,y,Mid,What);
 end;
Procedure OutTextXyDep3(x,y,base:integer;What:string);
 var
  c1,c2:byte;
  c4,c3:Integer;
  ink:boolean;
 begin
  c3:=-1;
  for c4:=1 to length(What) do
   begin
    ink:=true;{
    c3:=c3+1;  }
    if what[c4]=(' ') then c3:=c3+5;
    for c1:=0 to 8 do
     begin
     if ink then c3:=c3+1;
     ink:=false;
      for c2:=0 to 4 do
       begin
        if Font3^[ord(what[c4])][c1][c2] then
         begin
          ink:=true;
          putpixel(x+c3,y+c2,base+c2);
         end;
        if Font3^[ord(what[c4])][c1][c2+4] then
         begin
          ink:=true;
          putpixel(x+c3,y+c2+4,base+(4-c2));
         end;
       end;
      end;
   end;
 end;
Procedure KillFont1;
 begin
  Dispose(Font1);
 end;
Procedure LoadFont1;
 var
  filez:file of Color_7x9_set;
 begin
  New(Font1);
  assign(Filez,'CL7X9.Fnt');
  reset(Filez);
  read(Filez,Font1^);
  Close(Filez);
 end;
Procedure KillFont2;
 begin
  Dispose(Font2);
 end;
Procedure LoadFont2;
 var
  filez:file of BW_26x22_Set;
 begin
  New(Font2);
  assign(Filez,'BW26X22.Fnt');
  reset(Filez);
  read(Filez,Font2^);
  Close(Filez);
 end;
Procedure KillFont3;
 begin
  Dispose(Font3);
 end;
Procedure LoadFont3;
 var
  filez:file of BW_9x9_Set;
 begin
  New(Font3);
  assign(Filez,'BW9x9.Fnt');
  reset(Filez);
  read(Filez,Font3^);
  Close(Filez);
 end;
Procedure KillFont4;
 begin
  Dispose(Font4);
 end;
Procedure LoadFont4;
 var
  filez:file of Color_7x8_set;
 begin
  New(Font4);
  assign(Filez,'CL7X8.Fnt');
  reset(Filez);
  read(Filez,Font4^);
  Close(Filez);
 end;
begin
end.