unit bitmaps;
interface
uses Graphics,Vars,crt,spx_tim;  {this unit uses fast clock number 3!}

Procedure LoadOverLay;
Procedure KillOverLay;
Procedure DrawOverLay;
Procedure DrawPanelDirect(y:byte); {panel is right side of overlay}
Procedure DrawPanel(y:byte);
Procedure PanelClose;
Procedure PanelUp;

Procedure LoadPopTxtBk;
Procedure KillPopTxtBk;
Procedure DrawPopTxtBk;

Procedure DrawGrid;{
Procedure PutHero;  }

Procedure PopLoadBacks;{this loads, draws, then unloads}

Procedure PutSmallBit(x,y:byte;Where:SmallBlock);
Procedure PutSmallBitFast(x,y:byte;Where:FastSmallBlock);
Procedure PutSmallBitfast2(x,y:byte;Where:fastSmallBlock);
Procedure PutSmallBitfaster(x,y:word; Where: SmallBtm);
procedure PutSmallTranBitFast(x, y : word; trans : byte; where : SmallBlock);
Procedure PutMediumBit(X,Y:byte);
Procedure DispGrdBuf(What:String);
Procedure DispFullBtmBuf(What:String);
Procedure DispFullBtmFull(What:String;Speed:byte);
implementation

{$I-}
Procedure PopLoadBacks;
 var
  LGB:LGBPtr;
  Temp:^LoadGridBackLine;
  c1,c2:Integer;
  Filez:File of LoadGridBack;
 begin
  new(LGB);
  assign(Filez,'LGB.GRD');
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Lgb^);
    for c2:=0 to 3 do
    for c1:=0 to 29 do
     begin
      Temp:=Addr(TheScreen^[50+(c1+5+(c2*40))*320]);
      Temp^:=LGB^[c1];
     end;
   end;
  Dispose(LGB);
 end;
Procedure DispGrdBuf(What:String);
 var
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    TheScreen^:=Temp^.Screen;
   end;
  Dispose(Temp);
 end;
Procedure DispFullBtmBuf(What:String);
 var
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    TheScreen^:=Temp^.Screen;
    for c1:=0 to 255 do
    ASetRgbPAlette(c1,Temp^.Pal[c1].R,Temp^.Pal[c1].g,Temp^.Pal[c1].b);
   end;
  Dispose(Temp);
 end;
Procedure DispFullBtmFull(What:String;Speed:byte);
 var
  p:pointer;
  Temp:^BtmRec;
  Filez:File of BtmRec;
  c1:integer;
 begin
  new(temp);
  Assign(Filez,What);
  reset(Filez);
  If IOResult=0 then
   begin
    Read(Filez,Temp^);
    Close(Filez);
    for c1:=0 to 255 do
      asetrgbpalette(c1,0,0,0);
    TheRealScreen^:=Temp^.Screen;
    FadeIn(Speed,Temp^.Pal);
     While keypressed do readkey;
     readkey;
     FadeOut(Speed);
   end;
  Dispose(Temp);
 end;
Procedure LoadPopTxtBk;
 var
  filez:file of Pop_Text_background;
 begin
  New(Const_Game_Vars.PopBack);
  Assign(Filez,'PopTxtBk.Grd');
  reset(Filez);
  read(Filez,Const_Game_Vars.PopBack^);
  close(Filez);
 end;
Procedure KillPopTxtBk;
 begin
  Dispose(Const_Game_Vars.PopBack);
 end;
Procedure LoadOverLay;
 var
  filez:file of OverLayType;
 begin
  New(Const_Game_Vars.OverLay);
  Assign(Filez,'OverLay.Grd');
  reset(Filez);
  read(Filez,Const_Game_Vars.OverLay^);
  close(Filez);
 end;
Procedure KillOverLay;
 begin
  Dispose(Const_Game_Vars.OverLay);
 end;                               {
Procedure PutHero;
 var
  c1,c2:byte;
  c3:integer;
 begin
    c3:=100+32000;
    for c2:=20 to 39 do
     begin
       for c1:=0 to 19 do
        begin
         if hero.bitmaps[hero.frame].Bitmap^[c2][c1]<>0 then {
     putpixel(c1+100,c2+80,hero.bitmaps[hero.frame].Bitmap^[c2][c1]);  }{
          TheScreen^[c3]:=hero.bitmaps[hero.frame].Bitmap^[c2][c1];
          c3:=c3+1;
         end;
        c3:=c3+300;
     end;
 end;    }
Procedure DrawBack;
 var
  temp:^BackGroundLine;
  c1:byte;
  c3:integer;
 begin
  for c1:=20 to 179 do
   begin
    temp:=Addr(TheScreen^[20+c1*320]);
    Temp^:=CurrentBG^[c1-20];
   end;
 end;
Procedure DrawGrid;
 var
  c1,c2,c3:integer;
  p1:^OLT1;
  p2:^OLT2;
 begin
  if hero.offset>0 then
  begin
  if hero.dir=3 then
  for c1:=1 to 9 do
  for c2:=1 to 9 do
   begin                                             {
    if OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]<>0 then }
    PutSmallBitFaster(c1*20,c2*20-hero.offset,Const_Game_Vars.SmallBitMAps[OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]]^);
  end
  else if hero.dir=4 then
  for c1:=1 to 10 do
  for c2:=1 to 8 do
   begin                                               {
    if OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]<>0 then   }
    PutSmallBitFaster(c1*20-hero.offset,c2*20,Const_Game_Vars.SmallBitMAps[OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]]^);
  end
  else if hero.dir=1 then
  for c1:=1 to 9 do
  for c2:=0 to 8 do
   begin                                             {
    if OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]<>0 then }
    PutSmallBitFaster(c1*20,c2*20+hero.offset,Const_Game_Vars.SmallBitMAps[OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]]^);
  end
  else if hero.dir=2 then
  for c1:=0 to 9 do
  for c2:=1 to 8 do
   begin                                             {
    if OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]<>0 then }
    PutSmallBitFaster(c1*20+hero.offset,c2*20,Const_Game_Vars.SmallBitMAps[OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]]^);
  end
  end
  else
  for c1:=1 to 9 do
  for c2:=1 to 8 do
   begin                                             {
    if OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]<>0 then }
    PutSmallBitFaster(c1*20,c2*20,Const_Game_Vars.SmallBitMAps[OWM^.back[c1+(hero.x-5),c2+(hero.y-5)]]^);
  end;                                 {
  for c1:=0 to 10 do
   begin
    PutSmallBit(c1*20,0,SmallBitMAps[2]);
    PutSmallBit(c1*20,180,SmallBitMAps[2]);
   end;
  for c1:=1 to 8 do
   begin
    PutSmallBit(0,c1*20,SmallBitMAps[2]);
    PutSmallBit(200,c1*20,SmallBitMAps[2]);
   end;                                 }{
   puthero;                               }
                                                          {
   PutSmallTranBitFast(80,100,0,hero.bitmaps[hero.frame]);
   PutSmallTranBitFast(120,100,0,hero.bitmaps[hero.frame]);
   PutSmallTranBitFast(100,80,0,hero.bitmaps[hero.frame]);
   PutSmallTranBitFast(100,120,0,hero.bitmaps[hero.frame]);}
   PutSmallTranBitFast(100,100,0,hero.bitmaps[hero.frame]);
   {
   PutSmallTranBitFast(100,100,0,Const_Game_Vars.SmallBitMAps[1]);}

                                    {
    c3:=100+32000;
    for c2:=20 to 39 do
     begin
       for c1:=0 to 19 do
        begin
         if hero.bitmaps[hero.frame].Bitmap^[c2][c1]<>0 then
          TheScreen^[c3]:=hero.bitmaps[hero.frame].Bitmap^[c2][c1];
          c3:=c3+1;
         end;
        c3:=c3+300;
     end;                            }
                   {
    for c1:=0 to 19 do
    for c2:=20 to 39 do
    if hero.bitmaps[hero.frame].Bitmap^[c2][c1]<>0 then
    putpixel(c1+100,c2+80,hero.bitmaps[hero.frame].Bitmap^[c2][c1]);}

    {
    PutSmallBit(100,80,SmallBitMAps[1]);
    PutSmallBit(100,100,SmallBitMAps[1]);                           }


  for c1:=0 to 19 do
   begin
    p1:=addr(TheScreen^[c1*320]);
    p1^:=Const_Game_Vars.OverLay^.Top[c1];
    p1:=addr(TheScreen^[(c1+180)*320]);
    p1^:=Const_Game_Vars.OverLay^.Bot[c1];
   end;
  for c1:=20 to 179 do
   begin
    P2:=addr(TheScreen^[c1*320]);
    p2^:=Const_Game_Vars.OverLay^.Left[c1];
    P2:=addr(TheScreen^[c1*320+200]);
    p2^:=Const_Game_Vars.OverLay^.Right[c1];
   end;

         {
   DrawPanel; }
 end;
Procedure DrawPopTxtBk;
 var
  c2:byte;
  temp:^Pop_Text_line;
 begin
   for c2:=59 downto 0 do
    begin
     temp:=addr(TheScreen^[(5)+(c2+140)*320]);
     temp^:=Const_Game_Vars.popback^[c2];
    end;
 end;
Procedure DrawOverLay;
 var
  c1:byte;
  p1:^OLT1;
  p2:^OLT2;
 begin
  for c1:=0 to 19 do
   begin
    p1:=addr(TheScreen^[c1*320]);
    p1^:=Const_Game_Vars.OverLay^.Top[c1];
    p1:=addr(TheScreen^[(c1+180)*320]);
    p1^:=Const_Game_Vars.OverLay^.Bot[c1];
   end;
  for c1:=20 to 179 do
   begin
    P2:=addr(TheScreen^[c1*320]);
    p2^:=Const_Game_Vars.OverLay^.Left[c1];
    P2:=addr(TheScreen^[c1*320+200]);
    p2^:=Const_Game_Vars.OverLay^.Right[c1];
   end;     
 end;
Procedure DrawPanel(y:byte);
 var
  c1:byte;
  p3:^OLT3;
 begin
  For c1:=0 to 199-y do
   begin
    p3:=addr(TheScreen^[(c1+y)*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[c1];
   end;
 end;
Procedure PanelClose;
 var
  c1,c2:byte;
  p3:^OLT3;
  p4:^OLT3;
 begin
  new(p4);
  for c1:=0 to 99 do
  p4^[c1]:=0;                         {timer used here}

   F_Clk[3]:=3;
  for c2:=5 to 99 do
  begin
   repeat
   until F_clk[3]=0;
   F_Clk[3]:=3;
  for c1:=1 to 4 do
   begin
    p3:=addr(TheRealScreen^[(c2-c1)*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[5-c1];

    p3:=addr(TheRealScreen^[(199-(c2-c1))*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[199-(5-c1)];
   end;

    p3:=addr(TheRealScreen^[(199-(c2-5))*320+220]);
    p3^:=p4^;

    p3:=addr(TheRealScreen^[(c2-5)*320+220]);
    p3^:=p4^;
   end;
   dispose(p4);
 end;
Procedure PanelUp;
 var
  c1,c2:byte;
  p3:^OLT3;
  p4:^OLT3;
 begin
   F_Clk[3]:=3;                       {timer used here}
  for c2:=99 downto 5 do
  begin
   repeat
   until F_clk[3]=0;
   F_Clk[3]:=3;
  for c1:=1 to 5 do
   begin
    p3:=addr(TheRealScreen^[(c2-c1)*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[5-c1];

    p3:=addr(TheRealScreen^[(199-(c2-c1))*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[199-(5-c1)];
   end;
    p4:=addr(TheScreen^[(199-c2)*320+220]);
    p3:=addr(TheRealScreen^[(199-c2)*320+220]);
    p3^:=p4^;

    p4:=addr(TheScreen^[(c2)*320+220]);
    p3:=addr(TheRealScreen^[(c2)*320+220]);
    p3^:=p4^;
   end;
 end;

Procedure DrawPanelDirect(y:byte);
 var
  c1:byte;
  p3:^OLT3;
 begin
  For c1:=0 to 199-y do
   begin
    p3:=addr(TheRealScreen^[(c1+y)*320+220]);
    p3^:=Const_Game_Vars.OverLay^.Panel[c1];
   end;
 end;
Procedure PutSmallBit(x,y:byte;Where:SmallBlock);
 var
  c1:byte;
  temp:HBASmallPoint;
 begin
    temp:=Addr(TheScreen^[x+(y)*320]);
    temp^:=Where^[0];
    temp:=Addr(TheScreen^[x+(y+1)*320]);
    temp^:=Where^[1];
    temp:=Addr(TheScreen^[x+(y+2)*320]);
    temp^:=Where^[2];
    temp:=Addr(TheScreen^[x+(y+3)*320]);
    temp^:=Where^[3];
    temp:=Addr(TheScreen^[x+(y+4)*320]);
    temp^:=Where^[4];
    temp:=Addr(TheScreen^[x+(y+5)*320]);
    temp^:=Where^[5];
    temp:=Addr(TheScreen^[x+(y+6)*320]);
    temp^:=Where^[6];
    temp:=Addr(TheScreen^[x+(y+7)*320]);
    temp^:=Where^[7];
    temp:=Addr(TheScreen^[x+(y+8)*320]);
    temp^:=Where^[8];
    temp:=Addr(TheScreen^[x+(y+9)*320]);
    temp^:=Where^[9];
    temp:=Addr(TheScreen^[x+(y+10)*320]);
    temp^:=Where^[10];
    temp:=Addr(TheScreen^[x+(y+11)*320]);
    temp^:=Where^[11];
    temp:=Addr(TheScreen^[x+(y+12)*320]);
    temp^:=Where^[12];
    temp:=Addr(TheScreen^[x+(y+13)*320]);
    temp^:=Where^[13];
    temp:=Addr(TheScreen^[x+(y+14)*320]);
    temp^:=Where^[14];
    temp:=Addr(TheScreen^[x+(y+15)*320]);
    temp^:=Where^[15];
    temp:=Addr(TheScreen^[x+(y+16)*320]);
    temp^:=Where^[16];
    temp:=Addr(TheScreen^[x+(y+17)*320]);
    temp^:=Where^[17];
    temp:=Addr(TheScreen^[x+(y+18)*320]);
    temp^:=Where^[18];
    temp:=Addr(TheScreen^[x+(y+19)*320]);
    temp^:=Where^[19];
                      {
  for c1:=0 to 19 do
   begin
    temp:=Addr(TheScreen^[x+(y+c1)*320]);
    temp^:=Where^[c1];
   end;                }
 end;
Procedure PutSmallBitfast2(x,y:byte;Where:fastSmallBlock);
 var
  c1:byte;
  temp:fastHBASmallPoint;
 begin
    temp:=Addr(TheScreen^[x+(y)*320]);
    temp^:=Where^[0];
    temp:=Addr(TheScreen^[x+(y+1)*320]);
    temp^:=Where^[1];
    temp:=Addr(TheScreen^[x+(y+2)*320]);
    temp^:=Where^[2];
    temp:=Addr(TheScreen^[x+(y+3)*320]);
    temp^:=Where^[3];
    temp:=Addr(TheScreen^[x+(y+4)*320]);
    temp^:=Where^[4];
    temp:=Addr(TheScreen^[x+(y+5)*320]);
    temp^:=Where^[5];
    temp:=Addr(TheScreen^[x+(y+6)*320]);
    temp^:=Where^[6];
    temp:=Addr(TheScreen^[x+(y+7)*320]);
    temp^:=Where^[7];
    temp:=Addr(TheScreen^[x+(y+8)*320]);
    temp^:=Where^[8];
    temp:=Addr(TheScreen^[x+(y+9)*320]);
    temp^:=Where^[9];
    temp:=Addr(TheScreen^[x+(y+10)*320]);
    temp^:=Where^[10];
    temp:=Addr(TheScreen^[x+(y+11)*320]);
    temp^:=Where^[11];
    temp:=Addr(TheScreen^[x+(y+12)*320]);
    temp^:=Where^[12];
    temp:=Addr(TheScreen^[x+(y+13)*320]);
    temp^:=Where^[13];
    temp:=Addr(TheScreen^[x+(y+14)*320]);
    temp^:=Where^[14];
    temp:=Addr(TheScreen^[x+(y+15)*320]);
    temp^:=Where^[15];
    temp:=Addr(TheScreen^[x+(y+16)*320]);
    temp^:=Where^[16];
    temp:=Addr(TheScreen^[x+(y+17)*320]);
    temp^:=Where^[17];
    temp:=Addr(TheScreen^[x+(y+18)*320]);
    temp^:=Where^[18];
    temp:=Addr(TheScreen^[x+(y+19)*320]);
    temp^:=Where^[19];
                      {
  for c1:=0 to 19 do
   begin
    temp:=Addr(TheScreen^[x+(y+c1)*320]);
    temp^:=Where^[c1];
   end;                }
 end;
Procedure PutSmallBitFastbak(x,y:byte;Where:FastSmallBlock);
 var
  c1:integer;
  temp:FastHBASmallPoint;
 begin
    c1:=x+(y*320);
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[0];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[1];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[2];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[3];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[4];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[5];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[6];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[7];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[8];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[9];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[10];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[11];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[12];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[13];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[14];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[15];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[16];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[17];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[18];

    c1:=c1+320;
    temp:=Addr(TheScreen^[c1]);
    temp^:=Where^[19];

                      {
  for c1:=0 to 19 do
   begin
    temp:=Addr(TheScreen^[x+(y+c1)*320]);
    temp^:=Where^[c1];
   end;                }
 end;                                                                  {
Procedure PutSmallBitfaster(x,y:word; Where:fastSmallBlock); assembler; }
procedure PutSmallBitFaster (x, y : word; where : SmallBtm); assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   cx,0014h
@copyloop:
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  movsw
  add   di,300
  loop  @copyloop
  pop   ds
end;


procedure PutSmallTranBitFast(x, y : word; trans : byte; where : SmallBlock);
assembler;

asm
  push  ds
  les   di,[TheScreen]
  mov   ax,[y]
  shl   ax,6
  mov   si,ax
  shl   ax,2
  add   si,ax
  add   si,[x]
  add   di,si
  lds   si,[where]
  cld
  mov   bl,[trans]
  mov   cx,0014h
@lineloop:
  push  cx
  mov   cx,000ah
@rowloop:
  lodsw
  mov   dx,word ptr es:[di]
  cmp   al,bl
  je    @1
  mov   dl,al
@1:
  cmp   ah,bl
  je    @2
  mov   dh,ah
@2:
  xchg  dx,ax
  stosw
  loop  @rowloop

  pop   cx
  add   di,300
  loop  @lineloop

  pop   ds
end;



Procedure PutSmallBitFast(x,y:byte;Where:FastSmallBlock);
 var
  c1:integer;
  temp:FastHBASmallPoint;
 begin
    c1:=x+(y*320);
    move(Where^[0],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[1],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[2],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[3],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[4],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[5],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[6],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[7],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[8],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[9],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[10],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[11],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[12],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[13],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[14],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[15],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[16],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[17],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[18],TheScreen^[c1],20);
    c1:=c1+320;
    move(Where^[19],TheScreen^[c1],20);
 end;
Procedure PutMediumBit(X,Y:byte);
 begin
 end;
begin
end.