{S_CLK[3] reserved for keys!!!!!!!!!!!!}
{$I-}
{$B-}
{$G+}
program Game;
uses graphics,vars,bitmaps,fonts,mensys,multkeys,spx_tim,joystick,crt;

var c1:byte;

{This function returns the correct frame for
a walking sprite given its position on the
map and direction}
Function Frame(x,y,offset,dir:byte):byte;
 begin
  if dir=1 then
   begin
    frame:=1;
    if (offset>5)  and (offset<15) then
     begin
      if odd(y) then frame:=0 else frame:=2;
     end;
   end
  else if dir=2 then
   begin
    frame:=4;
    if (offset>5)  and (offset<15) then
     begin
      if odd(x) then frame:=3 else frame:=5;
     end;
   end
  else if dir=3 then
   begin
    frame:=7;
    if (offset>5)  and (offset<15) then
     begin
      if odd(y) then frame:=6 else frame:=8;
     end;
   end
  else
   begin
    frame:=10;
    if (offset>5)  and (offset<15) then
     begin
      if odd(x) then frame:=9 else frame:=11;
     end;
   end;
 end;

{This funtion rotates the color cycling for
5 blues and 5 reds}
Procedure MoveAni;
 var
  c1,t1,t2,t3,t4,t5,t6:byte;
 begin
  getrgbpalette(179,t4,t5,t6);
  for c1:=0 to 3 do
   begin
    getrgbpalette(c1+180,t1,t2,t3);
    asetrgbpalette(c1+179,t1,t2,t3);
   end;
  asetrgbpalette(183,t4,t5,t6);
  getrgbpalette(184,t4,t5,t6);
  for c1:=0 to 3 do
   begin
    getrgbpalette(c1+185,t1,t2,t3);
    asetrgbpalette(c1+184,t1,t2,t3);
   end;
  asetrgbpalette(188,t4,t5,t6);

 end;

{Standard Game's pallete}
Procedure SetUpPal;
 var
  c1,c2,c3:byte;
 begin
  for c1:=0 to 9 do
   asetrgbpalette(c1+64,c1*4+17,c1*4+17,c1*4+17);
  for c1:=0 to 9 do
   asetrgbpalette(c1+74,c1,c1*4+25,c1);
  for c1:=0 to 9 do
   asetrgbpalette(c1+84,c1,c1,c1*4+25);
  for c1:=0 to 9 do
   asetrgbpalette(c1+94,c1*3+30,c1*2+15,c1+7);
  for c1:=0 to 4 do
   asetrgbpalette(c1+104,c1*3+30,c1,c1);
  for c1:=0 to 1 do
   asetrgbpalette(c1+109,c1*3+7,c1*3+7,c1*3+10);
  for c1:=2 to 3 do
   asetrgbpalette(c1+109,c1*6+40,c1*6+40,63);
   asetrgbpalette(113,63,63,63);
  for c1:=0 to 2 do
   asetrgbpalette(c1+114,c1*6+15,c1*3+7,c1*2+2);
  for c1:=0 to 1 do
   asetrgbpalette(c1+117,23+c1*5,23+c1*5,35+c1*6);
  for c1:=0 to 4 do
   asetrgbpalette(c1+119,c1*5+35,c1*6+35,c1*2);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*5+35,c1*2,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*2,c1*5+35,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+129,c1*6+10,c1*3+4,c1*7+10);
  for c1:=0 to 4 do
   asetrgbpalette(c1+134,8+c1*3,4,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+139,4,8+c1*3,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+144,4,4,8+c1*3);
  for c1:=0 to 4 do
   asetrgbpalette(c1+149,c1*5+11,c1*5+15,c1*5+30);
  for c1:=0 to 4 do
   asetrgbpalette(c1+154,5+c1*2,5+c1*2,5+c1*2);
  for c1:=0 to 4 do
   asetrgbpalette(c1+159,c1*3+15,c1*2+7,c1+2);
  for c1:=0 to 4 do
   begin
    asetrgbpalette(c1+164,50-(c1*2),46-(c1*5),36-(c1*6));
   end;
  for c1:=0 to 4 do
   begin
    asetrgbpalette(c1+169,c1*2,c1*5,c1*4);
   end;

    asetrgbpalette(174,33,14,7);
    asetrgbpalette(175,30,11,5);
    asetrgbpalette(176,26,9,4);
  for c1:=0 to 2 do
   asetrgbpalette(c1+179,c1*5+46,c1*3+10,c1*2+10);
  for c1:=3 to 4 do
   asetrgbpalette(c1+179,(5-c1)*5+46,(5-c1)*3+10,(5-c1)*2+10);
  for c1:=0 to 2 do
   asetrgbpalette(c1+184,c1*2+5,c1*2+5,c1*5+35);
  for c1:=3 to 4 do
   asetrgbpalette(c1+184,(4-c1)*2+5,(4-c1)*2+5,(4-c1)*5+35);
 end;


Procedure Credits;
 var
  c1,c2,c3:byte;
  Temp:VirtScrPtr;
 begin
  FadeOut(20);
  ClearSCreen;
  PushScreen;
  DispFullBtmBuf('aseds.Btm');
  New(Temp);
  Temp^:=TheSCreen^;
  For c1:=1 to 5 do
   asetRgbPalette(c1,63-c1*7,63-c1*7,63-c1*2);
  For c1:=1 to 5 do
   asetRgbPalette(c1+5,63-(c1*8),63-(c1*4),63-(c1*9));
  For c1:=1 to 5 do
   asetRgbPalette(c1+10,63-(c1*2),63-(c1*7),63-(c1*7));
  PushFadeIn(20);


  c1:=0;
  while ButtonDown do;
  While Not(ButtonDown) do
   begin
    if c1<10 then
     begin
      c1:=c1+1;
      AsmPush(temp,TheScreen);
      OutTextXyRange1(40 ,15*c1,1,'This game is dedicated to:');
      OutTextXyRange1(60,17*c1,7,'        Amanda June Eldridge');
      PushScreen;
     end;
   end;

  While c1>0 do
   begin
     begin
      c1:=c1-1;
      AsmPush(temp,TheScreen);{
      TheScreen^:=Temp^;       }
      OutTextXyRange1(50 ,5*c1,11,'Production-');
      OutTextXyRange1(60 ,6*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,7*c1,1,'Scott Farrell');
      OutTextXyRange1(60 ,8*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,6*c1,6,'Zaskoda');{
      OutTextXyRange1(200,7*c1,6,'Neuro-XTC');
      OutTextXyRange1(200,8*c1,6,'ICEMAN');  }

      OutTextXyRange1(50 ,10*c1,11,'Art-');
      OutTextXyRange1(60 ,11*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,12*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,11*c1,6,'Zaskoda');       {
      OutTextXyRange1(200,12*c1,6,'IceMan');  }

      OutTextXyRange1(50 ,14*c1,11,'Code-');
      OutTextXyRange1(60 ,15*c1,1,'Scott Dudley');
      OutTextXyRange1(200,15*c1,6,'Zaskoda');
      PushScreen;
     end;
   end;
  FadeOut(20);
  Dispose(Temp);
  temp:=nil;
  While GlobalKeyDown do;
 end;

Function RUSure(text:string):boolean;
 type
  bufarray=array[0..98,0..29] of byte;
 var
  buffer:^bufarray;
  c1,c2,c3:byte;
  chosen:boolean;
  convar:byte;
 begin
  new(buffer);
  for c1:=0 to 98 do
  for c2:=0 to 29 do
   begin
    buffer^[c1,c2]:=TheScreen^[(c1+110)+(320*50)+(c2*320)];
   end;

  for c3:=0 to 5 do
  begin
  for c2:=0 to 29 do
  for c1:=0 to 98 do
   if random(5)=1 then
   putpixel(c1+110,c2+50,9-(c2 div 4));
  waitscreen;
  pushscreen;
  end;

  for c1:=0 to 98 do
  for c2:=0 to 29 do
   putpixel(c1+110,c2+50,9-(c2 div 4));

  for c3:=0 to 3 do
  begin
  for c2:=2 to 27 do
  for c1:=2 to 96 do
   if random(3)=1 then
   putpixel(c1+110,c2+50,(c2+1) div 3);
  waitscreen;
  pushscreen;
  end;

  for c1:=2 to 96 do
  for c2:=2 to 27 do
   putpixel(c1+110,c2+50,(c2+1) div 3);

  OutTextXYChoise(160-((length(text)+1)*4),55,11,text+'?');
  OutTextXYChoise(122,67,12,'yes');
  OutTextXYChoise(180,67,13,'no');
  convar:=12;
     HiText(12);
     DulText(13);
     HiText(11);

  waitscreen;
  pushscreen;

    while ButtonDown do;


  Chosen:=false;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;
   if left then
    begin
     HiText(12);
     DulText(13);
     ConVar:=12;
    end;
   if right then
    begin
     DulText(12);
     HiText(13);
     ConVar:=13;
    end;
   If PowerKey then Chosen:=True;
   If EscapeKey then
    begin
     ConVar:=13;
     Chosen:=True;
     while (ButtonDown) do;
    end;
  until Chosen;


  for c1:=0 to 98 do
  for c2:=0 to 29 do
   begin
    TheScreen^[(c1+110)+(320*50)+(c2*320)]:=buffer^[c1,c2];
   end;
   dispose(buffer);
   pushscreen;
  if convar=12 then RUSure:=true else RUSure:=false;
 end;
Procedure PreScreens;
 var
  pal1:palettetype;
  var c1:byte;
 begin
  for c1:=0 to 255 do
   begin
    pal1[c1].r:=63;
    pal1[c1].g:=63;
    pal1[c1].b:=63;
   end;
  clearscreen;pushscreen;
  DispFullBtmBuf('ZasElec.Btm');
  PushFadeIn(200);
  Fadeto(70,pal1);
  FadeOut(50);
 end;
Procedure TitleScreen;
 var
  Tempscr:VirtScrPtr;
  ts:string;
  c1,c2:byte;
  pal:palettetype;
  temp:^Pop_Text_line;
  Words:STBPtr;
  filez:file of Pop_Text_background;
 begin
  new(tempscr);
  LoadPopTxtBk;
  LoadFont4;
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('RT.Btm');
  For c1:=1 to 7 do
     asetrgbpalette(c1,c1*1,c1*3,c1*4);
  For c1:=1 to 7 do
     asetrgbpalette(c1+7,c1*1+30,c1*3+40,c1*5+20);
  For c1:=1 to 7 do
     asetrgbpalette(c1+14,c1*3+40,c1*5+20,c1*1+30);
     FetchPal(pal);
  For c1:=1 to 255 do
     asetrgbpalette(c1,(c1 div 6),(c1 div 10),(c1 div 20));
  PushFadeIn(40);
  Outtextxy3D4(85,7,1,1,8,1,1,'Zaskoda Soft presents:');
  Outtextxy3D4(261,191,1,1,15,1,1,' C 1995');
  Outtextxy3D4(261,191,1,1,8,1,1,'[ ]');
  Fadeto(70,pal);
  For c1:=1 to 7 do
    begin
     asetrgbpalette(c1,0,0,0);
     asetrgbpalette(c1+7,0,0,0);
     asetrgbpalette(c1+14,0,0,0);
    end;
  Pushscreen;
  Fadeto(30,pal);
  tempscr^:=TheScreen^;
  ts:='Chapter 1: A Past Forgotten';



  for c2:=0 to 8 do
   begin
   TheScreen^:=tempscr^;
    for c1:=0 to length(ts) do
      Outtextxy3D4(90+(c1*c2),162,1,1,15,1,1,ts[c1]);
      waitscreen;
      pushscreen;
   end;
  while ButtonDown do;
  while not(ButtonDown) do;
  while ButtonDown do;
  ClearFunk1;
  fadeout(1);
  killfont4;
  dispose(tempscr);
 end;


Procedure Test;                 {sample overworld}
 vAR
  mapon:boolean;
  pal:palettetype;
  c1,c2,c3:integer;
  exit_loop:boolean;
  Words:STBPtr;
Procedure UpDateNPCs;
 var
  c1:byte;
 begin
  for c1:=0 to Num_of_NPCs-1 do
   begin
    if NPCs[c1]<>nil then
     begin
      if NPCs[c1]^.offset>0 then NPCs[c1]^.offset:=NPCs[c1]^.offset-1{GlobalStats^.WalkRAte}
     else
       begin
        if random(75)=1 then
         begin
          NPCs[c1]^.dir:=random(4)+1;
         end
        else if random(50)=1 then
         begin
          if NPCs[c1]^.dir=1 then
           begin  {add more stuff if only one party member}
            if (OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y+1]=0)
               and not( GlobalStats^.c1alive and ((GlobalStats^.c1x=NPCs[c1]^.x) and (GlobalStats^.c1y=NPCs[c1]^.y+1))
                     or GlobalStats^.c2alive and ((GlobalStats^.c2x=NPCs[c1]^.x) and (GlobalStats^.c2y=NPCs[c1]^.y+1))
                     or GlobalStats^.c3alive and ((GlobalStats^.c3x=NPCs[c1]^.x) and (GlobalStats^.c3y=NPCs[c1]^.y+1))
                   ) then
             begin
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=0;
              inc(NPCs[c1]^.y);NPCs[c1]^.offset:=20;
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=c1+194;
             end
           end;
          if NPCs[c1]^.dir=3 then
           begin
            if (OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y-1]=0)
               and not( GlobalStats^.c1alive and ((GlobalStats^.c1x=NPCs[c1]^.x) and (GlobalStats^.c1y=NPCs[c1]^.y-1))
                     or GlobalStats^.c2alive and ((GlobalStats^.c2x=NPCs[c1]^.x) and (GlobalStats^.c2y=NPCs[c1]^.y-1))
                     or GlobalStats^.c3alive and ((GlobalStats^.c3x=NPCs[c1]^.x) and (GlobalStats^.c3y=NPCs[c1]^.y-1))
                   ) then
             begin
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=0;
              dec(NPCs[c1]^.y);NPCs[c1]^.offset:=20;
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=c1+194;
             end
           end;
          if NPCs[c1]^.dir=2 then
           begin
            if (OWM^.forth[NPCs[c1]^.x+1,NPCs[c1]^.y]=0)
               and not( GlobalStats^.c1alive and ((GlobalStats^.c1x=NPCs[c1]^.x+1) and (GlobalStats^.c1y=NPCs[c1]^.y))
                     or GlobalStats^.c2alive and ((GlobalStats^.c2x=NPCs[c1]^.x+1) and (GlobalStats^.c2y=NPCs[c1]^.y))
                     or GlobalStats^.c3alive and ((GlobalStats^.c3x=NPCs[c1]^.x+1) and (GlobalStats^.c3y=NPCs[c1]^.y))
                   ) then
             begin
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=0;
              inc(NPCs[c1]^.x);NPCs[c1]^.offset:=20;
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=c1+194;
             end
           end;
          if NPCs[c1]^.dir=4 then
           begin
            if (OWM^.forth[NPCs[c1]^.x-1,NPCs[c1]^.y]=0)
               and not( GlobalStats^.c1alive and ((GlobalStats^.c1x=NPCs[c1]^.x-1) and (GlobalStats^.c1y=NPCs[c1]^.y))
                     or GlobalStats^.c2alive and ((GlobalStats^.c2x=NPCs[c1]^.x-1) and (GlobalStats^.c2y=NPCs[c1]^.y))
                     or ((GlobalStats^.c3x=NPCs[c1]^.x-1) and (GlobalStats^.c3y=NPCs[c1]^.y))
                   ) then
             begin
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=0;
              dec(NPCs[c1]^.x);NPCs[c1]^.offset:=20;
              OWM^.forth[NPCs[c1]^.x,NPCs[c1]^.y]:=c1+194;
             end
           end;
         end;
       end;
     end;
    NPCs[c1]^.Frame:=Frame(NPCs[c1]^.x,NPCs[c1]^.y,NPCs[c1]^.offset,NPCs[c1]^.dir);
   end;
 end;
Procedure Stupid; {update 2 other party members}
 begin
      begin
       if GlobalStats^.c3x>Globalstats^.c2x then
        begin
         dec(GlobalStats^.c3x);
         GlobalStats^.c3offset:=20;
         GlobalStats^.c3dir:=4;
        end else
       if GlobalStats^.c3x<Globalstats^.c2x then
        begin
         inc(GlobalStats^.c3x);
         GlobalStats^.c3offset:=20;
         GlobalStats^.c3dir:=2;
        end else
       if GlobalStats^.c3y>Globalstats^.c2y then
        begin
         dec(GlobalStats^.c3y);
         GlobalStats^.c3offset:=20;
         GlobalStats^.c3dir:=3;
        end else
       if GlobalStats^.c3y<Globalstats^.c2y then
        begin
         inc(GlobalStats^.c3y);
         GlobalStats^.c3offset:=20;
         GlobalStats^.c3dir:=1;
        end;
      end;


      begin
       if GlobalStats^.c2x>Globalstats^.c1x then
        begin
         dec(GlobalStats^.c2x);
         GlobalStats^.c2offset:=20;
         GlobalStats^.c2dir:=4;
        end else
       if GlobalStats^.c2x<Globalstats^.c1x then
        begin
         inc(GlobalStats^.c2x);
         GlobalStats^.c2offset:=20;
         GlobalStats^.c2dir:=2;
        end else
       if GlobalStats^.c2y>Globalstats^.c1y then
        begin
         dec(GlobalStats^.c2y);
         GlobalStats^.c2offset:=20;
         GlobalStats^.c2dir:=3;
        end else
       if GlobalStats^.c2y<Globalstats^.c1y then
        begin
         inc(GlobalStats^.c2y);
         GlobalStats^.c2offset:=20;
         GlobalStats^.c2dir:=1;
        end;
      end;

 end;
Procedure LoadTextBlock(wich:byte);
 begin
 words^[0]:='                                      ';
 words^[1]:='                                      ';
 words^[2]:=' nothing at all                       ';
 words^[3]:='                                      ';
 words^[4]:='                                      ';
 assign(SpriteTextFile,SpriteTextFileName);
 reset(SpriteTextFile);
 if IOResult=0 then
  begin
     seek(SpriteTextFile,wich);
     if IOResult=0 then read(SpriteTextFile,words^);
     IF IOResult<>0 then
      begin
       words^[0]:='                                      ';
       words^[1]:='                                      ';
       words^[2]:=' no text!!!!!!!                       ';
       words^[3]:='                                      ';
       words^[4]:='                                      ';
      end;
    close(SpriteTextFile);
  end;
 end;


Procedure DrawSmallStatus; {unloads font4}
  begin
    loadfont4;
   if GlobalStats^.c1alive then
    begin
     PutSmallBit3Dedge (296,5,3,c1bitmaps[1]);
     PutSmallTranBitFast(296,5,0,c1bitmaps[1]);
     OutTextXY3d4(227,14,2,3,24,1,0,GlobalStats^.c1name+':');
     OutTextXy3d4(233,26,2,3,31,1,0,'HP:175/187');
     OutTextXy3d4(233,38,2,3,31,1,0,'MP: 37/57');
    end;
   if GlobalStats^.c2alive then
    begin
     PutSmallBit3Dedge (296,45,3,c2bitmaps[1]);
     PutSmallTranBitFast(296,45,0,c2bitmaps[1]);
     OutTextXY3d4(227,54,2,3,24,1,0,GlobalStats^.c2name+':');
     OutTextXy3d4(233,66,2,3,31,1,0,'HP:115/297');
     OutTextXy3d4(233,78,2,3,31,1,0,'MP: 10/22');
    end;
   if GlobalStats^.c3alive then
    begin
     PutSmallBit3Dedge (296,85,3,c3bitmaps[1]);
     PutSmallTranBitFast(296,85,0,c3bitmaps[1]);
     OutTextXY3d4(227,94,2,3,24,1,0,GlobalStats^.c3name+':');
     OutTextXy3d4(233,106,2,3,31,1,0,'HP: 75/99');
     OutTextXy3d4(233,118,2,3,31,1,0,'MP: 40/91');
    end;
    OutTextXY3d4(227,170,2,3,24,1,0,'Gold');
    OutTextXy3d4(233,182,2,3,31,1,0,'64123');
    killfont4;
  end;
 begin



 new(words);

 ClearScreen;
 PushSCreen;
 for c1:=0 to 255 do
 asetrgbpalette(c1,0,0,0);

                                 {
 for c1:=1 to 20 do
 asetrgbpalette(c1,c1*3,c1*3,c1*3);
                                  }
 {brown}
 for c1:=1 to 20 do
 asetrgbpalette(c1,c1*3+10,c1*2+5,c1);

 {red}
 for c1:=1 to 9 do
 asetrgbpalette(c1,c1*3+1,c1*2,c1*1+0);
  {green}                  {
 for c1:=1 to 9 do
 asetrgbpalette(c1,c1 div 2,c1*3,c1);      }

 {blue}                                  {
 for c1:=1 to 20 do
 asetrgbpalette(c1,c1*1+5,c1*1+5,c1*4+5); }


 {red}
 for c1:=0 to 3 do
 asetrgbpalette(c1+20,40-(c1*8),50-c1*7,60-(c1*8));


  For c1:=1 to 7 do
     asetrgbpalette(c1+23,(c1*1+30),(c1*3+40),(c1*5+20));
  For c1:=1 to 7 do
     asetrgbpalette(c1+30,(c1*3+40),(c1*5+20),(c1*1+30));


 SetUpPal;
 DrawGrid;
 drawoverlay;

 PushFadeIn(50);
 drawpanel(0);


 DrawSmallStatus; {unloads font4}

 panelup;
 mapon:=false;
 repeat

 pollsticks;
 exit_loop:=false;
 {
 if d=('5') then hero.frame:=hero.frame+1;
 if hero.frame>15 then hero.frame:=0;       }

 {start get input to move}
  if GlobalStats^.c1offset=0 then
  if (keydown[key_leftarrow]) or ((gsticks[1].x<left_bound))  then
   begin
    GlobalStats^.c1dir:=4;
  if (owm^.forth[GlobalStats^.c1X-1,GlobalStats^.c1Y]<194) then
   begin
    stupid;
    GlobalStats^.c1x:=GlobalStats^.c1x-1;
    GlobalStats^.c1offset:=20;
   end;
   end else
  if (keydown[key_rightarrow]) or ((gsticks[1].x>right_bound))  then
   begin
    GlobalStats^.c1dir:=2;
  if owm^.forth[GlobalStats^.c1X+1,GlobalStats^.c1Y]<194 then
   begin
    stupid;
    GlobalStats^.c1x:=GlobalStats^.c1x+1;
    GlobalStats^.c1offset:=20;
   end;
   end else
  if (keydown[key_uparrow]) or ((gsticks[1].y<up_bound))  then
   begin
    GlobalStats^.c1dir:=3;
  if owm^.forth[GlobalStats^.c1X,GlobalStats^.c1Y-1]<194 then
   begin
    stupid;
    GlobalStats^.c1offset:=20;
    GlobalStats^.c1y:=GlobalStats^.c1y-1;
   end;
   end else
  if (keydown[key_downarrow]) or ((gsticks[1].y>down_bound))  then
   begin
    GlobalStats^.c1dir:=1;
  if owm^.forth[GlobalStats^.c1X,GlobalStats^.c1Y+1]<194 then
   begin
    stupid;
    GlobalStats^.c1y:=GlobalStats^.c1y+1;
    GlobalStats^.c1offset:=20;
   end;
   end;
 {end get input to move}

 {update party member's frames}
 GlobalStats^.c1Frame:=Frame(GlobalStats^.c1x,GlobalStats^.c1y,GlobalStats^.c1offset,GlobalStats^.c1dir);
 GlobalStats^.c2Frame:=Frame(GlobalStats^.c2x,GlobalStats^.c2y,GlobalStats^.c2offset,GlobalStats^.c2dir);
 GlobalStats^.c3Frame:=Frame(GlobalStats^.c3x,GlobalStats^.c3y,GlobalStats^.c3offset,GlobalStats^.c3dir);

 UpDateNPCs;
 if GlobalStats^.c3offset<>0 then GlobalStats^.c3offset:=GlobalStats^.c3offset-GlobalStats^.WalkRate;
 if GlobalStats^.c2offset<>0 then GlobalStats^.c2offset:=GlobalStats^.c2offset-GlobalStats^.WalkRate;
 if GlobalStats^.c1offset<>0 then GlobalStats^.c1offset:=GlobalStats^.c1offset-GlobalStats^.WalkRate;

 {start map skip here}
 c1:=owm^.forth[GlobalStats^.c1x,GlobalStats^.c1y];
 if not(odd(c1)) then
  begin
   c1:=c1 div 2;
   if (c1>2) and (c1<25) then
    begin
     GlobalStats^.c1X:=MapWarpLUT^[c1*2+1].x;
     GlobalStats^.c1Y:=MapWarpLUT^[c1*2+1].y;
     GlobalStats^.c2X:=MapWarpLUT^[c1*2+1].x;
     GlobalStats^.c2Y:=MapWarpLUT^[c1*2+1].y;
     GlobalStats^.c3X:=MapWarpLUT^[c1*2+1].x;
     GlobalStats^.c3Y:=MapWarpLUT^[c1*2+1].y;
     GlobalStats^.c2dir:=GlobalStats^.c1dir;
     GlobalStats^.c3dir:=GlobalStats^.c1dir;
    end;
  end;              {
 for c1:=3 to 24 do
  if (owm^.forth[GlobalStats^.c1x,GlobalStats^.c1y]=c1*2) then
   begin
    GlobalStats^.c1X:=MapWarpLUT^[c1*2+1].x;
    GlobalStats^.c1Y:=MapWarpLUT^[c1*2+1].y;
    GlobalStats^.c2X:=MapWarpLUT^[c1*2+1].x;
    GlobalStats^.c2Y:=MapWarpLUT^[c1*2+1].y;
    GlobalStats^.c3X:=MapWarpLUT^[c1*2+1].x;
    GlobalStats^.c3Y:=MapWarpLUT^[c1*2+1].y;
    GlobalStats^.c2dir:=GlobalStats^.c1dir;
    GlobalStats^.c3dir:=GlobalStats^.c1dir;
   end;              }

{end map skip here}

{start map change}
  if GlobalStats^.c1offset=0 then
  for c1:=127 to 192 do
  if (owm^.forth[GlobalStats^.c1x,GlobalStats^.c1y]=c1) then
   begin
    GlobalStats^.c1offset:=20;
    FadeOutPartial(10,pal);
    changemap(c1);
    drawgrid;
    drawoverlay;
    pushscreen;
    fadeto(10,pal);
   end;
  if GlobalStats^.c1offset=0 then
  if (owm^.forth[GlobalStats^.c1x,GlobalStats^.c1y]=1) then
   begin                          {exit}
    GlobalStats^.c1offset:=20;
    FadeOutPartial(10,pal);
    exitmap;
    drawgrid;
    drawoverlay;
    pushscreen;
    fadeto(10,pal);
   end;
{end map change}



 {just draw the tiles}
 DrawGrid;
 {the small map requires a full push screen}
 if mapon then DrawSmallMap;
     {
  while f_clk[5]<>0 do;
  f_clk[5]:=100;
      }

  {the mini map requires a full pushscreen}
 if Mapon then begin drawoverlay; pushscreen; end else
  begin
   waitscreen;
   pushsmallscreen;
  end;
 if f_clk[2]=0 then
  begin
   f_clk[2]:=50;
   MoveAni;
  end;

{start debug stuff}
 if keydown[key_M] then   {dubugging feature}
  begin
   MapOn:=true;
  end;
 if keydown[key_N] then   {dubugging feature}
  begin
   MapOn:=false;
  end;
 if keydown[key_R] then   {dubugging feature}
  begin
   if not(rainon) then InitRain;
  end;
 if keydown[key_T] then   {dubugging feature}
  begin
   if (rainon) then CloseRain;
  end;
 if keydown[Key_Q] then   {dubugging feature}
  begin
   GlobalStats^.c1alive:=true;
  end;
 if keydown[Key_W] then   {dubugging feature}
  begin
   GlobalStats^.c2alive:=true;
  end;
 if keydown[Key_E] then   {dubugging feature}
  begin
   GlobalStats^.c3alive:=true;
  end;
 if keydown[Key_A] then   {dubugging feature}
  begin
   GlobalStats^.c1alive:=false;
  end;
 if keydown[Key_S] then   {dubugging feature}
  begin
   GlobalStats^.c2alive:=false;
  end;
 if keydown[Key_D] then   {dubugging feature}
  begin
   GlobalStats^.c3alive:=false;
  end;
{end debug stuff}

{start talk}
 if powerkey then
  begin
  if GlobalStats^.c1dir=1 then c1:=owm^.forth[GlobalStats^.c1X,GlobalStats^.c1Y+1]
  else if GlobalStats^.c1dir=2 then c1:=owm^.forth[GlobalStats^.c1X+1,GlobalStats^.c1Y]
  else if GlobalStats^.c1dir=3 then c1:=owm^.forth[GlobalStats^.c1X,GlobalStats^.c1Y-1]
  else if GlobalStats^.c1dir=4 then c1:=owm^.forth[GlobalStats^.c1X-1,GlobalStats^.c1Y];
  if (c1>=194) and (c1<=226) then
    begin
     if GlobalStats^.c1dir=1 then
      NPCs[c1-194]^.Frame:=Frame(NPCs[c1-194]^.x,NPCs[c1-194]^.y,NPCs[c1-194]^.offset,3) else
     if GlobalStats^.c1dir=2 then
      NPCs[c1-194]^.Frame:=Frame(NPCs[c1-194]^.x,NPCs[c1-194]^.y,NPCs[c1-194]^.offset,4) else
     if GlobalStats^.c1dir=3 then
      NPCs[c1-194]^.Frame:=Frame(NPCs[c1-194]^.x,NPCs[c1-194]^.y,NPCs[c1-194]^.offset,1) else
     if GlobalStats^.c1dir=4 then
      NPCs[c1-194]^.Frame:=Frame(NPCs[c1-194]^.x,NPCs[c1-194]^.y,NPCs[c1-194]^.offset,2);
     drawgrid;pushsmallscreen;
     LoadTextBlock(OWM^.NPCMAPData[c1-194+64]);
     while buttondown do;
     For c2:=0 to 2 do
      asetrgbpalette(c2+10,63-c2*7,59-c2*10,54-c2*14);
     DrawOverLay;
     DrawPopTxtBk;
     waitscreen;
     pushscreen;
     PopText(Words,10);
     while buttondown do;
     drawpanel(0);
     DrawGrid;
     DrawOverLay;
     DrawSmallStatus; {unloads font4}

     PushScreen;
    end;
  end;
{end talk}

{start menu}
 if (keydown[key_NPMult]) or ((gsticks[1].button2))   then
  begin
   menuinfo^.title:='Main Menu';
   menuinfo^.choices[0]:='Move';
   menuinfo^.choices[1]:='Stock';
   menuinfo^.choices[2]:='Magic';
   menuinfo^.choices[3]:='Equipment';
   menuinfo^.choices[4]:='Status';
   menuinfo^.choices[5]:='Rod';
   menuinfo^.choices[6]:='Options';
   menuinfo^.choices[7]:='Files';
   menuinfo^.choices[8]:='Map';
   menuinfo^.choices[9]:='Quit';
   menuinfo^.choices[10]:='end';

  repeat
   DrawGrid;
   drawoverlay;
   pushscreen;
   c1:=Getchoice(0,0);
   if c1=9 then exit_loop:=true;
   if c1=4 then
    begin
     KillMaptiles;
     ClearFunk1;
     Fadeout(1);
     clearscreen;
     pushscreen;
     DispFullBtmBuf('stat\'+
     globalstats^.c1Name[1]+
     globalstats^.c1Name[2]+
     globalstats^.c1Name[3]+
     globalstats^.c1Name[4]+
     'stat.btm');
  LoadMaptiles(maplut^.tileset[GlobalStats^.Map]);


     for c1:=0 to 2 do
      begin
       asetrgbpalette(70+c1,63-c1*12,30-c1*7,30-c1*7);
       asetrgbpalette(73+c1,30-c1*7,63-c1*12,30-c1*7);
       asetrgbpalette(76+c1,30-c1*7,30-c1*7,63-c1*12);
       asetrgbpalette(82+c1,45-c1*7,45-c1*7,45-c1*7);
      end;
     AsetRgbPalette(79,63,55,33);
     AsetRgbPalette(80,50,45,25);
     AsetRgbPalette(81,41,36,21);


   OutTextXYNorm1(140,20,76,'NAME:');
   OutTextXYNorm1(140,30,76,' EXP:');
   OutTextXYNorm1(140,40,76,' LEV:');
   OutTextXYNorm1(180,20,79,'gerwin');
   OutTextXYNorm1(180,30,79,'3245');
   OutTextXYNorm1(180,40,79,'3');

   OutTextXYNorm1(100,60,76,'PHYSICAL:');
   OutTextXYNorm1(200,60,76,'MAGICAL:');
   OutTextXYNorm1(90,70,70,'STRENGTH:');
   OutTextXYNorm1(90,080,70,' AGILITY:');
   OutTextXYNorm1(90,090,70,' DEFENCE:');
   OutTextXYNorm1(190,70,73, '  POWER:');
   OutTextXYNorm1(190,080,73,'  EVADE:');
   OutTextXYNorm1(190,090,73,'DEFENCE:');
   OutTextXYNorm1(165,70,79,'7');
   OutTextXYNorm1(165,080,79,'6');
   OutTextXYNorm1(165,090,79,'8');
   OutTextXYNorm1(260,70,79,'7');
   OutTextXYNorm1(260,080,79,'4');
   OutTextXYNorm1(260,090,79,'8');
   OutTextXYNorm1(100,120,76,' ARMOR:');
   OutTextXYNorm1(170,120,79,'Leather');
   OutTextXYNorm1(100,140,76,'Weapon:');
   OutTextXYNorm1(110,150,82,'Close:');
   OutTextXYNorm1(110,160,82,' Long:');
   OutTextXYNorm1(170,150,79,'Long Knight');
   OutTextXYNorm1(170,160,79,'Bobsky Dagger');

                {
    drawoverlay; }
     PushFadeIn(10);
     while ButtonDown do;
     while not(ButtonDown) do;
     while ButtonDown do;
     fadeout(10);
     clearscreen;
     pushscreen;
     SetUpPal;
     for c1:=1 to 20 do
     asetrgbpalette(c1,c1*3+10,c1*2+5,c1);
     drawoverlay;
     drawgrid;
     pushfadein(20);
    end;

   if c1=8 then
    begin
     Fadeout(20);
     clearscreen;
     pushscreen;
     DispFullBtmFull('map.btm',100);
     clearscreen;
     pushscreen;
     SetUpPal;
     for c1:=1 to 20 do
     asetrgbpalette(c1,c1*3+10,c1*2+5,c1);
     pushfadein(20);
    end;
   until ((c1=0) or (c1=9));
   panelclose;
   drawpanel(0);

  For c1:=1 to 7 do
     asetrgbpalette(c1+23,(c1*1+30),(c1*3+40),(c1*5+20));
  For c1:=1 to 7 do
     asetrgbpalette(c1+30,(c1*3+40),(c1*5+20),(c1*1+30));

   DrawSmallStatus; {unloads font4}
   panelup;
  end;
{end menu}

  if EscapeKey then
     begin
      exit_loop:=true;
      drawoverlay;
      while (ButtonDown) do;
     end;
  if exit_loop then
    If not(RUSure('Main Menu')) then exit_loop:=false;
 until exit_loop;

 dispose(words);
 words:=nil;
 end;

Procedure MainMenu(var ConVar:byte);
 var
  c1:integer;
  cycle:byte;
  Pal:PaletteType;
  Chosen:boolean;
 begin
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('icebk.Btm');            {BackGround}
  brownpal;
  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,5+c1,5+c1,5+c1*2);
   asetrgbpalette(110,10,5,0);
  for c1:=1 to 7 do
   asetrgbpalette(c1+110,c1*8+4,c1*6+4,c1*3+5);


     DulText(0);
     DulText(1);
     DulText(2);
     HiText(ConVar);


   LoadFont2;                              {Actual Texts}
   OutTextXyBW2(81,9,110,'Main  Menu');
   OutTextXyBW2(79,9,110,'Main  Menu');
   OutTextXyBW2(81,11,110,'Main  Menu');
   OutTextXyBW2(79,11,110,'Main  Menu');

   OutTextXynorm2(80,10,110,'Main  Menu');

   KillFont2;

   OutTextXYChoise(120,70,0,'Enter Game');
   OutTextXYChoise(124,90,1,' Credits');
   OutTextXYChoise(120,110,2,'   Quit');


  FetchPal(Pal);           {Get PAllette for loop}


  PushFadeIn(10);          {Quickly Bring up menu}
  while ButtonDown do;

  cycle:=0;      {For color cycle}
  setrate(512);
  f_clk[0] := 20;
  Chosen:=false;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;
   if f_Clk[0]=0 then
    begin
     f_clk[0] := 20;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;

   if up then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=2 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     HiText(ConVar);
    end;                                    {
   If (d=('2')) or (Zeroed and (d=#80)) then }   {If more than 5 options}
   If Down then
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=2 then ConVar:=0 else
     ConVar:=ConVar+1;
     HiText(ConVar);
    end;
   If PowerKey then Chosen:=True;
   If EscapeKey then
    begin
     DulText(ConVar);
     ConVar:=2;
     Chosen:=True;
     HiText(ConVar);
     while (ButtonDown) do;
    end;
   if chosen and (convar=2) then if not (rusure('DOS')) then chosen:=false;
  until Chosen;
  FadeOut(2);
 end;


Procedure StoryScene(Wich:Byte);
 var
  c2:byte;
  Words:STBPtr;
  filez:file of Pop_Text_background;
  temp:^Pop_Text_line;
 Procedure SetColors;
  begin
  for c1:=1 to 9 do
   asetrgbpalette(c1,c1*3+10,c1*2+5,c1);
  For c1:=0 to 2 do
   asetrgbpalette(c1+10,63-c1*7,59-c1*10,54-c1*14);
  end;
 begin

 {all startup stuff}
  new(popback);                {IS this needed??? 5/27}
  assign(filez,'POPTXTBK.GRD');
  reset(filez);
  read(filez,popback^);
  close(filez);

  New(Words);

  FadeOut(10);
  ClearScreen;
  PushScreen;
 {end all startup stuff}

 if wich=0 then
  begin
   DispFullBtmBuf('story/story000.btm');
   SetColors; {local procedure}
   PushFadeIn(5);
   DrawPopTxtBk;
   waitscreen;
   pushscreen;
   Words^[0]:=(' Story scene 0 images story000.btm    ');
   Words^[1]:=('                                      ');
   Words^[2]:=('                                      ');
   Words^[3]:=('                                      ');
   Words^[4]:=('                                      ');
   PopText(Words,10);
   FadeOut(5);
   ClearScreen;
   PushScreen;
  end
 else if wich=1 then
  begin
   DispFullBtmBuf('story/story001.btm');
   SetColors; {local procedure}
   PushFadeIn(50);
   DrawPopTxtBk;
   waitscreen;
   pushscreen;
   Words^[0]:=(' Story scene 1 images story001.btm    ');
   Words^[1]:=('                                      ');
   Words^[2]:=('                                      ');
   Words^[3]:=('                                      ');
   Words^[4]:=('                                      ');
   PopText(Words,10);
   FadeOut(50);
   ClearScreen;
   PushScreen;
  end;
  dispose(popback);
  popback:=nil;
 end;
Procedure GameSelect(var Wich:byte;New:boolean);
 var
  convar:byte;
  cycle:byte;
  Pal:PaletteType;
  Chosen,Zeroed:boolean;
 begin
  convar:=4;
  if not(new) then convar:=5;
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('grid.Btm');
  DispFullBtmBuf('wrpbk2.Btm');            {BackGround}
  brownpal;
  PopLoadBacks;


  For c1:=0 to 19 do                     {LGB colors}
   AsetRgbPalette(c1+34,c1*3,c1*2,c1*1);
  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,5+c1,5+c1,5+c1*2);
  for c1:=0 to 10 do
   asetrgbpalette(c1+110,c1*2+30,0,0);
     DulText(0);
     DulText(1);
     dulText(2);
     dulText(3);
     DulText(4);
     DulText(5);
     HiText(convar);

                            {
   LoadFont2;                }             {Actual Texts}{
   OutTextXyBW2(119,164,22,'N E W');
   OutTextXyBW2(121,164,22,'N E W');
   OutTextXyBW2(119,166,23,'N E W');
   OutTextXyBW2(121,166,24,'N E W');
   outtextxynorm2(120,165,110,'N E W');
   KillFont2;                                             }

   OutTextXyChoise(135,16,0, 'Too Fast');
   OutTextXyChoise(135,56,1, '  Fast ');
   OutTextXyChoise(135,96,2, ' Normal');
   OutTextXyChoise(135,136,3,'  Slow ');
  if new then
  begin
   OutTextXyChoise(107,165,4,'Start NEW Game');
   OutTextXyChoise(127,185,5,'Exit Menu');
  end
   else
   OutTextXyChoise(127,175,5,'Exit Menu');



  FetchPal(Pal);           {Get PAllette for loop}
  PushFadeIn(10);          {Quickly Bring up menu}
  while ButtonDown do;

  cycle:=0;      {For color cycle}
  setrate(512);
  f_clk[0] := 20;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;

   if f_Clk[0]=0 then
    begin
     f_clk[0] := 20;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;
   If Up then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=5 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     if (not(new)) and (ConVar=4) then ConVar:=3;
     HiText(ConVar);
    end;
   If Down then                       {If more than 5 options}
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=5 then ConVar:=0 else
     ConVar:=ConVar+1;
     if (not(new)) and (ConVar=4) then ConVar:=5;
     HiText(ConVar);
    end;
   If PowerKey then Chosen:=True;
   If EscapeKey then
    begin
     ConVar:=5;
     Chosen:=True;
     while (ButtonDown) do;
    end;
  until Chosen;
  FadeOut(2);
  Wich:=Convar;                                 {
  if convar=5 then play :=false else play:=true; }
 end;


(******Loading/Unloading********)
Procedure LoadGameConst;
 begin
  {never change}
  LoadOverlay;
  LoadPopTxtBk;

  {variable}
  LoadSprite(c1bitmaps,globalstats^.c1sprt);
  LoadSprite(c2bitmaps,globalstats^.c2sprt);
  LoadSprite(c3bitmaps,globalstats^.c3sprt);
  LoadOWM(maplut^.mapname[GlobalStats^.Map]);
  LoadMaptiles(maplut^.tileset[GlobalStats^.Map]);
  new(menuinfo);
  {fonts}
  {overlays}
  {pop text stuff}
 end;
Procedure KillGameConst;
 begin
  {never change}
  KillOverlay;
  KillPopTxtBk;

  {variable}
  KillSprite(c1bitmaps);
  KillOWM;
  KillMapTiles;
  dispose(menuinfo);
  menuinfo:=nil;

 end;
Procedure LoadGame(Play:byte);
 begin
  new(GlobalStats);
  GlobalStats^.Map:=127;

  globalstats^.c1Name:='Vexx';
  GlobalStats^.c1x:=22;
  GlobalStats^.c1y:=23;
  GlobalStats^.c1offset:=0;
  GlobalStats^.c1dir:=3;
  GlobalStats^.c1frame:=7;
  GlobalStats^.c1alive:=true;
  GlobalStats^.c1sprt:=drudwyn;

  globalstats^.c2Name:='Gerwin';
  GlobalStats^.c2x:=22;
  GlobalStats^.c2y:=24;
  GlobalStats^.c2offset:=0;
  GlobalStats^.c2dir:=3;
  GlobalStats^.c2frame:=7;
  GlobalStats^.c2alive:=false;
  GlobalStats^.c2sprt:=Gerwin;


  globalstats^.c3Name:='Venetia';
  GlobalStats^.c3x:=22;
  GlobalStats^.c3y:=25;
  GlobalStats^.c3offset:=0;
  GlobalStats^.c3dir:=3;
  GlobalStats^.c3frame:=7;
  GlobalStats^.c3alive:=false;
  GlobalStats^.c3sprt:=Venetia;


  {options}
  GlobalStats^.WalkRAte:=2;
  GlobalStats^.TalkRAte:=40;

  {init pointers}
  {loadgame}
 end;
Procedure KillGame;
 begin
  dispose(GlobalStats);
  {check for save}
  {kill game pointers}
 end;
(******Loading/Unloading********)


(******Gaming Loops********)
Procedure FightLoop;
 begin
  {fadeout}
  {evaluate monsters}
  {load fight graphics}
  {begin loop}
    {get party choices}
    {setup enemy choices}
    {enter battle}
      {beginloop}
      {endloop}
    {evaluate winner}
  {end loop}
  {kill fight graphics}
 end;
Procedure MoveLoop;
 begin
  {put up those menus}
  {begin loop}
   {check for key entry}
   {if movenment then set offset and direction}
   {if enter then exit}
   {if space then talk/open}
   {if one away from offset=0 then random}
     {killmapstuff/fightloop/loadmapstuff/dec(offset)/repaintscreen}
   {decrement offset}
   {update graphics}
   {clearkey}
  {end loop}
 end;
Procedure GameLoop;
 begin
  {load map}{load sprite}{always save in map mode}
  {draw the screen}
  {open main menu}
  {fadein}
  {start loop}
   {check key entry}
   {if move then moveloop}
   {if stock then stockmenu}
   {if magic then magicmenu}
   {if equip then equipmenu}
   {if status then status menu}
   {if rods then rodmenu}
   {if options then opsmenu}
   {if files then}
    {if load then load(which game)}
    {if save then save(which game)}
   {if quit then quit:=true}
  {end loop}
 end;
Procedure RunGame;
 var
  play:Byte;
 begin
  GameSelect(play,true);
  if play<>5 then
   begin
    if play=4 then StoryScene(1); {new game}
    LoadGame(play);
    LoadGameConst; {saved game stuff}
    if play=0 then GlobalStats^.WalkRAte:=5;
    if play=1 then GlobalStats^.WalkRAte:=4;
    if play=2 then GlobalStats^.WalkRAte:=2;
    if play=3 then GlobalStats^.WalkRAte:=1;
    {del}test;
    GameLoop;       {nul}

    KillGameConst;
    KillGame; {saved game stuff}
   end;
 end;
(******Gaming Loops********)
Procedure OverAll;
 var
  ConVar:byte;
 begin
  ConVar:=0;{
  PreScreens;
  TitleScreen;}
  repeat
   MainMenu(ConVar);
   If ConVar=0 then RunGame;
   If ConVar=1 then credits;
  until ConVar=2;
 end;
begin
 randomize;
 asetrgbpalette(1,0,5,0);
 asetrgbpalette(2,2,10,2);
 asetrgbpalette(3,4,20,4);
 asetrgbpalette(4,8,60,8);
 asetrgbpalette(5,38,63,38);
 window(1,1,80,25);TextBackGround(2);ClrScr;
 window(5,3,78,5);TextBackGround(1);ClrScr;
 window(4,2,77,4);TextBackGround(3);ClrScr;

 TextColor(4);
 Writeln(' Snazzy Engine (tm)                                      v.01 (pre alpha)');
 Writeln(' Copyright 1997 by Scott Dudley                       All Rights Reserved');
   Write('                                                             Zaskoda Soft');

 window(5,8,78,24);TextBackGround(1);ClrScr;
 window(4,7,77,23);TextBackGround(3);ClrScr;
 TextColor(4);

 write('-=*=-                                                                -=*=-');
 writeln(' THE LEGEND OF TALIBAH Chapter 1: A Past Forgotten          Zaskoda Soft');
 write('-=*=-                                                                -=*=-');
 {init_spriteslut;}
 init_maplut;
 writeln('Maplink look up table created...');
 LoadFont1;
 writeln('Main font loaded...');
 Textcolor(5);
 SetUpSticks;
 Textcolor(4);
 writeln('Init mode 13h');
  setvideomode($13);

     OverAll;
     setvideomode($3);

  window(1,1,80,25);TextBackGround(0);TextColor(lightgray);ClrScr;
  setrate(18);
  KillFont1;
  writeln('Main font unloaded.');
  kill_maplut;
  writeln('Map look up table disposed...');
  {kill_spriteslut;}
end.