
{$i-}
Program MakeDataFiles;
 uses crt;
 type
  CommonString=string[8];
  HorizBtmArray=array[0..19] of byte;  {For Sprites}
  HBASmallPoint=^HorizBtmArray;
  SmallBtm=array[0..19] of HorizBtmArray;
  SmallBlock=^SmallBtm;
  SpriteFrames=array[0..11] of SmallBlock;

Procedure MakeSpriteDataFile;
 var
  filez:file of CommonString;
  temp:CommonString;
  tempsprite:SpriteFrames;
  c1:byte;
  outfile:File of SmallBtm;
 Function SpriteIn(what:string):boolean;
  var
   c1:byte;
   tempfile:file of SmallBtm;
  begin
   SpriteIn:=true;
   assign(tempfile,'oldata\'+what+'.spr');
     reset(tempfile);
     if IOResult=0 then
      begin
       textcolor(green);
       write('('+what+')');
       textcolor(lightgray);
       for c1:=0 to 11 do
        begin
         read(tempfile,tempsprite[c1]^);
         write('.');
        end;
       close(tempfile);
      end
     else
      begin
       textcolor(red);
       Writeln('!!!=> '+what+'.spr not found!');
       textcolor(lightgray);
       SpriteIn:=false;
      end;
  end;
 Procedure SpriteOut;
  var c1:byte;
  begin
   for c1:=0 to 11 do
    write(outfile,tempsprite[c1]^);
   writeln(':');
  end;
 begin

  for c1:=0 to 11 do new(tempsprite[c1]);
  assign(outfile,'all_spr.69');
  rewrite(outfile);
  {party members}
  if SpriteIn('DRUDWYN') then SpriteOut;
  if SpriteIn('SARIS') then SpriteOut;
  if SpriteIn('SFARM') then SpriteOut;
  if SpriteIn('SKNIGHT') then SpriteOut;
  if SpriteIn('SMONK') then SpriteOut;
  if SpriteIn('SSHAD') then SpriteOut;
  if SpriteIn('GERWIN') then SpriteOut;
  if SpriteIn('STAULKER') then SpriteOut;
  if SpriteIn('VENETIA') then SpriteOut;
  if SpriteIn('PHONOVAN') then SpriteOut;
  {non party members}
  if SpriteIn('GUY1') then SpriteOut;
  if SpriteIn('KNIGHT') then SpriteOut;
  if SpriteIn('TAYLOR') then SpriteOut;
  if SpriteIn('BSMITH') then SpriteOut;
  if SpriteIn('FARMBOY') then SpriteOut;
  if SpriteIn('GIRL01') then SpriteOut;
  if SpriteIn('GIRL02') then SpriteOut;
  if SpriteIn('MONSTER') then SpriteOut;
  if SpriteIn('GIRLY') then SpriteOut;
  if SpriteIn('BOAT') then SpriteOut;
  if SpriteIn('GOOFER') then SpriteOut;
  if SpriteIn('TANK') then SpriteOut;
  if SpriteIn('CHEST') then SpriteOut;
  if SpriteIn('BOULDER') then SpriteOut;
  if SpriteIn('CRATE') then SpriteOut;
  if SpriteIn('ANIMAL1') then SpriteOut;
  if SpriteIn('ANIMAL2') then SpriteOut;
  if SpriteIn('innkeep') then SpriteOut;
  if SpriteIn('ormad') then SpriteOut;
  if SpriteIn('animal3') then SpriteOut;
  if SpriteIn('animal4') then SpriteOut;
  if SpriteIn('MIRIAM') then SpriteOut;
  if SpriteIn('WSHOP') then SpriteOut;
  if SpriteIn('MAGIC1') then SpriteOut;
  if SpriteIn('rain') then SpriteOut;
  if SpriteIn('oldbrown') then SpriteOut;
  if SpriteIn('farmguy1') then SpriteOut;
  if SpriteIn('monk') then SpriteOut;
  if SpriteIn('drag') then SpriteOut;

              {
  writeln;
  assign(filez,'sprlut.dat');
  rewrite(filez);
  temp:='GUY1    ';  write(filez,temp);  write('.');
  temp:='KNIGHT  ';  write(filez,temp);  write('.');
  temp:='STAULKER';  write(filez,temp);  write('.');
  temp:='DRUDWYN ';  write(filez,temp);  write('.');
  temp:='GERWIN  ';  write(filez,temp);  write('.');
  temp:='SMONK   ';  write(filez,temp);  write('.');
  temp:='TAYLOR  ';  write(filez,temp);  write('.');
  temp:='BSMITH  ';  write(filez,temp);  write('.');
  temp:='FARMBOY ';  write(filez,temp);  write('.');
  temp:='PHONOVAN';  write(filez,temp);  write('.');
  temp:='GIRL01  ';  write(filez,temp);  write('.');
  temp:='GIRL02  ';  write(filez,temp);  write('.');
  temp:='MONSTER ';  write(filez,temp);  write('.');
  temp:='GIRLY   ';  write(filez,temp);  write('.');
  temp:='BOAT    ';  write(filez,temp);  write('.');
  temp:='GOOFER  ';  write(filez,temp);  write('.');
  temp:='SSHAD   ';  write(filez,temp);  write('.');
  temp:='VENETIA ';  write(filez,temp);  write('.');
  temp:='SFARM   ';  write(filez,temp);  write('.');
  temp:='TANK    ';  write(filez,temp);  write('.');
  temp:='SKNIGHT ';  write(filez,temp);  write('.');
  temp:='CHEST   ';  write(filez,temp);  write('.');
  temp:='BOULDER ';  write(filez,temp);  write('.');
  temp:='CRATE   ';  write(filez,temp);  write('.');

  close(filez);}

  close(outfile);
  for c1:=0 to 11 do dispose(tempsprite[c1]);
  writeln;
 end;

begin
 MakeSpriteDataFile;
end.