{This unit has menu routines}
{$B-}
{$G+}
unit mensys;
interface
uses fonts,graphics,bitmaps,multkeys,vars,spx_tim;               {8 wide}
type
 option_string=string[10];
 All_menu_stuff=record
   title:option_string;
   choices:array[0..10] of option_string;
  end;
var
 MenuInfo:^All_menu_Stuff;

Procedure Use_Item(which:byte;overworld:boolean;decrement:boolean);
Procedure Drop_Item(which:byte);
Function GetItem:byte;
Function GetChoice(cur:byte;ESCAPE:byte):byte;
Function RUSure(text:string):boolean;
Procedure MainMenu(var ConVar:byte);
Procedure TitleScreen;
Procedure PreScreens;
Procedure Credits;
Function ChooseCharacter(title:commonstring;chars_on:boolean):byte;

Procedure GameSelect(var Wich:byte;New:boolean);

implementation

Procedure Use_Item(which:byte;overworld:boolean;decrement:boolean);
 var
  character:byte;
 begin
  if decrement then if (GlobalStats^.Item_Quant[which]>0) then dec(GlobalStats^.Item_Quant[which]);
  case which of
   (0): begin {herb}
      character:=ChooseCharacter('Use On?',overworld);
      case character of
       1: begin
           if (globalstats^.c1hp+20>globalstats^.c1mhp) then
            globalstats^.c1hp:=(globalstats^.c1mhp) else
             globalstats^.c1hp:=((globalstats^.c1hp+20));
           globalstats^.c1effect:=47;
          end;
       2: begin
           if (globalstats^.c2hp+20>globalstats^.c2mhp) then
            globalstats^.c2hp:=(globalstats^.c2mhp) else
             globalstats^.c2hp:=((globalstats^.c2hp+20));
           globalstats^.c2effect:=47;
          end;
       3: begin
           if (globalstats^.c3hp+20>globalstats^.c3mhp) then
            globalstats^.c3hp:=(globalstats^.c3mhp) else
             globalstats^.c3hp:=((globalstats^.c3hp+20));
           globalstats^.c3effect:=47;
          end;
       end;
     end; {herb}

   (1): begin {potion}
      character:=ChooseCharacter('Use On',overworld);
      case character of
       1: begin
           globalstats^.c1hp:=globalstats^.c1mhp;
           globalstats^.c1effect:=47;
          end;
       2: begin
           globalstats^.c2hp:=globalstats^.c2mhp;
           globalstats^.c2effect:=47;
          end;
       3: begin
           globalstats^.c3hp:=globalstats^.c3mhp;
           globalstats^.c3effect:=47;
          end;
       end
     end;{potion}

    else begin end;
   end; {case}
 end;

Function ChooseCharacter(title:commonstring;chars_on:boolean):byte;
 var
  men2:byte;
 begin
     if chars_on then
      begin
       DrawPartyGuys(13,16,19);
       PushScreen;
      end;
     men2:=0;
     if GlobalStats^.c2alive then
      begin
          menuinfo^.title:=title;
          menuinfo^.choices[0]:='Exit';
          menuinfo^.choices[1]:=GlobalStats^.c1name;
          menuinfo^.choices[2]:=GlobalStats^.c2name;
          if GlobalStats^.c3alive then
           begin
            menuinfo^.choices[3]:=GlobalStats^.c3name;
            menuinfo^.choices[4]:='end';
           end else menuinfo^.choices[3]:='end';
          men2:=Getchoice(men2,0);
     end
     else men2:=1;
     ChooseCharacter:=men2;
     if chars_on then
      begin
       DrawPartyGuys(4,4,4);
       PushScreen;
      end;
 end;
Procedure Drop_Item(which:byte);
 begin
  if which<>255 then rusure('Drop Item');
 end;

Function GetItem;
 Const
  No_Item=255;
  More_Up=254;
  More_Down=253;
 Type
  Temp_Array_Type=Array[0..8] of byte;
 var
  c1,c2:byte;
  last:byte;
  Chosen:boolean;
  Cur:byte;
  Temp_Array:^Temp_Array_Type;
  page:byte;
  Item_Count:byte;
    Function Count_Items(start:byte):byte;
     var
      tmp1,tmp2:byte;
     begin
      tmp1:=0;
      For tmp2:=start to Num_of_Items do
        if GlobalStats^.Item_Quant[tmp2]<>0
         then inc(tmp1);
      Count_Items:=tmp1;
     end;
    Procedure Seed_Array;
     var
      c1,c2:byte;
     begin
      Item_Count:=Count_Items(0);
      For c1:=0 to 8 do
       Temp_Array^[c1]:=No_Item;

      c1:=0;
      If Page<>0 then
       begin
        temp_array^[0]:=more_up;
        c2:=0;
        if (c1<Num_of_Items) then
         While ((c1<>Num_of_Items) and (c2<>(page*9-1))) do
           begin
            if GlobalStats^.Item_Quant[c1]<>0 then inc(c2);
            inc(c1);
           end;
       end;

      c2:=0;
      While (c1<>Num_of_Items) do
         begin
          if GlobalStats^.Item_Quant[c1]<>0 then
           begin
            While (Temp_Array^[c2]<>No_Item) and (c2<8) do inc(c2);
            Temp_Array^[c2]:=c1;
            if c2=8 then c1:=Num_of_Items-1;
           end;
          inc(c1);
         end;

      If Temp_Array^[7]<>No_Item then
        case Count_Items(Temp_Array^[7]+1) of
         0: begin end;
         1: begin
             For c1:=Num_of_Items downto Temp_Array^[7]+1 do
              if GlobalStats^.Item_Quant[Temp_Array^[c1]] <>0
               then Temp_Array^[8]:=c1;
           end;
         else begin
             Temp_Array^[8]:=More_Down;
           end;
       end;
     end;
  Procedure Draw_Text;
   var
    c1:byte;
   begin
    drawpanel(0);
    last:=9;
    For c1:=8 downto 0 do
     begin
      case Temp_Array^[c1] of
       no_item: last:=c1;
       more_up: MenuInfo^.choices[c1+1]:='- More -';
       more_down: MenuInfo^.choices[c1+1]:='- More -';
       else str(GlobalStats^.Item_Quant[Temp_Array^[c1]],MenuInfo^.choices[c1+1]);
       end;
     end;
    if last<>0 then
    for c1:=1 to last do
      begin
       if (Temp_Array^[c1-1]<>More_Up) and (Temp_Array^[c1-1]<>More_Down) then
       OutTextXy3d4(225,40+c1*15+2,2,3,55,1,0,Item_Name(Temp_Array^[c1-1]));
      end;
    if last<>0 then
    for c1:=1 to last do
     begin
      if ((Temp_Array^[c1-1]<>More_Up) and (Temp_Array^[c1-1]<>More_Down)) then
       OutTextXyChoise(315-(length(MenuInfo^.choices[c1])*8),
       40+c1*15,c1,MenuInfo^.choices[c1])
      else
       OutTextXyChoise(270-(8*4),
       40+c1*15,c1,MenuInfo^.choices[c1])
     end;
     OutTextXyChoise(270-(4*4),40,0,'Exit');
     OutTextXyChoise(270-(9*4),10,10,'Inventory');
   end;


 begin
  page:=0;
  new(Temp_Array);
  Seed_Array;

  For c1:=1 to 7 do
     asetrgbpalette(c1+55,(c1*1+20),(c1*5+25),(c1*3+20));
  panelclose;
   {switch, 0 is now exit, not 1st element.. kinda}
  Draw_Text;

  cur:=0;
  if last<>0 then
   for c1:=1 to (last) do
     DulText(c1);
  HiText(0);

  panelup;

  while ButtonDown do;
  repeat
  Chosen:=False;
  if not(somethingdown) then last_key:=255;
   If up then
    begin
     DulText(Cur);
     If Cur=0 then Cur:=last else            {If more than 5 options}
     Cur:=Cur-1;                          {adjust here}
     HiText(Cur);
    end;
   If down then    {If more than 5 options}
    begin                                       {adjust here}
     DulText(Cur);
     If Cur=last then Cur:=0 else
     Cur:=Cur+1;
     HiText(Cur);
    end;
   If PowerKey1 then
    begin
     if Temp_Array^[cur-1]=More_Up then
      begin
       dec(page);
       seed_array;
       Draw_Text;
       PanelUp_instant;
       if Temp_array^[cur-1]<>More_Up then
        begin
         cur:=last;
         for c1:=1 to 9 do DulText(c1);
         HiText(cur);
        end;
      end
     else if Temp_Array^[cur-1]=More_down then
      begin
       inc(page);
       seed_array;
       Draw_Text;
       PanelUp_instant;
       if (Temp_array^[cur-1]<>More_Down) then
        begin
         cur:=1;
         for c1:=2 to 9 do DulText(c1);
         HiText(cur);
        end;
      end
     else
      begin
       if cur=0 then Chosen:=true else
        begin if RUSure('This Item') then Chosen:=True end;
      end;
    end;
   If EscapeKey then
    begin
     DulText(Cur);
     Cur:=0;
     Chosen:=True;
     HiText(Cur);
     while (ButtonDown) do;
    end;
  until Chosen;
  if cur<>0 then
    getitem:=Temp_Array^[cur-1]
  else
    getitem:=No_Item;

    dispose(temp_array);
 end;



Function GetChoice;
 var
  c1,c2:byte;
  last:byte;
  Chosen:boolean;
 begin
  panelclose;
  drawpanel(0);
  HiText(10);
  last:=9;
  for c1:=9 downto 2 do
   begin
    if MenuInfo^.choices[c1]=('end') then last:=c1-1;
   end;
  for c1:=0 to last do
   DulText(c1);
  HiText(cur);
  OutTextXyChoise(270-(length(MenuInfo^.title)*4),10,10,MenuInfo^.title);
  for c1:=0 to last do
   OutTextXyChoise(270-(length(MenuInfo^.choices[c1])*4),
   40+c1*15,c1,MenuInfo^.choices[c1]);
  panelup;


  while ButtonDown do;
  repeat
  Chosen:=False;
  if not(somethingdown) then last_key:=255;
   If up then
    begin
     DulText(Cur);
     If Cur=0 then Cur:=last else            {If more than 5 options}
     Cur:=Cur-1;                          {adjust here}
     HiText(Cur);
    end;
   If down then    {If more than 5 options}
    begin                                       {adjust here}
     DulText(Cur);
     If Cur=last then Cur:=0 else
     Cur:=Cur+1;
     HiText(Cur);
    end;
   If PowerKey1 then Chosen:=True;
   If EscapeKey then
    begin
     DulText(Cur);
     Cur:=escape;
     Chosen:=True;
     HiText(Cur);
     while (ButtonDown) do;
    end;
  until Chosen;
  getchoice:=cur;
 end;

Function RUSure(text:string):boolean;
 type
  bufarray=array[0..98,0..29] of byte;
 var
  buffer:^bufarray;
  c1,c2,c3:byte;
  chosen:boolean;
  convar:byte;
 begin
  new(buffer);
  for c1:=0 to 98 do
  for c2:=0 to 29 do
   begin
    buffer^[c1,c2]:=TheScreen^[(c1+110)+(320*50)+(c2*320)];
   end;

  for c3:=0 to 5 do
  begin
  for c2:=0 to 29 do
  for c1:=0 to 98 do
   if random(5)=1 then
   putpixel(c1+110,c2+50,9-(c2 div 4));
  waitscreen;
  pushscreen;
  end;

  for c1:=0 to 98 do
  for c2:=0 to 29 do
   putpixel(c1+110,c2+50,9-(c2 div 4));

  for c3:=0 to 3 do
  begin
  for c2:=2 to 27 do
  for c1:=2 to 96 do
   if random(3)=1 then
   putpixel(c1+110,c2+50,(c2+1) div 3);
  waitscreen;
  pushscreen;
  end;

  for c1:=2 to 96 do
  for c2:=2 to 27 do
   putpixel(c1+110,c2+50,(c2+1) div 3);

  OutTextXYChoise(160-((length(text)+1)*4),55,11,text+'?');
  OutTextXYChoise(122,67,12,'yes');
  OutTextXYChoise(180,67,13,'no');
  convar:=12;
     HiText(12);
     DulText(13);
     HiText(11);

  waitscreen;
  pushscreen;

    while ButtonDown do;


  Chosen:=false;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;
   if left then
    begin
     HiText(12);
     DulText(13);
     ConVar:=12;
    end;
   if right then
    begin
     DulText(12);
     HiText(13);
     ConVar:=13;
    end;
   If PowerKey1 then Chosen:=True;
   If EscapeKey then
    begin
     ConVar:=13;
     Chosen:=True;
     while (ButtonDown) do;
    end;
  until Chosen;

  for c1:=0 to 98 do
  for c2:=0 to 29 do
   begin
    TheScreen^[(c1+110)+(320*50)+(c2*320)]:=buffer^[c1,c2];
   end;
   dispose(buffer);
  while ButtonDown do;
   pushscreen;
  if convar=12 then RUSure:=true else RUSure:=false;

 end;


Procedure MainMenu(var ConVar:byte);
 var
  c1:integer;
  cycle:byte;
  Pal:PaletteType;
  Chosen:boolean;
 begin
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('icebk.Btm');            {BackGround}
  brownpal;
  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,5+c1,5+c1,5+c1*2);
   asetrgbpalette(110,10,5,0);
  for c1:=1 to 7 do
   asetrgbpalette(c1+110,c1*8+4,c1*6+4,c1*3+5);


     DulText(0);
     DulText(1);
     DulText(2);
     HiText(ConVar);


   LoadFont2;                              {Actual Texts}
   OutTextXyBW2(81,9,110,'Main  Menu');
   OutTextXyBW2(79,9,110,'Main  Menu');
   OutTextXyBW2(81,11,110,'Main  Menu');
   OutTextXyBW2(79,11,110,'Main  Menu');

   OutTextXynorm2(80,10,110,'Main  Menu');

   KillFont2;

   OutTextXYChoise(120,70,0,'Enter Game');
   OutTextXYChoise(124,90,1,' Credits');
   OutTextXYChoise(120,110,2,'   Quit');


  FetchPal(Pal);           {Get PAllette for loop}


  PushFadeIn(10);          {Quickly Bring up menu}
  while ButtonDown do;

  cycle:=0;      {For color cycle}
  setrate(512);
  f_clk[0] := 20;
  Chosen:=false;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;
   if f_Clk[0]=0 then
    begin
     f_clk[0] := 20;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;

   if up then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=2 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     HiText(ConVar);
    end;                                    {
   If (d=('2')) or (Zeroed and (d=#80)) then }   {If more than 5 options}
   If down then
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=2 then ConVar:=0 else
     ConVar:=ConVar+1;
     HiText(ConVar);
    end;
   If PowerKey1 then Chosen:=True;
   If EscapeKey then
    begin
     DulText(ConVar);
     ConVar:=2;
     Chosen:=True;
     HiText(ConVar);
     while (ButtonDown) do;
    end;
   if chosen and (convar=2) then if not (rusure('DOS')) then chosen:=false;
  until Chosen;
  FadeOut(2);
 end;

Procedure TitleScreen;
 var
  Tempscr:VirtScrPtr;
  ts:string;
  c1,c2:byte;
  pal:palettetype;
  temp:^Pop_Text_line;
  Words:STBPtr;
  filez:file of Pop_Text_background;
 begin
  new(tempscr);
  LoadPopTxtBk;{
  LoadFont4;    }
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('RT.Btm');
  For c1:=1 to 7 do
     asetrgbpalette(c1,c1*1,c1*3,c1*4);
  For c1:=1 to 7 do
     asetrgbpalette(c1+7,c1*1+30,c1*3+40,c1*5+20);
  For c1:=1 to 7 do
     asetrgbpalette(c1+14,c1*3+40,c1*5+20,c1*1+30);
     FetchPal(pal);
  For c1:=1 to 255 do
     asetrgbpalette(c1,(c1 div 6),(c1 div 10),(c1 div 20));
  PushFadeIn(40);
  Outtextxy3D4(85,7,1,1,8,1,1,'Zaskoda Soft presents:');
  Outtextxy3D4(261,191,1,1,15,1,1,' C 1995');
  Outtextxy3D4(261,191,1,1,8,1,1,'[ ]');
  Fadeto(70,pal);
  For c1:=1 to 7 do
    begin
     asetrgbpalette(c1,0,0,0);
     asetrgbpalette(c1+7,0,0,0);
     asetrgbpalette(c1+14,0,0,0);
    end;
  Pushscreen;
  Fadeto(30,pal);
  tempscr^:=TheScreen^;
  ts:='Chapter 1: A Past Forgotten';



  for c2:=0 to 8 do
   begin
   TheScreen^:=tempscr^;
    for c1:=0 to length(ts) do
      Outtextxy3D4(90+(c1*c2),162,1,1,15,1,1,ts[c1]);
      waitscreen;
      pushscreen;
   end;
  while ButtonDown do;
  while not(ButtonDown) do;
  while ButtonDown do;
  ClearFunk1;
  fadeout(1);{
  killfont4;  }
  dispose(tempscr);
 end;


Procedure Credits;
 var
  c1,c2,c3:byte;
  Temp:VirtScrPtr;
 begin
  FadeOut(20);
  ClearSCreen;
  PushScreen;
  DispFullBtmBuf('aseds.Btm');
  New(Temp);
  Temp^:=TheSCreen^;
  For c1:=1 to 5 do
   asetRgbPalette(c1,63-c1*7,63-c1*7,63-c1*2);
  For c1:=1 to 5 do
   asetRgbPalette(c1+5,63-(c1*8),63-(c1*4),63-(c1*9));
  For c1:=1 to 5 do
   asetRgbPalette(c1+10,63-(c1*2),63-(c1*7),63-(c1*7));
  PushFadeIn(20);


  c1:=0;
  while ButtonDown do;
  While Not(ButtonDown) do
   begin
    if c1<10 then
     begin
      c1:=c1+1;
      AsmPush(temp,TheScreen);
      OutTextXyRange1(40 ,15*c1,1,'This game is dedicated to:');
      OutTextXyRange1(60,17*c1,7,'        Amanda June Eldridge');
      PushScreen;
     end;
   end;

  While c1>0 do
   begin
     begin
      c1:=c1-1;
      AsmPush(temp,TheScreen);{
      TheScreen^:=Temp^;       }
      OutTextXyRange1(50 ,5*c1,11,'Production-');
      OutTextXyRange1(60 ,6*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,7*c1,1,'Scott Farrell');
      OutTextXyRange1(60 ,8*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,6*c1,6,'Zaskoda');{
      OutTextXyRange1(200,7*c1,6,'Neuro-XTC');
      OutTextXyRange1(200,8*c1,6,'ICEMAN');  }

      OutTextXyRange1(50 ,10*c1,11,'Art-');
      OutTextXyRange1(60 ,11*c1,1,'Scott Dudley');{
      OutTextXyRange1(60 ,12*c1,1,'Klint Bower');  }
      OutTextXyRange1(200,11*c1,6,'Zaskoda');       {
      OutTextXyRange1(200,12*c1,6,'IceMan');  }

      OutTextXyRange1(50 ,14*c1,11,'Code-');
      OutTextXyRange1(60 ,15*c1,1,'Scott Dudley');
      OutTextXyRange1(200,15*c1,6,'Zaskoda');
      PushScreen;
     end;
   end;
  FadeOut(20);
  Dispose(Temp);
  temp:=nil;
  While GlobalKeyDown do;
 end;

Procedure PreScreens;
 var
  pal1:palettetype;
  var c1:byte;
 begin
  for c1:=0 to 255 do
   begin
    pal1[c1].r:=63;
    pal1[c1].g:=63;
    pal1[c1].b:=63;
   end;
  clearscreen;pushscreen;
  DispFullBtmBuf('ZasElec.Btm');
  PushFadeIn(200);
  Fadeto(70,pal1);
  FadeOut(50);
 end;

Procedure GameSelect(var Wich:byte;New:boolean);
 var
  c1,convar:byte;
  cycle:byte;
  Pal:PaletteType;
  Chosen,Zeroed:boolean;
 begin
  convar:=4;
  if not(new) then convar:=5;
  ClearScreen;
  PushScreen;
  DispFullBtmBuf('grid.Btm');
  DispFullBtmBuf('wrpbk2.Btm');            {BackGround}
  brownpal;
  PopLoadBacks;


  For c1:=0 to 19 do                     {LGB colors}
   AsetRgbPalette(c1+34,c1*3,c1*2,c1*1);
  for c1:=1 to 9 do                      {Texts Colors}
   asetrgbpalette(c1,5+c1,5+c1,5+c1*2);
  for c1:=0 to 10 do
   asetrgbpalette(c1+110,c1*2+30,0,0);
     DulText(0);
     DulText(1);
     dulText(2);
     dulText(3);
     DulText(4);
     DulText(5);
     HiText(convar);

   OutTextXyChoise(135,16,0, 'Too Fast');
   OutTextXyChoise(135,56,1, '  Fast ');
   OutTextXyChoise(135,96,2, ' Normal');
   OutTextXyChoise(135,136,3,'  Slow ');
  if new then
  begin
   OutTextXyChoise(107,165,4,'Start NEW Game');
   OutTextXyChoise(127,185,5,'Exit Menu');
  end
   else
   OutTextXyChoise(127,175,5,'Exit Menu');



  FetchPal(Pal);           {Get PAllette for loop}
  PushFadeIn(10);          {Quickly Bring up menu}
  while ButtonDown do;

  cycle:=0;      {For color cycle}
  setrate(512);
  f_clk[0] := 20;
  repeat
  if not(SomethingDown) then last_key:=255;
  Chosen:=False;

   if f_Clk[0]=0 then
    begin
     f_clk[0] := 20;
     Cycle:=Cycle+1;
     cycle:=TopCap(Cycle);
     SetCycle(Cycle,Pal);
    end;
   If Up then
    begin
     DulText(ConVar);
     If ConVar=0 then ConVar:=5 else            {If more than 5 options}
     ConVar:=ConVar-1;                          {adjust here}
     if (not(new)) and (ConVar=4) then ConVar:=3;
     HiText(ConVar);
    end;
   If Down then                       {If more than 5 options}
    begin                                       {adjust here}
     DulText(ConVar);
     If ConVar=5 then ConVar:=0 else
     ConVar:=ConVar+1;
     if (not(new)) and (ConVar=4) then ConVar:=5;
     HiText(ConVar);
    end;
   If PowerKey1 then Chosen:=True;
   If EscapeKey then
    begin
     ConVar:=5;
     Chosen:=True;
     while (ButtonDown) do;
    end;
  until Chosen;
  FadeOut(2);
  Wich:=Convar;                                 {
  if convar=5 then play :=false else play:=true; }
 end;

begin
end.