{this is an editor for yo average 20x20 block in proj}

program BKLEdit;
uses graphics,fonts,crt,smouse;
type
 setbyte=set of 0..19;
 BKLLine=array[0..19]of byte;
 BKL=array[0..19] of BKLLine;
 bklset=array[0..255] of ^bkl;
 palettetype=array[0..255] of record
   r,g,b:byte;
  end;

 BtmRec=Record
    Pal:PAlettetype;
    Screen:VirtScr;
   end;
var
 bkup: ^bkl;
 but,mx,my:word;
 current:byte;
 Block:BKLset;
 filename:string[8];
 capname:string[8];
 curcol:byte;
{$I-}

Procedure ShowAllTiles;
 var
  tempscreen:VirtScrPtr;
  c1,c2,c3,c4:byte;
  offset:byte;
  d:char;
 begin
  offset:=0;
  while keypressed do readkey;
  new(tempscreen);
  tempscreen^:=thescreen^;
  clearscreen;
  repeat
  for c3:=0 to 15 do
  for c4:=0 to 9 do
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    putpixel(c3*20+c1,c4*20+c2,Block[c3+c4*16+offset]^[c2][c1]);
   end;
  hidemouse;
  pushscreen;
  showmouse;
   while keypressed do readkey;
   d:=readkey;
   if ((d='+') and (offset<94)) then offset:=offset+4;
   if ((d='-') and (offset>3)) then offset:=offset-4;
   until ((d<>'+') and (d<>'-'));
   while keypressed do readkey;
  hidemouse;
  thescreen^:=tempscreen^;
  dispose(tempscreen);
  pushscreen;
  showmouse;
 end;

PROCEDURE GetRgbPalette(Color : BYTE; VAR Red, Green, Blue : BYTE);
 Begin
  Port[$3C7]:=Color;
  Red:=Port[$3C9];
  Green:=Port[$3C9];
  Blue:=Port[$3C9];
 end;

Procedure MoveAni;
 var
  c1,t1,t2,t3,t4,t5,t6:byte;
 begin
  getrgbpalette(179,t4,t5,t6);
  for c1:=0 to 3 do
   begin
    getrgbpalette(c1+180,t1,t2,t3);
    asetrgbpalette(c1+179,t1,t2,t3);
   end;
  asetrgbpalette(183,t4,t5,t6);
  getrgbpalette(184,t4,t5,t6);
  for c1:=0 to 3 do
   begin
    getrgbpalette(c1+185,t1,t2,t3);
    asetrgbpalette(c1+184,t1,t2,t3);
   end;
  asetrgbpalette(188,t4,t5,t6);

 end;
Procedure PutPixelDirect(c1,c2:integer;col:byte);
 begin
  mem[$a000:c1+c2*320]:=col;
 end;
procedure Load(var Success:Boolean);
 var
  filez:File of BKL;
  c1:byte;
 begin
  success:=false;
  Assign(Filez,FileName+'.set');
  Reset(filez);
  if IOResult=0 then
   begin
    success:=true;
    for c1:=0 to 255 do
    read(filez,Block[c1]^);
    Close(Filez);
   end;
 end;
Procedure Save(var Success:Boolean);
 var
  filez:File of BKL;
  c1:byte;
 begin
  Assign(Filez,FileName+'.set');
  Rewrite(filez);
    success:=false;
  if IOResult=0 then
   begin
    success:=true;
    for c1:=0 to 255 do
    Write(filez,Block[c1]^);
    Close(Filez);
   end;
 end;
Procedure pressed(x1,y1,x2,y2:integer);
 var
  c1,c2:integer;
 begin
  for c1:=x1 to (x2-1) do
   PutpixelDirect(c1,y1,252);
  for c1:=(x1+1) to x2 do
   PutpixelDirect(c1,y2,254);
  for c1:=y1 to (y2-1) do
   putpixelDirect(x2,c1,254);
  for c1:=(y1+1) to y2 do
   putpixelDirect(x1,c1,252);
  PutpixelDirect(x1,y1,251);
  PutpixelDirect(x2,y2,255);
 end;
Procedure Box3dUp(x1,y1,x2,y2:integer);
 var
  c1,c2:integer;
 begin
  for c1:=x1 to (x2-1) do
   Putpixel(c1,y1,254);
  for c1:=(x1+1) to x2 do
   Putpixel(c1,y2,252);
  for c1:=y1 to (y2-1) do
   putpixel(x2,c1,252);
  for c1:=(y1+1) to y2 do
   putpixel(x1,c1,254);
  Putpixel(x1,y1,255);
  Putpixel(x2,y2,251);
 end;
Procedure PutNum;
 var
  temp:string;
  c1,c2:byte;
 begin
  str(current,temp);
  for c1:=230 to 252 do
  for c2:=14 to 22 do
  putpixel(c1,c2,250);
  if length(temp)=1 then temp:=('  ')+temp;
  if length(temp)=2 then temp:=(' ')+temp;
  outtextxynorm1(230,14,246,temp);
 end;
Procedure Box3dDown(x1,y1,x2,y2:integer);
 var
  c1,c2:integer;
 begin
  for c1:=x1 to (x2-1) do
   Putpixel(c1,y1,252);
  for c1:=(x1+1) to x2 do
   Putpixel(c1,y2,254);
  for c1:=y1 to (y2-1) do
   putpixel(x2,c1,254);
  for c1:=(y1+1) to y2 do
   putpixel(x1,c1,252);
  Putpixel(x1,y1,251);
  Putpixel(x2,y2,255);
 end;
Procedure ColorBar;
 var
  c1,c2:integer;
  d:string;
 begin
  for c1:=297 to 316 do
  for c2:=3 to 9 do
   putpixel(c1,c2,curcol);

  for c1:=230 to 252 do
  for c2:=25 to 33 do
   putpixel(c1,c2,0);

  str(curcol,d);
  outtextxynorm1(230,25,246,d);
 end;
Procedure SetUpPal;
 var
  c1,c2,c3:byte;
 begin
  for c1:=1 to 127 do
  asetrgbpalette(c1,63,63,63);
  asetrgbpalette(31,63,45,63);{
  for c1:=0 to 4 do
  for c2:=0 to 4 do
  for c3:=0 to 4 do
   asetrgbpalette(c1+c2*5+c3*25+64,c1*15+3,c2*15+3,c3*15+3);}
  for c1:=0 to 9 do
   asetrgbpalette(c1+64,c1*4+17,c1*4+17,c1*4+17);
  for c1:=0 to 9 do
   asetrgbpalette(c1+74,c1,c1*4+25,c1);
  for c1:=0 to 9 do
   asetrgbpalette(c1+84,c1,c1,c1*4+25);
  for c1:=0 to 9 do
   asetrgbpalette(c1+94,c1*3+30,c1*2+15,c1+7);
  for c1:=0 to 4 do
   asetrgbpalette(c1+104,c1*3+30,c1,c1);
  for c1:=0 to 1 do
   asetrgbpalette(c1+109,c1*3+7,c1*3+7,c1*3+10);
  for c1:=2 to 3 do
   asetrgbpalette(c1+109,c1*6+40,c1*6+40,63);
   asetrgbpalette(113,63,63,63);
  for c1:=0 to 2 do
   asetrgbpalette(c1+114,c1*6+15,c1*3+7,c1*2+2);
  for c1:=0 to 1 do
   asetrgbpalette(c1+117,23+c1*5,23+c1*5,35+c1*6);
  for c1:=0 to 4 do
   asetrgbpalette(c1+119,c1*5+35,c1*6+35,c1*2);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*5+35,c1*2,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+124,c1*2,c1*5+35,c1*6+35);
  for c1:=0 to 4 do
   asetrgbpalette(c1+129,c1*6+10,c1*3+4,c1*7+10);
  for c1:=0 to 4 do
   asetrgbpalette(c1+134,8+c1*3,4,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+139,4,8+c1*3,4);
  for c1:=0 to 4 do
   asetrgbpalette(c1+144,4,4,8+c1*3);
  for c1:=0 to 4 do
   asetrgbpalette(c1+149,c1*5+11,c1*5+15,c1*5+30);
  for c1:=0 to 4 do
   asetrgbpalette(c1+154,5+c1*2,5+c1*2,5+c1*2);{
  For c1:=0 to 9 do
   asetrgbpalette(c1+154,0,c1*2+10,c1*4+20);
  for c1:=0 to 4 do
   asetrgbpalette(c1+154,c1*10+20,c1*5+10,c1*2+5); }
  for c1:=0 to 4 do
   asetrgbpalette(c1+159,c1*3+15,c1*2+7,c1+2);{
  for c1:=0 to 4 do
   begin
   asetrgbpalette(c1+179,c1,c1,c1*7+25);
   asetrgbpalette((179+9)-c1,c1,c1,c1*7+25);
   end;                                        }
  for c1:=0 to 4 do
   begin
    asetrgbpalette(c1+164,50-(c1*2),46-(c1*5),36-(c1*6));
   end;
  for c1:=0 to 4 do
   begin
    asetrgbpalette(c1+169,c1*2,c1*5,c1*4);
   end;
    asetrgbpalette(174,33,14,7);
    asetrgbpalette(175,30,11,5);
    asetrgbpalette(176,26,9,4);

  for c1:=0 to 2 do
   asetrgbpalette(c1+179,c1*5+46,c1*3+10,c1*2+10);
  for c1:=3 to 4 do
   asetrgbpalette(c1+179,(5-c1)*5+46,(5-c1)*3+10,(5-c1)*2+10);

  for c1:=0 to 2 do
   asetrgbpalette(c1+184,c1*2+5,c1*2+5,c1*5+35);
  for c1:=3 to 4 do
   asetrgbpalette(c1+184,(4-c1)*2+5,(4-c1)*2+5,(4-c1)*5+35);

   {
   asetrgbpalette(188,63,63,63);         }
 end;
Procedure LayOutColors;
 var
  c1,c2,c3,c4:integer;
 begin
  box3ddown(284,18,318,171);
  box3dup(285,19,317,170);
  for c1:=0 to 4 do
  for c2:=0 to 24 do
   for c3:=0 to 5 do
   for c4:=0 to 5 do
    putpixel(286+c1*6+c3,20+c2*6+c4,c1+c2*5+64);
  box3ddown(268,18,282,32);
  box3dup(269,19,281,31);
  for c3:=0 to 10 do
  for c4:=0 to 10 do
   begin
    putpixel(270+c3,20+c4,0);
   end;
                                               {
  for c1:=210 to 309 do
  for c2:=30 to 35 do
   putpixel(c1,c2,(c1-210) div 5);              }
 end;
Procedure PutName;
 begin
  Box3DUp(225,1,294,11);
  outtextxynorm1(228+((8-Length(filename))*4),2,246,FileName);
 end;
function RUSure(what:String):boolean;
 var
  d:char;
  c1,c2:integer;
  done:boolean;
  zeroed:boolean;
 begin
  Box3dDown(201,186,284,198);
  Box3dUp(240,187,258,197);
  Box3dUp(260,187,278,197);
  OuttextxyNorm1(203,188,246,What);
  OuttextxyNorm1(245,188,241,'Y');
  OuttextxyNorm1(265,188,241,'N');
  hidemouse;
  pushscreen;
  setlimits(239*2,277*2,186,196);
  showmouse;
  d:=(' ');
  done:=false;


  repeat
   if keypressed then
    begin
     d:=readkey;
     zeroed:=false;
     if d=#0 then
      begin
       zeroed:=true;
       d:=readkey;
      end
    end;
   If ButtonPressed(1) then
    begin
     if mousein(238*2,186,256*2,196) then
      begin
       hidemouse;
       pressed(240,187,258,197);
       showmouse;
       repeat until not(buttonpressed(1)) or
       not(mousein(238*2,186,256*2,196));
       if mousein(238*2,186,256*2,196) then
        begin
         done:=true;
         RUSure:=True;
        end;
       hidemouse;
       pushscreen;
       showmouse;
      end;
     if mousein(258*2,186,276*2,197) then
      begin
       hidemouse;
       pressed(260,187,278,197);
       showmouse;
       repeat until not(buttonpressed(1)) or
       not(mousein(258*2,186,276*2,197));
       if mousein(258*2,186,276*2,197) then
        begin
         done:=true;
         RUSure:=False;
        end;
       hidemouse;
       pushscreen;
       showmouse;
      end;
    end;
   If not(zeroed) then
    begin
     if d=#27 then
      begin
       done:=True;
       RUSURE:=False;
      end;
     if upcase(d)=('Y') then
      begin
       done:=True;
       RUSURE:=true;
      end;
     if upcase(d)=('N') then
      begin
       done:=True;
       RUSURE:=false;
      end;
    end;
  until done;
  for c1:=201 to 284 do
  for c2:=186 to 198 do
   putpixel(c1,c2,253);
  hidemouse;
  pushscreen;
  setlimits(1,634,1,197);
  showmouse;

 end;
Procedure SetAllBits(Col:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   Block[current]^[c2][c1]:=col;
 end;
Procedure FatBit(x,y,color:byte);
 var
  c1,c2:byte;
 begin
  for c1:=1 to 8 do
  for c2:=1 to 8 do
   putpixel(x*10+c1,y*10+c2,color);
 end;
Procedure AllFatBits;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    FatBit(c1,c2,Block[current]^[c2][c1]);
    putpixel(203+c1,3+c2,Block[current]^[c2][c1]);
    putpixel(233+c1,123+c2,Block[current]^[c2][c1]);
   end;
 end;
Procedure SwapBK;
 var
  c1,c2,temp:byte;
 begin
   for c1:=0 to 19 do
   for c2:=0 to 19 do
    begin
      temp:=Block[current]^[c2][c1];
      Block[current]^[c2][c1]:=BKUP^[c2][c1];
      BKUP^[c2][c1]:=temp;
    end;
    AllFatBits;
 end;
Procedure DoBK;
 var
  c1,c2,temp:byte;
 begin
   for c1:=0 to 19 do
   for c2:=0 to 19 do
    begin
      BKUP^[c2][c1]:=Block[current]^[c2][c1];
    end;
 end;


Procedure PutColor(x,y:byte);
 begin
  if block[current]^[y][x]<>curcol then
  begin
  FatBit(x,y,curcol);
  putpixel(203+x,3+y,curcol);

  putpixel(233+x,123+y,curcol);
  BLOCK[current]^[y][x]:=curcol;
  hidemouse;
  pushscreen;
  showmouse;
  end;
 end;
Procedure GetName;
 var
  d:char;
  c1,c2,curd:integer;
  New:String;
  Zeroed,Done:boolean;
 begin
  new:=Filename;
  for c1:=225 to 294 do
  for c2:=1 to 11 do
  PutPixel(c1,c2,253);
  Box3DDown(225,1,294,11);
  curd:=Length(New);
  outtextxynorm1(226,2,241,New);
  For c2:=0 to 4 do
   begin
    putpixel(227+curd*8,10-c2,c2+246);
    putpixel(227+curd*8,2+c2,c2+246);
    putpixel(228+curd*8,2+c2,250-c2);
    putpixel(228+curd*8,10-c2,250-c2);
    putpixel(229+curd*8,10-c2,c2+246);
    putpixel(229+curd*8,2+c2,c2+246);
   end;
  HideMouse;
  Pushscreen;
  d:=(' ');
  done:=false;
  repeat
  for c1:=226 to 293 do
  for c2:=2 to 10 do
  PutPixel(c1,c2,253);
  curd:=Length(New);
  outtextxynorm1(226,2,241,New);
  For c2:=0 to 4 do
   begin
    putpixel(227+curd*8,10-c2,c2+246);
    putpixel(227+curd*8,2+c2,c2+246);
    putpixel(228+curd*8,2+c2,250-c2);
    putpixel(228+curd*8,10-c2,250-c2);
    putpixel(229+curd*8,10-c2,c2+246);
    putpixel(229+curd*8,2+c2,c2+246);
   end;
   Pushscreen;

   d:=readkey;
   Zeroed:=False;
   d:=Upcase(d);
   If (not(Zeroed)) and (d='-') then
    begin
     New:=New+d;
    end;
   If (not(Zeroed)) and (ord(d)>64) and (ord(D)<91) and (CURD<8) then
    begin
     New:=New+d;
    end;
   If (not(Zeroed)) and (ord(d)>47) and (ord(D)<58) and (CURD<8) then
    begin
     New:=New+d;
    end;
   If (Not(Zeroed)) and (d=#8) and (curd>0) then
    begin
     new:=Copy(new,1,curd-1);
    end;
   if d=#0 then
    begin
     zeroed:=true;
     d:=readkey;
    end;
   If d=#27 then done:=true;
   if d=#13 then
    begin
     if new<>('') then FileName:=New;
     Done:=True;
    end;
  Until Done;
  for c1:=225 to 294 do
  for c2:=1 to 11 do
  PutPixel(c1,c2,253);
  PutName;
  Pushscreen;
  showmouse;
 end;

Function FindBest(r,g,b:byte):byte;
 var
  c1,c2,c3,off:integer;
  t1,t2,t3:byte;
 begin
  getrgbpalette(0,t1,t2,t3);
  off:=abs(r-t1)+abs(g-t2)+abs(b-t3)+
      (((abs(abs(r-t1)-abs(g-t2)))+
      (abs(abs(r-t1)-abs(b-t3)))+
      (abs(abs(g-t2)-abs(b-t3)))) div 3);
  findbest:=0;
  for c1:=64 to 188 do
   begin
    getrgbpalette(c1,t1,t2,t3);
    if off>abs(r-t1)+abs(g-t2)+abs(b-t3)+
      (((abs(abs(r-t1)-abs(g-t2)))+
      (abs(abs(r-t1)-abs(b-t3)))+
      (abs(abs(g-t2)-abs(b-t3)))) div 3) then
     begin
      off:=abs(r-t1)+abs(g-t2)+abs(b-t3)+
      (((abs(abs(r-t1)-abs(g-t2)))+
      (abs(abs(r-t1)-abs(b-t3)))+
      (abs(abs(g-t2)-abs(b-t3)))) div 3);

      findbest:=c1;
     end;
   end;
 end;
Procedure Katch;
 var
  ScreenCap,picture:^BtmRec;
  filez:file of BtmRec;
  c1,c2,hi:word;
  temppic:bkl;
 begin
  temppic:=block[current]^;
  New(Picture);
  Assign(filez,'Katch.btm');
  Reset(Filez);
  Read(Filez,Picture^);
  Close(filez);
  New(ScreenCap);
  ScreenCap^.Screen:=TheScreen^;
  For c1:=0 to 255 do
   getrgbpalette(c1,ScreenCap^.pal[c1].r,ScreenCap^.pal[c1].g,
   ScreenCap^.pal[c1].b);
  For c1:=0 to 255 do
   asetrgbpalette(c1,Picture^.pal[c1].r,Picture^.pal[c1].g,
   Picture^.pal[c1].b);
  TheScreen^:=Picture^.Screen;
  hi:=findbest(63,63,63);
  hidemouse;
  pushscreen;

   {stuff}
   repeat
    getmouseposition(but,mx,my);
    For c1:=(mx div 2) to (mx div 2)+19 do
     begin
      if (c1<320) and (c1>-1) and (my-1>-1) and (my-1<200) then
      putpixel(c1,my-1,hi);
      if (c1<320) and (c1>-1) and (my+18>-1) and (my+18<200) then
      putpixel(c1,my+18,hi);
     end;
    For c2:=my-1 to my+18 do
     begin
      if (mx div 2<320) and (mx div 2>-1) and (c2>-1) and (c2<200) then
      putpixel(mx div 2,c2,hi);
      if (mx div 2+19<320) and (mx div 2>-1) and (c2>-1) and (c2<200) then
      putpixel(mx div 2+19,c2,hi);
     end;
    Pushscreen;
    TheScreen^:=Picture^.Screen;
   until (buttonpressed(1)) or keypressed;
   {stuff}
  For c1:=0 to 255 do
   asetrgbpalette(c1,ScreenCap^.pal[c1].r,ScreenCap^.pal[c1].g,
   ScreenCap^.pal[c1].b);
  For c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    block[current]^[c2][c1]:=findbest(
    Picture^.Pal[TheScreen^[(mx div 2+c1)+(my-1+c2)*320]].r,
    Picture^.Pal[TheScreen^[(mx div 2+c1)+(my-1+c2)*320]].g,
    Picture^.Pal[TheScreen^[(mx div 2+c1)+(my-1+c2)*320]].b);
   end;

   {restore screen}
  TheScreen^:=ScreenCap^.Screen;
  Dispose(Picture);
  Dispose(ScreenCap);
  allfatbits;
  Pushscreen;
  showmouse;
  repeat until not(buttonpressed(1));
  while keypressed do readkey;
  if not(RUSure('This')) then
   begin
    block[current]^:=temppic;
    allfatbits;
    hidemouse;
    pushscreen;
    showmouse;
   end;
 end;
Procedure Blend1;
 var
  c1,c2,upc1,downc1,upc2,downc2:byte;
  t1a,t2a,t3a:byte;
  t1b,t2b,t3b:longint;
  temppic:bkl;
 begin
  temppic:=block[current]^;
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if c1=0 then downc1:=19 else downc1:=c1-1;
    if c2=0 then downc2:=19 else downc2:=c2-1;
    if c1=19 then upc1:=0 else upc1:=c1+1;
    if c2=19 then upc2:=0 else upc2:=c2+1;
    sound(c1*c2);
    GetRgbPalette(Block[current]^[c2][c1],t1a,t2a,t3a);
    t1b:=t1a*8;t2b:=t2a*8;t3b:=t3a*8;
    GetRgbPalette(Block[current]^[downc2][downc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[downc2][c1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[c2][downc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[upc2][upc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[c2][upc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[upc2][c1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[downc2][upc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Block[current]^[upc2][downc1],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    t1b:=t1b div 16;
    t2b:=t2b div 16;
    t3b:=t3b div 16;
    temppic[c2][c1]:=FindBest(t1b,t2b,t3b);
   end;
    nosound;
  Block[current]^:=temppic;
  AllFatBits;
  hidemouse;pushscreen;showmouse;
 end;
Procedure Blend2;
 var
  c1,c2:byte;
  t1a,t2a,t3a:byte;
  t1b,t2b,t3b:longint;
  temppic:bkl;
 begin
  hidemouse;
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    sound(c1*c2);
    GetRgbPalette(Mem[$A000:233+(c1)+((c2+123)*320)],t1a,t2a,t3a);
    t1b:=t1a*8;t2b:=t2a*8;t3b:=t3a*8;
    GetRgbPalette(Mem[$A000:233+((c1-1))+(((c2)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1))+(((c2-1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1+1))+(((c2)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1))+(((c2+1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1-1))+(((c2-1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1+1))+(((c2+1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1-1))+(((c2+1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    GetRgbPalette(Mem[$A000:233+((c1+1))+(((c2-1)+123)*320)],t1a,t2a,t3a);
    t1b:=t1b+t1a;  t2b:=t2b+t2a;   t3b:=t3b+t3a;
    t1b:=t1b div 16;
    t2b:=t2b div 16;
    t3b:=t3b div 16;
    Block[current]^[c2][c1]:=FindBest(t1b,t2b,t3b);
   end;
    nosound;
    AllFatBits;
    pushscreen;
    showmouse;
    while keypressed do readkey;
 end;
procedure capture;
 var
  filez:File of BKL;
  tempstr:string;
  c1,c2:integer;
  temppic:bkl;
 begin
  temppic:=block[current]^;
  tempstr:=filename;
  filename:=capname;
  getname;
  Assign(Filez,FileName+'.bkl');
  Reset(filez);
  if IOResult=0 then
   begin
    read(filez,Block[current]^);
    Close(Filez);
   end;
  capname:=filename;
  filename:=tempstr;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
  if not(RUSure('This')) then
   begin
    block[current]^:=temppic;
    allfatbits;
   end;
  for c1:=225 to 294 do
  for c2:=1 to 11 do
  PutPixel(c1,c2,253);
  putname;
    hidemouse;
    pushscreen;
    showmouse;
 end;
Procedure Trans(wich:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if wich= 1 then if thescreen^[213+c1+(103+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[213+c1+(103+c2)*320];
    if wich= 2 then if thescreen^[233+c1+(103+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[233+c1+(103+c2)*320];
    if wich= 3 then if thescreen^[253+c1+(103+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[253+c1+(103+c2)*320];
    if wich= 4 then if thescreen^[213+c1+(123+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[213+c1+(123+c2)*320];
    if wich= 5 then if thescreen^[253+c1+(123+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[253+c1+(123+c2)*320];
    if wich= 6 then if thescreen^[213+c1+(143+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[213+c1+(143+c2)*320];
    if wich= 7 then if thescreen^[233+c1+(143+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[233+c1+(143+c2)*320];
    if wich= 8 then if thescreen^[253+c1+(143+c2)*320] <>0 then
     Block[current]^[c2][c1]:=thescreen^[253+c1+(143+c2)*320];
   end;
 end;
Procedure revT(wich:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if wich= 1 then if thescreen^[213+c1+(103+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 2 then if thescreen^[233+c1+(103+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 3 then if thescreen^[253+c1+(103+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 4 then if thescreen^[213+c1+(123+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 5 then if thescreen^[253+c1+(123+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 6 then if thescreen^[213+c1+(143+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 7 then if thescreen^[233+c1+(143+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
    if wich= 8 then if thescreen^[253+c1+(143+c2)*320] =0 then
     Block[current]^[c2][c1]:=0;
   end;
  end;
Procedure Move(dir:byte);
 var
  c1,c2:byte;
  temp:array[0..19] of byte;
 begin
  if dir=1 then
   begin
    for c2:=0 to 19 do
     temp[c2]:=block[current]^[c2][0];
    for c1:=1 to 19 do
    for c2:=0 to 19 do
     block[current]^[c2][c1-1]:=block[current]^[c2][c1];
    for c2:=0 to 19 do
     block[current]^[c2][19]:=temp[c2];
   end;
  if dir=2 then
   begin
    for c2:=0 to 19 do
     temp[c2]:=block[current]^[0][c2];
    for c1:=1 to 19 do
    for c2:=0 to 19 do
     block[current]^[c1-1][c2]:=block[current]^[c1][c2];
    for c2:=0 to 19 do
     block[current]^[19][c2]:=temp[c2];
   end;
  if dir=3 then
   begin
    for c2:=0 to 19 do
     temp[c2]:=block[current]^[c2][19];
    for c1:=18 downto 0 do
    for c2:=0 to 19 do
     block[current]^[c2][c1+1]:=block[current]^[c2][c1];
    for c2:=0 to 19 do
     block[current]^[c2][0]:=temp[c2];
   end;
  if dir=4 then
   begin
    for c2:=0 to 19 do
     temp[c2]:=block[current]^[19][c2];
    for c1:=18 downto 0 do
    for c2:=0 to 19 do
     block[current]^[c1+1][c2]:=block[current]^[c1][c2];
    for c2:=0 to 19 do
     block[current]^[0][c2]:=temp[c2];
   end;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
  while keypressed do readkey;
 end;
Procedure zeron;
 begin
  asetrgbpalette(0,32,32,32);
 end;
Procedure zeroff;
 begin
  asetrgbpalette(0,0,0,0);
 end;
Procedure Add;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   if block[current]^[c2][c1]<>0 then
   block[current]^[c2][c1]:=block[current]^[c2][c1]+1;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure Dec;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   if block[current]^[c2][c1]<>0 then
   block[current]^[c2][c1]:=block[current]^[c2][c1]-1;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure Cycle;
 var
  c1:byte;
  r,g,b:array[0..9] of byte;
 begin
  hidemouse;
  while keypressed do readkey;
  repeat
  for c1:=0 to 9 do
   getrgbpalette(c1+179,r[c1],g[c1],b[c1]);
  for c1:=0 to 8 do
   asetrgbpalette(c1+180,r[c1],g[c1],b[c1]);
  asetrgbpalette(179,r[9],g[9],b[9]);
  delay(150);
  waitscreen;
  until keypressed;
  setuppal;
  showmouse;
  while keypressed do readkey;
 end;
Procedure Blue2Water;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   if (block[current]^[c2][c1]<94) and (block[current]^[c2][c1]>83) then
   block[current]^[c2][c1]:=block[current]^[c2][c1]+(179-84);
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure Edge(wich:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 3 do
   begin
    if wich= 1 then Block[current]^[c2][c1]:=thescreen^[213+c1+(103+c2)*320];
    if wich= 2 then Block[current]^[c2][c1]:=thescreen^[233+c1+(103+c2)*320];
    if wich= 3 then Block[current]^[c2][c1]:=thescreen^[253+c1+(103+c2)*320];
   end;
  for c1:=0 to 19 do
  for c2:=16 to 19 do
   begin
    if wich= 6 then Block[current]^[c2][c1]:=thescreen^[213+c1+(143+c2)*320];
    if wich= 7 then Block[current]^[c2][c1]:=thescreen^[233+c1+(143+c2)*320];
    if wich= 8 then Block[current]^[c2][c1]:=thescreen^[253+c1+(143+c2)*320];
   end;
  for c1:=0 to 3 do
  for c2:=0 to 19 do
   begin
    if wich= 1 then Block[current]^[c2][c1]:=thescreen^[213+c1+(103+c2)*320];
    if wich= 4 then Block[current]^[c2][c1]:=thescreen^[213+c1+(123+c2)*320];
    if wich= 6 then Block[current]^[c2][c1]:=thescreen^[213+c1+(143+c2)*320];
   end;
  for c1:=16 to 19 do
  for c2:=0 to 19 do
   begin
    if wich= 3 then Block[current]^[c2][c1]:=thescreen^[253+c1+(103+c2)*320];
    if wich= 5 then Block[current]^[c2][c1]:=thescreen^[253+c1+(123+c2)*320];
    if wich= 8 then Block[current]^[c2][c1]:=thescreen^[253+c1+(143+c2)*320];
   end;
 end;

Procedure GetSample(wich:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if wich= 1 then Block[current]^[c2][c1]:=thescreen^[213+c1+(103+c2)*320];
    if wich= 2 then Block[current]^[c2][c1]:=thescreen^[233+c1+(103+c2)*320];
    if wich= 3 then Block[current]^[c2][c1]:=thescreen^[253+c1+(103+c2)*320];
    if wich= 4 then Block[current]^[c2][c1]:=thescreen^[213+c1+(123+c2)*320];
    if wich= 5 then Block[current]^[c2][c1]:=thescreen^[253+c1+(123+c2)*320];
    if wich= 6 then Block[current]^[c2][c1]:=thescreen^[213+c1+(143+c2)*320];
    if wich= 7 then Block[current]^[c2][c1]:=thescreen^[233+c1+(143+c2)*320];
    if wich= 8 then Block[current]^[c2][c1]:=thescreen^[253+c1+(143+c2)*320];
   end;
 end;
Procedure PutSample(wich:byte);
 var
  c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if wich= 1 then putpixel(213+c1,103+c2,Block[current]^[c2][c1]);
    if wich= 2 then putpixel(233+c1,103+c2,Block[current]^[c2][c1]);
    if wich= 3 then putpixel(253+c1,103+c2,Block[current]^[c2][c1]);
    if wich= 4 then putpixel(213+c1,123+c2,Block[current]^[c2][c1]);
    if wich= 5 then putpixel(253+c1,123+c2,Block[current]^[c2][c1]);
    if wich= 6 then putpixel(213+c1,143+c2,Block[current]^[c2][c1]);
    if wich= 7 then putpixel(233+c1,143+c2,Block[current]^[c2][c1]);
    if wich= 8 then putpixel(253+c1,143+c2,Block[current]^[c2][c1]);
   end;
 end;

Procedure Part;
 var
  temp:byte;
  c1,c2:byte;
 begin

     if mousein(0,0,396,199) then
       begin
         if mousein(0,0,18,8) then
          temp:=Block[current]^[0,0];

        for c2:=1 to 19 do
         if mousein(0,c2*10-1,16,c2*10+8) then
          temp:=Block[current]^[c2,0];

        for c1:=1 to 19 do
         if mousein(c1*20-2,0,c1*20+16,8) then
          temp:=Block[current]^[0,c1];

        for c1:=1 to 19 do
        for c2:=1 to 19 do
         if mousein(c1*20-2,c2*10-1,c1*20+16,c2*10+9-1) then
          temp:=Block[current]^[c2,c1];

  for c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    if Block[current]^[c2][c1]=temp then Block[current]^[c2][c1]:=curcol;
   end;
  AllFatBits;


       end;


 end;
Procedure MixDown;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 9 do
  for c2:=0 to 9 do
   begin
   Block[current]^[c2*2][c1*2]:=Block[current]^[c2*2][c1*2]-1;
   Block[current]^[c2*2+1][c1*2+1]:=Block[current]^[c2*2+1][c1*2+1]-1;
   end;
  AllFatBits;
 end;
Procedure MixUp;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 9 do
  for c2:=0 to 9 do
   begin
   Block[current]^[c2*2][c1*2]:=Block[current]^[c2*2][c1*2]+1;
   Block[current]^[c2*2+1][c1*2+1]:=Block[current]^[c2*2+1][c1*2+1]+1;
   end;
  AllFatBits;
 end;
Procedure Mix;
 var
  c1,c2:byte;
 begin
  for c1:=0 to 9 do
  for c2:=0 to 9 do
   begin
   Block[current]^[c2*2][c1*2]:=curcol;
   Block[current]^[c2*2+1][c1*2+1]:=curcol;
   end;
  AllFatBits;
 end;
Procedure FillAll;
 begin
  SetAllBits(CurCol);
  AllFatBits;
 end;
Procedure PrePaint;
 var
  c1,c2,c3:integer;
 begin
  for c1:=0 to 255 do
   asetrgbpalette(c1,0,0,0);
  for c1:=1 to 5 do
   asetrgbpalette(c1+240,60-(c1*5+25),5,5);
  for c1:=1 to 5 do
   asetrgbpalette(c1+245,40-(c1*6+5),50-(c1*8+5),60-(c1*10+5));
  for c1:=1 to 5 do
   asetrgbpalette(c1+250,c1*10+5,c1*5+5,c1+5);
  for c1:=0 to 319 do
  for c2:=0 to 199 do
   putpixel(c1,c2,253);
  Box3DUp(200,0,319,199);
  For c1:=0 to 19 do
  for c2:=0 to 19 do
   begin
    Box3dUp(c1*10,c2*10,c1*10+9,c2*10+9)
   end;
    Box3dDown(202,2,223,23);
  AllFatBits;
  Box3DUp(204,174,236,184);
  Box3DUp(244,174,276,184);
  Box3DUp(285,174,317,184);

  Box3DUp(285,187,317,197);


  Box3DUp(205,50,214,70);
  Box3DUp(220,50,240,59);
  Box3DUp(230,62,240,70);
  for c1:=1 to 10 do
   begin
    putpixel(209,54+c1,252);
    putpixel(210,55+c1,254);
    putpixel(224+c1,54,252);
    putpixel(225+c1,55,254);
   end;

  OutTextXYNorm1(286,188,246,'EXIT');
  OutTextXYNorm1(205,175,246,'Load');
  OutTextXYNorm1(245,175,246,'Save');
  OutTextXYNorm1(286,175,246,'Fill');
  Box3DUp(295,1,318,11);
  Box3DDown(296,2,317,10);
  colorbar;
  setuppal;
  layoutcolors;
  PutName;
  for c1:=1 to 8 do
  putsample(c1);
  box3ddown(229,13,253,23);
  putnum;
  pushscreen;
 end;

Procedure RePaint;
 begin
 end;
Procedure StartUp;
 var
  file_found:boolean;
  c1:byte;
  temp:string;
 begin
  new(bkup);
  capname:=('blank');
  current:=1;
  ClrScr;
  loadfont1;
  textcolor(lightred);
  Writeln('Font loaded');
  textcolor(cyan);
  for c1:=0 to 255 do
  New(Block[c1]);
  for current:=255 downto 0 do
  SetAllBits(0);
  Writeln('Pointers set up');
  if paramstr(1)=('') then
  filename:=('Default')
  else
   begin
    temp:=paramstr(1);
    for c1:=1 to length(temp) do
     temp[c1]:=upcase(temp[c1]);
    c1:=length(temp);
    while (temp[c1]<>'\') and (c1<>0) do c1:=c1-1;
    temp:=copy(temp,c1+1,length(temp));
    if copy(temp,length(temp)-3,length(temp))='.SET'
    then temp:=copy(temp,0,length(temp)-4);
    filename:=copy(temp,length(temp)-7,length(temp));{
    filename:=copy(paramstr(1),1,8);
    writeln(filename);writeln(temp);                              }
   end;
  for c1:=8 downto length(filename) do
   begin
    if (ord(filename[c1])<48) or (ord(filename[c1])>90) then
    filename:=copy(filename,1,c1)
   end;
  textcolor(green);
  Write('Current file name-');
  textcolor(lightgreen);
  Writeln(Filename);
  Load(File_Found);
  textcolor(Blue);
  if File_Found then writeln('File found') else
  writeln('File not found, creating new.');
  readkey;
  setvideomode($13);
 end;
Procedure SaveReport(OK:boolean);
 var
  c1,c2:integer;
 begin
  Box3dDown(201,186,284,198);
  if ok then
   begin
    for c1:=202 to 283 do
    for c2:=187 to 197 do
     putpixel(c1,c2,253);
    OuttextXynorm1(203,188,246,'File Saved');
   end
  else
   begin
    for c1:=202 to 283 do
    for c2:=187 to 197 do
     putpixel(c1,c2,255);
    OuttextXynorm1(203,188,241,'  Error');
   end;
    Hidemouse;
   Pushscreen;
   Showmouse;
   repeat until keypressed or buttonpressed(1);
   while keypressed do readkey;
    for c1:=201 to 284 do
    for c2:=186 to 198 do
     putpixel(c1,c2,253);
    Hidemouse;
    Pushscreen;
    ShowMouse;
 end;
Procedure LoadReport(OK:boolean);
 var
  c1,c2:integer;
 begin
  Box3dDown(201,186,284,198);
  if ok then
   begin
    for c1:=202 to 283 do
    for c2:=187 to 197 do
     putpixel(c1,c2,253);
    OuttextXynorm1(203,188,246,'  Loaded');
    allfatbits;
   end
  else
   begin
    for c1:=202 to 283 do
    for c2:=187 to 197 do
     putpixel(c1,c2,255);
    OuttextXynorm1(203,188,241,'Not  Found');
   end;
    Hidemouse;
   Pushscreen;
   Showmouse;
   repeat until keypressed or buttonpressed(1);
   while keypressed do readkey;
    for c1:=201 to 284 do
    for c2:=186 to 198 do
     putpixel(c1,c2,253);
    Hidemouse;
    Pushscreen;
    ShowMouse;
 end;
Procedure turn;
 var
  temp:BKL;
   c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   temp[c1][19-c2]:=block[current]^[c2][c1];
  Block[current]^:=temp;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure flip2;
 var
  temp:BKL;
   c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   temp[c2][c1]:=block[current]^[c2][19-c1];
  Block[current]^:=temp;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure flip1;
 var
  temp:BKL;
   c1,c2:byte;
 begin
  for c1:=0 to 19 do
  for c2:=0 to 19 do
   temp[c2][c1]:=block[current]^[19-c2][c1];
  Block[current]^:=temp;
  allfatbits;
  hidemouse;
  pushscreen;
  showmouse;
 end;
Procedure CloseDown;
 var
  c1:byte;
 begin
  setvideomode($3);
  killfont1;
  TextColor(cyan);
  writeln('Font disposed of.');
  dispose(bkup);
  for c1:=0 to 255 do
  dispose(Block[c1]);
  TextColor(lightmagenta);
  writeln('Pointer disposed of.');
 end; {
Procedure mouseit;
 var
  c1,c2:byte;
  temp:String;
 begin
  for c1:=0 to 70 do
  for c2:=0 to 10 do
   putpixel(210+c1,c2+10,0);
  str(mousex,temp);
  outtextxynorm1(211,11,246,temp);
  str(mouseY,temp);
  outtextxynorm1(241,11,246,temp);
  mouse_cursor(false);
  pushscreen;
  mouse_cursor(true);
  putpixel(mousex div 2,mousey,15);
 end;  }
Procedure MainLoop;
 var
  done,zeroed:boolean;
  d:char;
  c1,c2:byte;
  fileok:boolean;
 begin
  curcol:=0;
  PrePaint;
  showmouse;
  setlimits(1,634,1,198);
  done:=false;
  repeat
   d:=(' ');
   if keypressed then
    begin
     zeroed:=false;
     d:=readkey;
     if d=#0 then
      begin
       zeroed:=true;
       d:=readkey;
      end;
    end;

    if buttonpressed(1) then
     begin
      if mousein(229*2,61,239*2,69) then
       begin
        hidemouse;
        pressed(230,62,240,70);
        showmouse;
        repeat
        until not(buttonpressed(1)) or not(mousein(229*2,61,239*2,69));
        if mousein(229*2,61,239*2,69) then
         begin
          turn;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(219*2,49,239*2,58) then
       begin
        hidemouse;
        pressed(220,50,240,59);
        showmouse;
        repeat
        until not(buttonpressed(1)) or not(mousein(219*2,49,239*2,58));
        if mousein(219*2,49,239*2,58) then
         begin
          flip2;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(204*2,49,213*2,69) then
       begin
        hidemouse;
        pressed(205,50,214,70);
        showmouse;
        repeat
        until not(buttonpressed(1)) or not(mousein(204*2,49,213*2,69));
        if mousein(204*2,49,213*2,69) then
         begin
          flip1;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,102,231*2,121) then
       begin
        putsample(1);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,102,251*2,121) then
       begin
        putsample(2);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,102,271*2,121) then
       begin
        putsample(3);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,122,231*2,141) then
       begin
        putsample(4);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,122,271*2,141) then
       begin
        putsample(5);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,142,231*2,161) then
       begin
        putsample(6);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,142,251*2,161) then
       begin
        putsample(7);
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,142,271*2,161) then
       begin
        putsample(8);
        hidemouse;
        pushscreen;
        showmouse;
       end;

      if mousein(269*2,19,279*2,29) then
       begin
           if curcol<>0 then
            begin
             curcol:=0;
             hidemouse;
             colorbar;
             pushscreen;
             showmouse;
            end;
       end;
      if mousein(285*2,19,314*2,168) then
       begin
        for c1:=0 to 4 do
        for c2:=0 to 24 do
         if mousein((285+c1*6)*2,19+c2*6,(285+c1*6+5)*2,19+c2*6+5) then
          begin
           if curcol<>c1+c2*5+64 then
            begin
             curcol:=c1+c2*5+64;
             hidemouse;
             colorbar;
             pushscreen;
             showmouse;
            end;
          end;

       end;
      if mousein(0,0,396,199) then
       begin
         if mousein(0,0,18,8) then
          Putcolor(0,0);

        for c2:=1 to 19 do
         if mousein(0,c2*10-1,16,c2*10+8) then
          Putcolor(0,c2);

        for c1:=1 to 19 do
         if mousein(c1*20-2,0,c1*20+16,8) then
          Putcolor(c1,0);

        for c1:=1 to 19 do
        for c2:=1 to 19 do
         if mousein(c1*20-2,c2*10-1,c1*20+16,c2*10+9-1) then
          Putcolor(c1,c2);
       end;

      if mousein(224*2,0,293*2,10) then
       begin
        hidemouse;
        pressed(225,1,294,11);
        showmouse;
        repeat until not(mousein(224*2,0,293*2,10)) or not(buttonpressed(1));
        if mousein(224*2,0,293*2,10) then
         begin
          getname;
         end else
         begin
          hidemouse;
          pushscreen;
          showmouse;
         end;
       end;

      if mousein(203*2,173,235*2,183) then
       begin
        hidemouse;
        pressed(204,174,236,184);
        showmouse;
        repeat until not(mousein(203*2,173,235*2,183)) or not(buttonpressed(1));
        if mousein(203*2,173,235*2,183) then
         begin
          if RUSure('LOAD') then
           begin
            Load(FileOk);
            LoadReport(FileOk);
           end;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(243*2,173,275*2,183) then
       begin
        hidemouse;
        pressed(244,174,276,184);
        showmouse;
        repeat until not(mousein(243*2,173,275*2,183)) or not(buttonpressed(1));
        if mousein(243*2,173,275*2,183) then
         begin
          if RUSure('SAVE') then
           begin
            SAVE(FileOk);
            SAVEReport(FileOk);
           end;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(284*2,173,316*2,183) then
       begin
        hidemouse;
        pressed(285,174,317,184);
        showmouse;
        repeat until not(mousein(284*2,173,316*2,183)) or not(buttonpressed(1));
        if mousein(284*2,173,316*2,183) then
         begin
          dobk;
          if RUSURE('FILL') then FillAll;
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;

      if mousein(284*2,186,316*2,196) then
       begin
        hidemouse;
        pressed(285,187,317,197);
        showmouse;
        repeat until not(mousein(284*2,186,316*2,196)) or not(buttonpressed(1));
        if mousein(284*2,186,316*2,196) then
         begin
          if RUSure('Save') then
          save(FileOk);
          done:=RUSure('EXIT');
         end;
        hidemouse;
        pushscreen;
        showmouse;
       end;
     end;
   if d=#27 then done:=true;
   if upcase(d)=('G') then
    begin
    dobk;
      if mousein(0,0,396,199) then
       begin
         if mousein(0,0,18,8) then
          curcol:=block[current]^[0][0];
        for c2:=1 to 19 do
         if mousein(0,c2*10-1,16,c2*10+8) then
          curcol:=block[current]^[c2][0];
        for c1:=1 to 19 do
         if mousein(c1*20-2,0,c1*20+16,8) then
          curcol:=block[current]^[0][c1];
        for c1:=1 to 19 do
        for c2:=1 to 19 do
         if mousein(c1*20-2,c2*10-1,c1*20+16,c2*10+9-1) then
          curcol:=block[current]^[c2][c1];
         colorbar;
         hidemouse;
         pushscreen;
         showmouse;
       end;

      if mousein(212*2,102,231*2,121) then
       begin
        IF RUSure(' GET') then getsample(1);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,102,251*2,121) then
       begin
        IF RUSure(' GET') then getsample(2);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,102,271*2,121) then
       begin
        IF RUSure(' GET') then getsample(3);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,122,231*2,141) then
       begin
        IF RUSure(' GET') then getsample(4);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,122,271*2,141) then
       begin
        IF RUSure(' GET') then getsample(5);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,142,231*2,161) then
       begin
        IF RUSure(' GET') then getsample(6);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,142,251*2,161) then
       begin
        IF RUSure(' GET') then getsample(7);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,142,271*2,161) then
       begin
        IF RUSure(' GET') then getsample(8);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;


    end;
   If upcase(d)=('R') then
    begin
      dobk;
      if mousein(212*2,102,231*2,121) then
       begin
        IF RUSure('REVT') then REVT(1);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,102,251*2,121) then
       begin
        IF RUSure('REVT') then REVT(2);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,102,271*2,121) then
       begin
        IF RUSure('REVT') then REVT(3);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,122,231*2,141) then
       begin
        IF RUSure('REVT') then REVT(4);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,122,271*2,141) then
       begin
        IF RUSure('REVT') then REVT(5);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,142,231*2,161) then
       begin
        IF RUSure('REVT') then REVT(6);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,142,251*2,161) then
       begin
        IF RUSure('REVT') then REVT(7);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,142,271*2,161) then
       begin
        IF RUSure('REVT') then REVT(8);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
    end;
   If upcase(d)=('T') then
    begin
          dobk;
      if mousein(212*2,102,231*2,121) then
       begin
        IF RUSure('TRAN') then trans(1);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,102,251*2,121) then
       begin
        IF RUSure('TRAN') then trans(2);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,102,271*2,121) then
       begin
        IF RUSure('TRAN') then trans(3);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,122,231*2,141) then
       begin
        IF RUSure('TRAN') then trans(4);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,122,271*2,141) then
       begin
        IF RUSure('TRAN') then trans(5);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,142,231*2,161) then
       begin
        IF RUSure('TRAN') then trans(6);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,142,251*2,161) then
       begin
        IF RUSure('TRAN') then trans(7);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,142,271*2,161) then
       begin
        IF RUSure('TRAN') then trans(8);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
    end;
   If upcase(d)=('E') then
    begin
          dobk;
      if mousein(212*2,102,231*2,121) then
       begin
        IF RUSure('EDGE') then edge(1);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,102,251*2,121) then
       begin
        IF RUSure('EDGE') then edge(2);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,102,271*2,121) then
       begin
        IF RUSure('EDGE') then edge(3);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,122,231*2,141) then
       begin
        IF RUSure('EDGE') then edge(4);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,122,271*2,141) then
       begin
        IF RUSure('EDGE') then edge(5);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(212*2,142,231*2,161) then
       begin
        IF RUSure('EDGE') then edge(6);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(232*2,142,251*2,161) then
       begin
        IF RUSure('EDGE') then edge(7);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
      if mousein(252*2,142,271*2,161) then
       begin
        IF RUSure('EDGE') then edge(8);
        allfatbits;
        hidemouse;
        pushscreen;
        showmouse;
       end;
    end;
   if upcase(d)=('Z') then
    begin
      while keypressed do readkey;
      repeat
      MoveAni;
      delay(300);
      waitscreen;
      until keypressed;
      while keypressed do readkey;
    end;
   if upcase(d)=('F') then
    begin
          dobk;
     if RUSURE('FILL') then FillAll;
        hidemouse;
        pushscreen;
        showmouse;
    end;
   if upcase(d)=('M') then
    begin
          dobk;
     if RUSURE(' Mix') then Mix;
        hidemouse;
        pushscreen;
        showmouse;
    end;
   if upcase(d)=('U') then
    begin
        MixUp;
        hidemouse;
        pushscreen;
        showmouse;
    end;
   if upcase(d)=('D') then
    begin
        MixDown;
        hidemouse;
        pushscreen;
        showmouse;
    end;
   if upcase(d)=('S') then
    begin
      if RUSure('SAVE') then
       begin
        SAVE(FileOk);
        SAVEReport(FileOk);
       end;
    end;
   if upcase(d)=('X') then
    begin
     if RUSure('Save') then save(FileOk);
     done:=RUSure('EXIT');
    end;
   if upcase(d)=('K') then
    begin
     Katch;
    end;
   if zeroed and (d=#59) then
    begin
          dobk;
     Blend1;
    end;
   if zeroed and (d=#60) then
    begin
     dobk;
     Blend2;
    end;
   if zeroed and (d=#63) then
    begin
        Part;
        hidemouse;
        pushscreen;
        showmouse;
    end;
  if not(zeroed) and (d=#8) then
    begin
        SwapBk;
        hidemouse;
        pushscreen;
        showmouse;
    end;

   if upcase(d)=('W') then
    begin
     if RUSure('B2W') then
     Blue2Water;
    end;
   if upcase(d)=('C') then
    begin
     Capture;
    end;
   if (d)=('~') then
    begin
     Cycle;
    end;
   if not(zeroed) and (upcase(d)=('>')) then
    begin
     zeron;
    end;
   if not(zeroed) and (upcase(d)=('<')) then
    begin
     zeroff;
    end;

   if UpCase(d)=('4') then move(1);
   if UpCase(d)=('8') then move(2);
   if UpCase(d)=('6') then move(3);
   if UpCase(d)=('2') then move(4);
   if UpCase(d)=('{') then add;
   if UpCase(d)=('}') then dec;
   if upcase(d)=('L') then
    begin
     if RUSure('LOAD') then
      begin
       Load(FileOk);
       LoadReport(FileOk);
      end;
    end;
   if (d)=('+') then
    begin
     current:=current+1;
     allfatbits;
     putnum;
     hidemouse;
     pushscreen;
     showmouse;
    end;
   if (d)=('=') then
    begin
     showalltiles;
    end;
   if (d)=('-') then
    begin
     current:=current-1;
     allfatbits;
     putnum;
     hidemouse;
     pushscreen;
     showmouse;
    end;
   if zeroed and ((d)=#73) then
    begin
     current:=current+10;
     allfatbits;
     putnum;
     hidemouse;
     pushscreen;
     showmouse;
    end;
   if zeroed and ((d)=#81) then
    begin
     current:=current-10;
     allfatbits;
     putnum;
     hidemouse;
     pushscreen;
     showmouse;
    end;                        {
   while keypressed do readkey;  }
  until done;
 end;
begin
 StartUp;
 MainLoop;
 CloseDown;
end.